/********************************** (C) COPYRIGHT *******************************
* File Name          : ADC_Manual.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH56X ADC_INT Demo  
*                      (1)0Ϣ,115200bps;
*                      (2)ʵADC.AD̲DMA,Ĭѡͨ2ADCת.
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"

/******************************************************************************/
/*  */
UINT16 ADC_buf[1024]; 

/* һLEDڼʾĽ,͵ƽLED */
#define LED                     1<<3

#define LED_OUT_INIT(  )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }          /* LED ߵƽΪ */
#define LED_OUT_ACT(  )      { R32_PB_CLR |= LED; }                             /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT(  )    { R32_PB_OUT |= LED; }                             /* LED ߵƽرLEDʾ */

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void IRQ_Handler( void )   
{
   if( R8_INT_FLAG_1 & RB_IF_ADC ){                                             /* ADCж */
        if( R8_ADC_INT_FLAG & RB_ADC_IF_ADC_END ){                              /* ADCж */
            R8_ADC_INT_FLAG = 0xff;                                             /* ж */ 
            PRINT( "sample=%-8x ",R16_ADC_DATA );
        }
    }
	/* Ҫʹ򣬲ֹ */
#if 0                  
    R8_ADC_CTRL_DMA |= RB_ADC_MAN_SAMPLE;
    Delay_us(1);  
    R8_ADC_CTRL_DMA &= ~RB_ADC_MAN_SAMPLE;
    R8_ADC_CTRL_DMA &= ~RB_ADC_CHAN_OE;                                         /* ֹADCͨADCSλ */
#endif
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : ADC_INIT
* Description    : ADCʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
/* ҪADCáADCжԼDMA,жжÿ*/
/* ȥ,DMAԶȡR16_ADC_DATAĴ,ADCɼڴ˼Ĵ    */

void ADC_INIT( void )
{
    R8_ADC_CTRL_MOD = 0;
    R8_ADC_CTRL_MOD |= RB_ADC_POWER_ON;                                         /* ADCʹ */
    R8_ADC_CLOCK_DIV = 0x40;                                                    /* ADCʱź */
    R8_ADC_CTRL_MOD |= RB_ADC_SAMPLE_WID;                                       /* Լֶ */
    R8_ADC_CTRL_MOD |= 0x20;                                                    /* ѡͨ2 */    
    Delay_us(100);  

    R8_ADC_CTRL_DMA |= RB_ADC_MAN_SAMPLE;
    Delay_us(1);  
    R8_ADC_CTRL_DMA &= ~RB_ADC_MAN_SAMPLE;
    R8_ADC_CTRL_DMA &= ~RB_ADC_CHAN_OE;                                         /* ֹADCͨADCSλ */

    /*Ϊж*/
    R8_ADC_INT_FLAG = 0xff;                                                     /* жϱ־ */
    R8_INT_EN_IRQ_1 |= RB_IE_IRQ_ADC;                                           /* ADCж */
    R8_ADC_INTER_EN |= RB_ADC_IE_ADC_END;										/* ADCж */
    
    R8_ADC_INT_FLAG = 0xff;                                                     /* жϱ־ */
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                       /* ȫж */

}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void ) 
{
    LED_OUT_INIT( );
    LED_OUT_ACT( );                                                             /* LEDһʾ */ 
    Delay_ms( 100 );
    LED_OUT_INACT( );
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */ 
    LED_OUT_ACT( );
    LED_OUT_INACT( );
    PRINT( "ADC Demo....." );
    ADC_INIT(  );
    while(1);                                                                   /* ȴADCDMA */
}

/*********************************** endfile **********************************/
