/********************************** (C) COPYRIGHT *******************************
* File Name          : GPIO_INT.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH56X GPIO_INT DEMO
*                      (1)CH56X Examples by KEIL;
*                      (2)0Ϣ,115200bps;
*                      (3)ҪGPIOΪⲿжϵãжϷӳжȡж״̬жϱ־.
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"

/* һLEDڼʾĽ,͵ƽLED */
#define LED                  1<<3

#define LED_OUT_INIT(  )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }          /* LED ߵƽΪ */
#define LED_OUT_ACT(  )      { R32_PB_CLR |= LED; }                             /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT(  )    { R32_PB_OUT |= LED; }                             /* LED ߵƽرLEDʾ */

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void IRQ_Handler( void )
{
    PRINT("R32_INT_FLAG=%8lx\n",R32_INT_FLAG);
    if((R32_INT_FLAG>>8) & RB_IF_PB){                                           /* PBж */
        PRINT("%8lX \n", R32_INT_STATUS_PB&0x000000ff );                        /* 鿴жϱ־ */
        R32_INT_STATUS_PB = 0xfffff;                                            /* жϱ־д1 */
    }
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : IRQ_InitPB
* Description    : жóʼ 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void IRQ_InitPB( void )
{
    R32_PB_PU  |= 0x000000ff;                                                   /* GPIO Bã1ʾ */ 
    R32_PB_DIR &= ~0x000000ff;                                                  /* GPIO BΪ , direction: 0=in, 1=out */

    R32_INT_ENABLE_PB |= 0x000000ff;                                            /* GPIO Bλжʹ  1-ʹܣ0-ֹ */
    R32_INT_MODE_PB   |= 0x000000ff;                                            /* GPIO BжϷʽ 1-ж,0-ƽж */      
    R32_INT_POLAR_PB  &= ~0x000000ff;                                           /* GPIO Bжϼ 1-ж/ߵƽ0-½ж/͵ƽ */      
    
    R32_INT_STATUS_PB  = 0xfffff;                                               /* жϱ־д1 */
    R8_INT_EN_IRQ_1   |= RB_IE_IRQ_PB;                                          /* GPIO Bжʹ */ 
    R8_INT_EN_IRQ_GLOB|= RB_IE_IRQ_GLOB;                                        /* ȫжʹ */     
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void ) 
{ 
    LED_OUT_INIT( );
    LED_OUT_ACT( );                                                             /* LEDһʾ */
    Delay_ms( 100 );
    LED_OUT_INACT( );
    mInitSTDIO( );                                                              /* 0ʼ */
    PRINT("GPIO INT DEMO.....\n");
    IRQ_InitPB( );                                                              /* жóʼ */
    while(1);
}

/*********************************** endfile **********************************/
