/********************************** (C) COPYRIGHT ******************************
* File Name          : Main.C
* Author             : WCH 
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563 TCP/IP Эӿ
*                    : MDK3.36@ARM966E-S,Thumb,С
*******************************************************************************/



/******************************************************************************/
/* ͷļ*/
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"
#include "FTPINC.H"
#include "CH563NET.H"
#include "ISPXT56X.H"

#define CH563NET_DBG                          1

/* ĻȫֱҪ壬е */
__align(16)UINT8    CH563MACRxDesBuf[(RX_QUEUE_ENTRIES )*16];                   /* MAC16ֽڶ */
__align(4) UINT8    CH563MACRxBuf[RX_QUEUE_ENTRIES*RX_BUF_SIZE];                /* MACջ4ֽڶ */
__align(4) SOCK_INF SocketInf[CH563NET_MAX_SOCKET_NUM];                         /* SocketϢ4ֽڶ */
const UINT16 MemNum[8] = {CH563NET_NUM_IPRAW,
                         CH563NET_NUM_UDP,
                         CH563NET_NUM_TCP,
                         CH563NET_NUM_TCP_LISTEN,
                         CH563NET_NUM_TCP_SEG,
                         CH563NET_NUM_IP_REASSDATA,
                         CH563NET_NUM_PBUF,
                         CH563NET_NUM_POOL_BUF
                         };
const UINT16 MemSize[8] = {CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IPRAW_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_UDP_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB_LISTEN),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_SEG),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IP_REASSDATA),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(0),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_POOL_BUF)
                         };
__align(4)UINT8 Memp_Memory[CH563NET_MEMP_SIZE];
__align(4)UINT8 Mem_Heap_Memory[CH563NET_RAM_HEAP_SIZE];
__align(4)UINT8 Mem_ArpTable[CH563NET_RAM_ARP_TABLE_SIZE];

#define CH563NET_TIMEPERIOD                   10                                /* ʱʱڣλmS*/

/******************************************************************************/
/* ʾغ */
#define RECE_BUF_LEN                          536                               /* ջĴС */
#define READ_RECV_BUF_MODE                    0                                 /* socketջȡģʽ1ƣ0 */
#define CH563NET_DBG                          0                                 /* printfʹ */

UINT8 SocketRecvBuf[CH563NET_MAX_SOCKET_NUM][RECE_BUF_LEN];                     /* socketջ */
/* CH563ض */                                                                   
UINT8 MACAddr[6]  = {0x02,0x03,0x04,0x05,0x06,0x07};                            /* CH563MACַ */ 
const UINT8 IPAddr[4]   = {192,168,1,10};                                       /* CH563IPַ */ 
const UINT8 GWIPAddr[4] = {192,168,1,1};                                        /* CH563 */ 
const UINT8 IPMask[4]   = {255,255,255,0};                                      /* CH563 */ 
const UINT8 DestIP[4]   = {192,168,1,100};                                      /* ĿIP */ 
const UINT8 *pUserName  = "anonymous";                                          /* ½ */
const UINT8 *pPassword  = "123@";                                               /* e-mail Ϊ½ */
char  ListName[24];                                                             /* ڱĿ¼ */
char  ListMkd[24];                                                              /* ڱ´Ŀ¼ */
char  FileName[24];                                                             /* ڱļ */
char  CharIP[17];                                                               /* ڱתַIPַ */

UINT8 SocketId;                                                                 /* socketԲö */
UINT8 gPort;                                                                    /* ڸı˿ֵ */
/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    if(R32_INT_FLAG & 0x8000)                                                   /* ̫ж */
    {                                                                           /* ̫жжϷ */
        CH563NET_ETHIsr();
    }
    if(R32_INT_FLAG & RB_IF_TMR0)                                               /* ʱж */
    {
         CH563NET_TimeIsr(CH563NET_TIMEPERIOD);                                 /* CH563NET_ ʱжϷ */
         R8_TMR0_INT_FLAG |= 0xff;                                              /* ʱжϱ־ */
   }
}

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : SysTimeInit
* Description    : ϵͳʱʼCH563@100MHZ TIME0 10msCH563NET_TIMEPERIOD
*                ʼʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SysTimeInit(void)
{
    R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
    R32_TMR0_COUNT = 0x00000000; 
    R32_TMR0_CNT_END = 0x186a0 * CH563NET_TIMEPERIOD;                           /* Ϊ10MSʱ */
    R8_TMR0_INTER_EN |= RB_TMR_IE_CYC_END;
    R8_TMR0_CTRL_MOD = RB_TMR_COUNT_EN;
}

/*******************************************************************************
* Function Name  : InitSysHal
* Description    : ӲʼTIM0ETHж
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitSysHal(void)
{
    R8_INT_EN_IRQ_0 |= RB_IE_IRQ_TMR0;                                          /* TIM0ж */
    R8_INT_EN_IRQ_1 |= RB_IE_IRQ_ETH;                                           /* ETHж */
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                       /* IRQȫж */
}

/*******************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CH563NET_ERR_SUCCESS) return;                                 /* ɹ */
#if DEBUG
    printf("Error: %02X\n", (UINT16)iError);                                    /* ʾ */
#endif    
}

/*******************************************************************************
* Function Name  : CH563NET_LibInit
* Description    : ʼ
* Input          : ip      ipַָ
*                gwip    ipַָ
*                : mask    ָ
*                : macaddr MACַFָ 
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH563NET_LibInit(const UINT8 *ip,const UINT8 *gwip,const UINT8 *mask,const UINT8 *macaddr)
{
    UINT8 i;
    struct _CH563_CFG cfg;
    if(CH563NET_GetVer() != CH563NET_LIB_VER)return 0xfc;                       /* ȡİ汾ţǷͷļһ */
    CH563NETConfig = LIB_CFG_VALUE;                                             /* Ϣݸñ */
    cfg.RxBufSize = RX_BUF_SIZE; 
    cfg.TCPMss   = CH563NET_TCP_MSS;
    cfg.HeapSize = CH563_MEM_HEAP_SIZE;
    cfg.ARPTableNum = CH563NET_NUM_ARP_TABLE;
    cfg.MiscConfig0 = CH563NET_MISC_CONFIG0;
    CH563NET_ConfigLIB(&cfg);
    i = CH563NET_Init(ip,gwip,mask,macaddr);
    #if DEBUG                                                         
    printf("CH563NET_Config: %x\n",CH563NETConfig);                           
    #endif        
    return (i);                                                                 /* ʼ */

}

/*******************************************************************************
* Function Name  : CH563NET_HandleSokcetInt
* Description    : socketжϴ
* Input          : sockeid  socket
*                initstat ж״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_HandleSokcetInt(UINT8 sockeid,UINT8 initstat)
{
    UINT32 len;

#if  DEBUG
        printf("sockeid##= %02x\n",(UINT16)sockeid);
#endif
    if(initstat & SINT_STAT_RECV)                                               /* ж */
    {
        len = CH563NET_SocketRecvLen(sockeid,NULL);                             /* ѯ */
        if(len){

        ftp.RecDatLen = len; 
        CH563NET_SocketRecv(sockeid,SocketRecvBuf[sockeid],&len);               /* ջݶMyBuf*/
#if  DEBUG
        printf("check type= %02x\n",(UINT16)ftp.FileCmd);
        printf("len= %08d\n",ftp.RecDatLen);
        printf("MyBuffer=\n\n%s\n\n",(char *)SocketRecvBuf[sockeid]);
#endif
        CH563NET_FTPProcessReceDat((char *)SocketRecvBuf[sockeid],ftp.FileCmd,sockeid);
        memset((void *)SocketRecvBuf[sockeid],'\0',sizeof(SocketRecvBuf[sockeid]));    
        
        }          
    }
    if(initstat & SINT_STAT_CONNECT)                                            /* TCPж */
    {
#if DEBUG                                                                       /* жϱʾTCPѾӣԽշ */
        printf("TCP Connect Success\n");                           
#endif
        ftp.TcpStatus = CH563NET_FTPGetSockeID( );
    }
    if(initstat & SINT_STAT_DISCONNECT)                                         /* TCPϿж */
    {
#if DEBUG                                                                       /* жϣCH563NET_ڲὫsocketΪر*/
        printf("TCP Disconnect\n");                                             /* Ӧ´ */
#endif
        if(sockeid == ftp.DatTransfer){
            ftp.TcpStatus = 0;
            ftp.CmdDataS = FTP_MACH_DATAOVER;
            if(ftp.DatMonitor != 255){
                CH563NET_SocketClose( ftp.DatMonitor,TCP_CLOSE_NORMAL );
            }
        }
        
    }
    if(initstat & SINT_STAT_TIM_OUT)                                            /* TCPʱж */
    {
#if DEBUG                                                                       /* жϣCH563NET_ڲὫsocketΪر*/
        printf("TCP Timout\n");                                                 /* Ӧ´ */
#endif
    }
}

/*******************************************************************************
* Function Name  : CH563NET_HandleGlobalInt
* Description    : ȫжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_HandleGlobalInt( void )
{
    UINT8 initstat;
    UINT8 i;
    UINT8 socketinit;
    
    initstat = CH563NET_GetGlobalInt();                                         /* ȫж״̬ */
    if(initstat & GINT_STAT_UNREACH)                                            /* ɴж */
    {
#if DEBUG
        printf("UnreachCode %d\n",CH563Inf.UnreachCode);                      /* 鿴ɴ */
        printf("UnreachProto %d\n",CH563Inf.UnreachProto);                    /* 鿴ɴЭ */
        printf("UnreachPort %d\n",CH563Inf.UnreachPort);                      /* ѯɴ˿ */
#endif       
    }
   if(initstat & GINT_STAT_IP_CONFLI)                                           /* IPͻж */
   {
#if DEBUG
       printf("IP interrupt\n");
#endif   
   }
   if(initstat & GINT_STAT_PHY_CHANGE)                                          /* PHYıж */
   {
       i = CH563NET_GetPHYStatus();                                             /* ȡPHY״̬ */
#if DEBUG
       printf("GINT_STAT_PHY_CHANGE %02x\n",i);
#endif   
   }
   if(initstat & GINT_STAT_SOCKET)                                              /* Socketж */
   {
       for(i = 0; i < CH563NET_MAX_SOCKET_NUM; i ++)                     
       {
           socketinit = CH563NET_GetSocketInt(i);                               /* socketжϲ */
           if(socketinit)CH563NET_HandleSokcetInt(i,socketinit);                /* ж */
       }    
   }
}

/*******************************************************************************
* Function Name  : CH563NET_FTPCtlClient
* Description    : TCP Client socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPCtlClient(void)
{
   UINT8 i;                                                             
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */

   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   memcpy((void *)TmpSocketInf.IPAddr,DestIP,4);                                /* ĿIPַ */
   TmpSocketInf.DesPort =  21;                                                  /* ĿĶ˿ */
   TmpSocketInf.SourPort = 4000;                                                /* Դ˿ */
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                     /* socekt */
   TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf[0];                      /* ýջĽջ */
   TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;                                     /* ýջĽճ */
   i = CH563NET_SocketCreat( &SocketId,&TmpSocketInf );                         /* socketصsocketSocketId */
   mStopIfError(i);                                                             /*  */
   ftp.SocketCtl = SocketId;    
#if DEBUG
    printf("SocketId TCP FTP = %02x\n",(UINT16)ftp.SocketCtl);
#endif
   i = CH563NET_SocketConnect(SocketId);                                        /* TCP */
   mStopIfError(i);                                                             /*  */
   memset((void *)SocketRecvBuf[SocketId],'\0',sizeof(SocketRecvBuf[SocketId]));              
}

/*******************************************************************************
* Function Name  : CH563NET_FTPDatClient
* Description    : TCP Client socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPDatClient( UINT16 *port)
{
   UINT8 i;                                                             
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */

   if(gPort > 200) gPort = 0;
   gPort++;
   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   memcpy((void *)TmpSocketInf.IPAddr,DestIP,4);                                /* ĿIPַ */
   TmpSocketInf.DesPort =  20;                                                  /* ĿĶ˿ */
   TmpSocketInf.SourPort = 4001;                                                /* Դ˿ */
//  TmpSocketInf.SourPort = 4000+gPort;                                         /* Դ˿ */
   *port = TmpSocketInf.SourPort; 
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                     /* socekt */
   TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf[1];                      /* ýջĽջ */
   TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;                                     /* ýջĽճ */
   i = CH563NET_SocketCreat( &SocketId,&TmpSocketInf );                         /* socketصsocketSocketId */
   mStopIfError(i);                                                             /*  */
#if DEBUG
    printf("SocketId FTP DATA = %02x\n",(UINT16)ftp.SocketCtl);
#endif    
   i = CH563NET_SocketConnect(SocketId);                                        /* TCP */
   mStopIfError(i);                                                             /*  */
}

/*******************************************************************************
* Function Name  : CH563NET_FTPDatServer
* Description    : TCP Server socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPDatServer( UINT16 *port )
{
   UINT8 i;
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */
 
   if(gPort > 200) gPort = 0;
   gPort++;
   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   TmpSocketInf.SourPort = 4000 + gPort;                                        /* Դ˿ */
   *port = TmpSocketInf.SourPort; 
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                     /* socekt */
   i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);                           /* socketصsocketSocketId */
   mStopIfError(i);                                                             /*  */
   ftp.DatMonitor = SocketId; 
   i = CH563NET_SocketListen(SocketId);                                         /* TCP */
#if DEBUG
   printf("SocketId dat server:%d\n",(UINT16)SocketId);
#endif    
   mStopIfError(i);                                                             /*  */
   memset((void *)SocketRecvBuf[SocketId],'\0',sizeof(SocketRecvBuf[SocketId]));              
}

/*******************************************************************************
* Function Name  : CH563NET_ftp_SendData
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPSendData( char *PSend, UINT32 Len,UINT8 index  )
{
    UINT32 length;
    UINT8 i,*p,count;

    p = (UINT8 *)PSend;
    length = Len;
    count = 0;
    while(1){
        Len = length;
        i = CH563NET_SocketSend(index,p,&Len);                                  /* MyBufеݷ */
        mStopIfError(i);                                                        /*  */
        if(Len == 0){
            count++;
            if(count>2){
#if DEBUG
    printf("Send Data  fail\n");
#endif    
                return;
            } 
        }
        length -= Len;                                                          /* ܳȼȥԼϵĳ */
        p += Len;                                                               /* ָƫ*/
        if(length)continue;                                                     /* δϣ*/
        break;                                                                  /* ϣ˳ */
    }
}

/*******************************************************************************
* Function Name  : CH563NET_FTPGetSockeID
* Description    : ȡsocketid
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 CH563NET_FTPGetSockeID(  )
{
    UINT8 i;

    for(i=0;i<CH563NET_MAX_SOCKET_NUM;i++){
        if(SocketInf[i].DesPort == 20){
            if(i != ftp.DatMonitor){
                ftp.DatTransfer = i;
                CH563NET_ModifyRecvBuf(i,(UINT32)SocketRecvBuf[i],RECE_BUF_LEN);  
                return TRUE;
            }
        }
    }
    return FALSE; 
}

/*******************************************************************************
* Function Name  : CH563NET__FTPInitVari
* Description    : ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET__FTPInitVari( )
{
    UINT8 i,j;
    FTP   *pFTP;

    pFTP = &ftp;
    memset((void *)pFTP,0,sizeof(FTP));                   
    ftp.SocketCtl = 255; 
    ftp.DatMonitor = 255;
    ftp.DatTransfer = 255;
    ftp.FileCmd = FTP_CMD_LOGIN;                                                /* ִе½ */
    memset((void *)CharIP,'\0',sizeof(CharIP));                   
    j = 0;
    for(i=0;i<4;i++){                                                           /* ʮƵIPַתҪַʽ */ 
        if( IPAddr[i]/100 ){
            CharIP[j++] = IPAddr[i]/100 + '0';
            CharIP[j++] = (IPAddr[i]%100)/10 + '0' ;
            CharIP[j++] = IPAddr[i]%10 + '0';
        } 
        else if( IPAddr[i]/10 ){
            CharIP[j++] = IPAddr[i]/10 + '0';
            CharIP[j++] = IPAddr[i]%10 + '0';
        } 
        else CharIP[j++] = IPAddr[i]%10 + '0';
         CharIP[j++] = ',';
    }
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD1 schmitt input, TXD1 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD1 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : CH563NET_FTPInit
* Description    : ch563ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_FTPInit( void ) 
{

    UINT8 i = 0;

    i = CH56X_GetMac(MACAddr);
    CH563NET__FTPInitVari( );                                                   /* ʼ */
    i = CH563NET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);                       /* ʼ */
    mStopIfError(i);                                                            /*  */
#if DEBUG
    printf("CH563NET_LibInit Success\n");
#endif    
    SysTimeInit( );                                                             /* ϵͳʱʼ */
    InitSysHal( );                                                              /* ʼж */
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void )
{
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */
    CH563NET_FTPInit( );                                                        /* ʼ */
    while(1)
    {
        CH563NET_MainTask( );                                                   /* CH563IPҪѭвϵ */
        if(CH563NET_QueryGlobalInt( ))CH563NET_HandleGlobalInt();               /* ѯжϣжϣȫжϴ */
        CH563NET_FTPClientCmd( );                                               /* ѯ״ִ̬ */
    }
}

/*********************************** endfile **********************************/
