/********************************** (C) COPYRIGHT *******************************
* File Name          : MAIL_POP3.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563 Mail DEMO
*                      (1)CH563 Examples by KEIL;
*                      (2)0Ϣ,115200bps;
*                      (3)ARM9-CH563ƬCԵĽʼʾ
*******************************************************************************/



/******************************************************************************/
/* ͷļ*/
#include <stdio.h>
#include <string.h>
#include "CH563BAS.H"
#include "CH563SFR.H"
#include "SYSFREQ.H"
#include "CH563NET.H"
#include "ISPXT56X.H"

#define CH563NET_DBG                          0

/* ĻȫֱҪ壬е */
__align(16)UINT8    CH563MACRxDesBuf[(RX_QUEUE_ENTRIES )*16];                   /* MAC16ֽڶ */
__align(4) UINT8    CH563MACRxBuf[RX_QUEUE_ENTRIES*RX_BUF_SIZE];                /* MACջ4ֽڶ */
__align(4) SOCK_INF SocketInf[CH563NET_MAX_SOCKET_NUM];                         /* SocketϢ4ֽڶ */
const UINT16 MemNum[8] = {CH563NET_NUM_IPRAW,
                         CH563NET_NUM_UDP,
                         CH563NET_NUM_TCP,
                         CH563NET_NUM_TCP_LISTEN,
                         CH563NET_NUM_TCP_SEG,
                         CH563NET_NUM_IP_REASSDATA,
                         CH563NET_NUM_PBUF,
                         CH563NET_NUM_POOL_BUF
                         };
const UINT16 MemSize[8] = {CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IPRAW_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_UDP_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB_LISTEN),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_SEG),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IP_REASSDATA),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(0),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_POOL_BUF)
                         };
__align(4)UINT8 Memp_Memory[CH563NET_MEMP_SIZE];
__align(4)UINT8 Mem_Heap_Memory[CH563NET_RAM_HEAP_SIZE];
__align(4)UINT8 Mem_ArpTable[CH563NET_RAM_ARP_TABLE_SIZE];

#include "POP3.H"


#define CH563NET_TIMEPERIOD                    50                               /* ʱʱڣλmS*/

/******************************************************************************/
/* ʾغ */
#define RECE_BUF_LEN                          536*3                             /* ջĴС */
/* CH563IPTCPMSSΪ536ֽڣһTCPݲΪ536ֽ */
/* TCPЭջûڽأֵΪsocketĽջȡ趨 */
/* RX_QUEUE_ENTRIESʱҪMSSʹ֮Ĺϵ細ֵΪ4*MSSԶһλᷢ */
/* 4TCPRX_QUEUE_ENTRIESС4ȻᵼݰʧӶͨѶЧʽ */
/* RX_QUEUE_ENTRIESҪ( /MSS ),socketͬʱдݣ */
/* RX_QUEUE_ENTRIESҪ(( /MSS )*socket) ڶsocketͬʱдշʱ */
/* Ϊ˽ԼRAM뽫ջĳΪMSS */
/******************************************************************************/
/* CH563ض */                                                                   
UINT8 MACAddr[6] = {0x02,0x03,0x04,0x05,0x06,0x07};                             /* CH563MACַ */ 
const UINT8 IPAddr[4] =  {192,168,1,10};                                        /* CH563IPַ */ 
const UINT8 GWIPAddr[4] ={192,168,1,1};                                         /* CH563 */ 
const UINT8 IPMask[4] =  {255,255,255,0};                                       /* CH563 */

/* socketpop3 ض, POPʼ*/
const UINT16 Pop3SourPrt = 4567;
const UINT8  Socketpop3IP[4] = {113,108,16,116};                                /* Socket pop3ĿIPַ */
//    {220,181,15,128}    "pop.126.com",
//    {220,181,12,101}    "pop.163.com",
//    {113,108,16,116}    "pop.qq.com",
//    {74,125,141,108}    "pop.gmail.com"

/* popʼ */
const char *p_Server =    "pop.qq.com";                                         /* POP */
const char *p_UserName =  "XXX";                                                /* POP½û */
const char *p_PassWord =  "******";                                             /* POP½ */

/* ض */
UINT8     ReceDatFlag = 0;
UINT8     CheckType;
UINT8     OrderType;
UINT16     ReceLen;
extern POP *p_pop3;
UINT8 SocketId;                                                                 /* socketԲö */
UINT8 SocketRecvBuf[CH563NET_MAX_SOCKET_NUM][RECE_BUF_LEN];                     /* socketջ */
/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    if(R32_INT_FLAG & 0x8000)                                                   /* ̫ж */
    {                                                                           /* ̫жжϷ */
        CH563NET_ETHIsr();
    }
    if(R32_INT_FLAG & RB_IF_TMR0)                                               /* ʱж */
    {
         CH563NET_TimeIsr(CH563NET_TIMEPERIOD);                                 /* CH563NET_ ʱжϷ */
         R8_TMR0_INT_FLAG |= 0xff;                                              /* ʱжϱ־ */
   }
}
__irq void FIQ_Handler( void )
{
    while(1);
}
/*******************************************************************************
* Function Name  : SysTimeInit
* Description    : ϵͳʱʼCH563@100MHZ TIME0 10msCH563NET_TIMEPERIOD
*                ʼʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SysTimeInit(void)
{
    R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
    R32_TMR0_COUNT = 0x00000000; 
    R32_TMR0_CNT_END = 0x186a0 * CH563NET_TIMEPERIOD;                           /* Ϊ10MSʱ */
    R8_TMR0_INTER_EN |= RB_TMR_IE_CYC_END;
    R8_TMR0_CTRL_MOD = RB_TMR_COUNT_EN;
}
/*******************************************************************************
* Function Name  : InitSysHal
* Description    : ӲʼTIM0ETHж
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitSysHal(void)
{
    R8_INT_EN_IRQ_0 |= RB_IE_IRQ_TMR0;                                          /* TIM0ж */
    R8_INT_EN_IRQ_1 |= RB_IE_IRQ_ETH;                                           /* ETHж */
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                       /* IRQȫж */
}
/*******************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CH563NET_ERR_SUCCESS) return;                                 /* ɹ */
#if DEBUG
    printf("Error: %02X\n", (UINT16)iError);                                    /* ʾ */
#endif    
}

/*******************************************************************************
* Function Name  : CH563NET_LibInit
* Description    : ʼ
* Input          : ip      ipַָ
*                gwip    ipַָ
*                 : mask    ָ
*                 : macaddr MACַָ 
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH563NET_LibInit(const UINT8 *ip,const UINT8 *gwip,const UINT8 *mask,const UINT8 *macaddr)
{
    UINT8 i;
    struct _CH563_CFG cfg;
    if(CH563NET_GetVer() != CH563NET_LIB_VER)return 0xfc;                       /* ȡİ汾ţǷͷļһ */
    CH563NETConfig = LIB_CFG_VALUE;                                             /* Ϣݸñ */
    cfg.RxBufSize = RX_BUF_SIZE; 
    cfg.TCPMss   = CH563NET_TCP_MSS;
    cfg.HeapSize = CH563_MEM_HEAP_SIZE;
    cfg.ARPTableNum = CH563NET_NUM_ARP_TABLE;
    cfg.MiscConfig0 = CH563NET_MISC_CONFIG0;
    CH563NET_ConfigLIB(&cfg);
    i = CH563NET_Init(ip,gwip,mask,macaddr);
    return (i);                      /* ʼ */
}


/*******************************************************************************
* Function Name  : CH563IPHandleSokcetInt
* Description    : socketжϴ
* Input          : sockeid  socket
*                initstat ж״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_HandleSokcetInt(UINT8 sockeid,UINT8 initstat)
{
    UINT32 len;
    UINT8 i;

    if(initstat & SINT_STAT_RECV)                                               /* ж */
    {
        ReceDatFlag = 1;
        len = CH563NET_SocketRecvLen(sockeid,NULL);                             /* ѯ */
        ReceLen = len;
        CH563NET_SocketRecv(sockeid,SocketRecvBuf[sockeid],&len);               /* ջݶMyBuf*/
#if  DEBUG
        printf("ReceLen= %04x\n",ReceLen);
        printf("MyBuffer = %s\n",(char *)SocketRecvBuf[sockeid]);
#endif
        if( CheckType != uncheck ){
            i = CH563NET_CheckResponse((char *)SocketRecvBuf[sockeid],CheckType);
            if(i != CHECK_SUCCESS){
                if(sockeid == p_pop3->Socket) OrderType = POP_ERR_CHECK;
#if  DEBUG
                printf("ERROR: %02x\n",(UINT16)i);
#endif
            }
        }
        memset((void *)SocketRecvBuf[sockeid],'\0',sizeof(SocketRecvBuf[sockeid]));              
    }
    if(initstat & SINT_STAT_CONNECT)                                            /* TCPж */
    {
#if DEBUG                                                                       /* жϱʾTCPѾӣԽշ */
        printf("TCP Connect Success\n");                           
#endif
    }
    if(initstat & SINT_STAT_DISCONNECT)                                         /* TCPϿж */
    {
#if DEBUG                                                                       /* жϣCH563IPڲὫsocketΪر */
        printf("TCP Disconnect\n");                                             /* Ӧ´ */
#endif
        if(sockeid == p_pop3->Socket) p_pop3->DiscnntFlag = 1;
    }
    if(initstat & SINT_STAT_TIM_OUT)                                            /* TCPʱж */
    {
#if DEBUG                                                                       /* жϣCH563IPڲὫsocketΪر */
        printf("TCP Timout\n");                                                 /* Ӧ´ */
#endif
        if(sockeid == p_pop3->Socket) p_pop3->DiscnntFlag = 1;
    }
}

/*******************************************************************************
* Function Name  : CH563NET_HandleGlobalInt
* Description    : ȫжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_HandleGlobalInt(void)
{
    UINT8 initstat;
    UINT8 i;
    UINT8 socketinit;

    initstat = CH563NET_GetGlobalInt();                                         /* ȫж״̬ */
    if(initstat & GINT_STAT_UNREACH)                                            /* ɴж */
    {
#if DEBUG
        printf("UnreachCode %d\n",CH563Inf.UnreachCode);                      /* 鿴ɴ */
        printf("UnreachProto %d\n",CH563Inf.UnreachProto);                    /* 鿴ɴЭ */
        printf("UnreachPort %d\n",CH563Inf.UnreachPort);                      /* ѯɴ˿ */
#endif       
    }
   if(initstat & GINT_STAT_IP_CONFLI)                                           /* IPͻж */
   {
   
   }
   if(initstat & GINT_STAT_PHY_CHANGE)                                          /* PHYıж */
   {
       i = CH563NET_GetPHYStatus();                                             /* ȡPHY״̬ */
#if DEBUG
   printf("GINT_STAT_PHY_CHANGE %02x\n",i);
#endif   
   }
   if(initstat & GINT_STAT_SOCKET)                                              /* Socketж */
   {
       for(i = 0; i < CH563NET_MAX_SOCKET_NUM; i ++)                     
       {
           socketinit = CH563NET_GetSocketInt(i);                               /* socketжϲ */
           if(socketinit)CH563NET_HandleSokcetInt(i,socketinit);                /* ж */
       }    
   }
}

/*******************************************************************************
* Function Name  : CH563IP_CreatTcpSocket
* Description    : TCP Client socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_CreatTcpPop3( )
{
   UINT8 i;                                                             
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */

   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   memcpy((void *)TmpSocketInf.IPAddr,Socketpop3IP,4);                          /* ĿIPַ */
   TmpSocketInf.DesPort = 110;                                                  /* ĿĶ˿ */
   TmpSocketInf.SourPort = Pop3SourPrt;                                         /* Դ˿ */
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                     /* socekt */
   TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf[1];                      /* ýջĽջ */
   TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;                                     /* ýջĽճ */
   i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);                           /* socketصsocketSocketId */
#if DEBUG
    printf("SocketId TCP pop3 = %02x\n",(UINT16)SocketId);
#endif    
   mStopIfError(i);                                                             /*  */
   p_pop3->Socket = SocketId;
   CheckType = POP_CHECK_CNNT;
   i = CH563NET_SocketConnect(SocketId);                                        /* TCP */
   mStopIfError(i);                                                             /*  */
   memset((void *)SocketRecvBuf[SocketId],'\0',sizeof(SocketRecvBuf[SocketId]));              
}

/*******************************************************************************
* Function Name  : CH563NET_SendData
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_SendData( char *PSend, UINT32 Len,UINT8 type,UINT8 index  )
{
    UINT32 length;
    UINT8 i;
    UINT8 *p;

#if DEBUG
    printf("send data:\r\n%s\n", PSend);
#endif
    p = (UINT8 *)PSend;
    length = Len;
    CheckType = type;
    while(1)
    {
        Len = length;
        i = CH563NET_SocketSend(index,p,&Len);                                  /* MyBufеݷ */
        mStopIfError(i);                                                        /*  */
        length -= Len;                                                          /* ܳȼȥԼϵĳ */
        p += Len;                                                               /* ָƫ*/
        if(length)continue;                                                     /* δϣ*/
        break;                                                                  /* ϣ˳ */
    }
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD1 schmitt input, TXD1 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD1 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : CH563NET_MAILInit
* Description    : ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH563NET_MAILInit( void ) 
{

    UINT8 i = 0;

    i = CH56X_GetMac(MACAddr);
    i = CH563NET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);                       /* ʼ */
    mStopIfError(i);                                                            /*  */
#if DEBUG
    printf("CH563IPLibInit Success\n");
#endif    
    SysTimeInit();                                                              /* ϵͳʱʼ */
    InitSysHal();                                                               /* ʼж */
    CH563NET_POP3Init( );
    CH563NET_CreatTcpPop3( );
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void )
{
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */
    CH563NET_MAILInit( );
    while(1)
    {
        CH563NET_MainTask( );                                                   /* CH563NETҪѭвϵ */  
        if( CH563NET_QueryGlobalInt( ) )CH563NET_HandleGlobalInt( );            /* ѯжϣжϣȫжϴ */ 
        CH563NET_MailQuery( );
        if(ReceDatFlag){
            ReceDatFlag = 0;
            CH563NET_MailCmd( OrderType );                                          
        }
    }
}

/*********************************** endfile **********************************/
