/********************************** (C) COPYRIGHT *******************************
* File Name          : EHCI_HCD.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : Description: CH563MAC Non-OS firmware header file 
*******************************************************************************/



/******************************************************************************/
#ifndef __NETMAC_H__
#define __NETMAC_H__                            

/******************************************************************************/
#define ETHER_HEAD_LEN                     14
#define MAC_MAX_LEN                        1502
#define CH563_DEBUG                        1                                    /* ջ */
#define RECE_BUF_LEN                       0x5ec                                /* ջĴС */


/*
 * MAC㷢ͽջز
 */
/* С2 */
#define RX_QUEUE_NUM                       3                                    /* ջ */
#define TX_QUEUE_NUM                       2
#define RX_BUF_SIZE                        0x5ec                                /* ջС */
#define TX_BUF_SIZE                        0x5ec                                /* ͻС */

#define BUF_IDLE                           0                                    /*  */
#define BUF_MAC_LOCK                       1                                    /* MAC */
#define BUF_IP_LOCK                        2                                    /* IP */

#define IPADDR_LEN                         4
#define MACADDR_LEN                        6
#define NET_SOCKET_NUM                     20
/* 
 * PHY״̬ 
 */
#define PHY_DISCONN                         (1<<0)                              /* PHYϿ */
#define PHY_10M_FLL                         (1<<1)                              /* 10Mȫ˫ */
#define PHY_10M_HALF                        (1<<2)                              /* 10M˫ */
#define PHY_100M_FLL                        (1<<3)                              /* 100Mȫ˫ */
#define PHY_100M_HALF                       (1<<4)                              /* 100M˫ */
#define PHY_AUTO                            (1<<5)                              /* PHYԶģʽCMD10H_SET_PHY */
        
#define FTPHY_REG_CONTROL                  0x00
#define FTPHY_REG_STATUS                   0x01
#define FTPHY_RB_PHYAD                     0x10
/*
 * ȫֱ
 */
extern UINT8   MACRxBuf[RX_QUEUE_NUM][RX_BUF_SIZE];                             /* MACջ4ֽڶ */
extern UINT8   MACTxBuf[TX_QUEUE_NUM][TX_BUF_SIZE];                             /* MACͻ4ֽڶ */
extern UINT8   RecvBuf[RX_BUF_SIZE];
extern PUINT8  MACSendbuf;
extern UINT8V  PHYStatus;
extern UINT8V  SendSuc;                                                         /* ݰ ɹ־ */
extern UINT8   CH563MACAddr[MACADDR_LEN];                                       /* MACַ */
extern UINT8   CH563IPAddr[IPADDR_LEN];
extern UINT8   IPDestAddr[IPADDR_LEN];


/* 
 * RXտϢ 
 */
struct _RXBUFST
{
    UINT8  RecvIndex;                                                           /* MACջ */
    UINT8  ReadIndex;                                                           /* ȡֵ */
    UINT8  RemainCout;                                                          /* ʣδȡݰ */
    UINT8  RxDMAEnable;                                                         /* DMAʹܱ־ڻʱԹرRX DMA*/
    UINT8  RxBufStau[RX_QUEUE_NUM];                                             /* ջ״̬ */
    UINT16 RxBufLen[RX_QUEUE_NUM];                                              /* ջݵЧ */
    UINT32 RxBufAddr[RX_QUEUE_NUM];                                             /* ջʼַ */
};
extern struct  _RXBUFST    RxCtrl;                                     

/* 
 * TXտϢ 
 */                                       

struct _TXBUFST
{                                                                               
    UINT8  SendIndex;                                                           /*  */
    UINT8  TxBufStat[TX_QUEUE_NUM];                                             /* ͻ״̬ */
};
extern struct _TXBUFST    TxCtrl;                                      

/*
 * 16ֽڶ
 */
typedef struct _CH563MAC_TXDES {
    UINT32 txdes0; /* ֡״̬Ȩ */
    UINT32 txdes1; /* λ뷢ͻС */
    UINT32 txdes2; /* ͻĻַ */
    UINT32 txdes3; /* ûʹãڱһַ */
}mac_txdes;
extern UINT8  TxDesBuf[TX_QUEUE_NUM*16];

/*
 * 16ֽڶ
 */
typedef struct _CH563MAC_RXDES 
{
    UINT32 rxdes0; /* ֡״̬Ȩ */
    UINT32 rxdes1; /* λ뷢ͻС */
    UINT32 rxdes2; /* ջĻַ */
    UINT32 rxdes3; /* ûʹãڱһַ */
}mac_rxdes;
extern UINT8  RxDesBuf[(RX_QUEUE_NUM )*16]; 

/*
 * CH563MACƽṹ
 */
typedef struct _CH563MAC_Control
{
    mac_txdes *txdes_top;                                                       /*  */
    mac_txdes *txdes_cur;                                                       /* ǰ */
    mac_txdes *txdes_end;                                                       /* һ */
    mac_rxdes *rxdes_top;                                                       /*  */
    mac_rxdes *rxdes_cur;                                                       /* ǰ */
    mac_rxdes *rxdes_end;                                                       /* һ */
}MACCtrl;
extern MACCtrl   mac_cotrl;                                       


typedef union _ETHERHEAD
{
    UINT8  buffer[ETHER_HEAD_LEN];
    struct
    {
        UINT8   DestMAC[MACADDR_LEN];
        UINT8   SourMAC[MACADDR_LEN];
        UINT16  PROTOCOL;
        #define ETHER_TYPE_IP            0x0800    
        #define ETHER_TYPE_ARP          0x0806
    }Head;
}ETHERHEAD;
extern ETHERHEAD    ETH;                                                        /* macͷ */
#define ARP_ENTRY_TIME_OUT            10
#define ARP_PACKAGE_LEN                28
#define ARP_ENTRY_MAX_NUM            8

/* arppacket->type */
#define ARP_CODE_QUEST                0x0001    
#define ARP_CODE_REPLY              0x0002
#define RARP_CODE_QUEST                0x0003
#define RARP_CODE_REPLY                0x0004

typedef union _ARPPACKAGE
{
    UINT8  buffer[ARP_PACKAGE_LEN];
    struct  
    {
        UINT16 HRDTYPE;        // Ӳ
        #define ARP_HARDWARE_TYPE_ETHER     0x0001
        UINT16 PROTYPE;        //
        #define ARP_PROTOCOL_TYPE_IP        0x0800
        UINT8  MACLEN;        //
        UINT8  IPLEN;        //
        UINT16 OPCODE;        //
        UINT8  SENDMAC[MACADDR_LEN];
        UINT8  SENDIP[IPADDR_LEN];
        UINT8  TARGMAC[MACADDR_LEN];
        UINT8  TARGIP[IPADDR_LEN];
    }Package;
}ARPPACKAGE;

/* 
 * 
 */
UINT16 GLOB_nTohs( UINT16 in );

void    NET_INIT( void );

void    NET_TimeIsr( UINT16 time );

UINT16  PHY_ReadData(UINT16 regad);

void    MAC_InitTXDes(void);

void    MAC_Isr(void);

UINT8   MAC_QueryInput(void);

UINT16  MAC_Input(UINT8 *buf,UINT16 *slen);

void    MAC_RecvFinishHanld( void );

UINT8   MAC_Output(UINT8 *buf,UINT16 *len,UINT16 code);

UINT8 ARP_Output( UINT8 *desip,UINT8 code );

void ARP_Input( UINT8 *arpdata,UINT16 len );

#endif
