#ifndef __UPNP_H__
#define __UPNP_H__
/*=============================================================================*/
/* Զ */
/*-----------------------------------------------------------------------------*/
typedef unsigned long                             u32;
typedef unsigned short                            u16;
typedef unsigned char                             u8;
/*=============================================================================*/
/* ģʽ */
/*-----------------------------------------------------------------------------*/
#define UPNP_ENABLE                               1                             /* UPNP */
#define UPNP_BUG_ENABLE                           1                             /* DEBUGʹ */
/*=============================================================================*/
/* SSDPܽ */
/*-----------------------------------------------------------------------------*/
#define ENABLE_SSDP_FUN                           0                             /* /SSDP,UDP㲥 */
/*=============================================================================*/
/* ˿ڷΧ */
/*-----------------------------------------------------------------------------*/
#define UVC_IP_MIN_PORT                           40000
#define UVC_IP_MAX_PORT                           41000
/*=============================================================================*/
/* UPNP״̬ */
/*-----------------------------------------------------------------------------*/
#define DEF_UPNP_STOP                             0X00                          /* UPNP ֹͣ */
#define DEF_UPNP_START                            0X01                          /* UPNP  */
#define DEF_UPNP_WAIT_URL                         0X02                          /* ȴURLַ */
#define DEF_UPNP_GET_CONNECT                      0X03                          /* GETTCP */
#define DEF_UPNP_GET_RECV                         0X04                          /* GETӳɹGET󣬵ȴUPNPӦ */
#define DEF_UPNP_GET_CLOSEING                     0X05                          /* GETӳɹݣȴرգرպPOST */
#define DEF_UPNP_POST_CONNECT                     0X06                          /* GETTCP */
#define DEF_UPNP_POST_RECV                        0X07                          /* POSTȴݣԱӳʧܻǳɹ */
#define DEF_UPNP_POST_CLOSEING                    0X08                          /* POSTӳɹݣȴرգرպPOST */
/*=============================================================================*/
/* ڴ鶨 */
/*-----------------------------------------------------------------------------*/
#define UPNP_MEM_SIZE                             170
/*=============================================================================*/
/* ʱ */
/*-----------------------------------------------------------------------------*/
#define UPNP_TIME_PERIOD                          250                           /* ʱ250MS*/
#define UPNP_TIME_SECOND                          1000                          /* 1Sʱ */
#define UPNP_TIMEOUT_10S                          (UPNP_TIME_SECOND*10)         /* 10Sʱ */
#define UPNP_TIMEOUT_180S                         (UPNP_TIME_SECOND*10)        /* 180Sʱ */
#define UPNP_TIMEOUT_20S                          (UPNP_TIME_SECOND*20)         /* 10Sʱ */
#define UPNP_MAX_AGE_ADD                          (UPNP_TIME_SECOND*5)          /* MAX-AGEϼUPNP_MAX_AGE_ADDֹ⵽UPNP豸 */
/*=============================================================================*/
/* ӳЭ */                                                                   
/*-----------------------------------------------------------------------------*/
#define MAP_TYPE_TCP                              0                            /* ӳЭΪTCP */
#define MAP_TYPE_UDP                              1                            /* ӳЭΪUDP */
/*=============================================================================*/
/*˿ڶ */                                                                   
/*-----------------------------------------------------------------------------*/
#define DEF_UPNP_MULTI_SPORT                      1890                          /* ಥض˿ */
#define DEF_UPNP_MULTI_DPORT                      1900                          /* ಥĿĶ˿ */
/*=============================================================================*/
/* Ч־ */                                                              
/*-----------------------------------------------------------------------------*/
#define SOCKET_ENABLE_FLAG                        0X80                          /* socketʱǷЧ */
/*=============================================================================*/
/* 3з */
/*-----------------------------------------------------------------------------*/
#define  UPNP_SERVER_WANIPCONNECT                 1
#define  UPNP_SERVER_WANCOMMINTER                 2
#define  UPNP_SERVER_LAY3FORWARD                  3
/*=============================================================================*/
/*  */
/*-----------------------------------------------------------------------------*/
#define ERR_UPNP_SUCCESS                          0
#define ERR_UPNP_FAIL                             1
#define ERR_UPNP_TCP_CONNECT                      0x30
#define ERR_UPNP_MEM_ERR                          0x31

/*=============================================================================*/
/* PNP־λ */
/*-----------------------------------------------------------------------------*/
#define  DEF_UPNP_FIND                            (1<<0)
/*=============================================================================*/
/*  */                                                                   
/*-----------------------------------------------------------------------------*/
typedef __packed struct _UP_CTRL
{
   u32  MaxAgeBack;                                                             /* MAX-AGEʱ䣬MAP˿ڼʱ */
   u32  MaxAgeCount;                                                            /* ʱ  */
   u32  MapTime;                                                                /* ְʱ */
   u32  TimeCount;                                                              /* ʱǰʱ */
   u32  SSDPTime;                                                               /* SSDPʱδUDPרöʱ */
   u8   *pRecv;                                                                 /* ָ */
   u16  RecvLen;                                                                /* ݵĳ */
   u16  RecvTotalLen;                                                           /* ݵܳ */
   u16  ExternalPort;                                                           /* UPNP ⲿ˿ */
   u16  InternelPort;                                                           /* UPNPڲ˿ */
   u8   UpnpProType;                                                            /* UPNPЭͣ0ΪTCP,1ΪUDP*/
   u8   IPAddr[4];
   u8   GateIPAddr[4];
   u8   UdpSocket;                                                              /* UPNPUDP˿ڣλΪ1ʾЧ */
   u8   TcpSocket;                                                              /* UPNPTCP˿ڣλΪ1ʾЧ */
   u8   MaxAgeStart;                                                            /* MaxAgeʱ */
   u8   TimeInt;                                                                /* ʱж */
   u8   UpnpMach;                                                               /* ״̬  */
   u8   UpnpFlags;                                                              /* ־λοUPNP־λ */
   const u8 *MapPortDes;                                                        /* MAP˿ */
   void (*AppUpnpCallBack)(u8 errcdoe);                                         /* ûص */
}UPNP_CTRL;

/*=============================================================================*/
/* UPNPӦòṹ壬ʱ */                                                                   
/*-----------------------------------------------------------------------------*/
typedef struct _UPNP
{
   u16  InternelPort;                                                           /* UPNPڲ˿ */
   u16  ExternalPort;                                                           /* UPNP ⲿ˿ */
   u8   IPAddr[4];                                                              /* ӳ˿ڵIPַ */
   u8   UpnpProType;                                                            /* UPNPЭͣ0ΪTCP,1ΪUDP*/
   const u8 *MapPortDes;                                                        /* MAP˿ */
}UPNP_MAP;
/*=============================================================================*/
/* UPNPӦòṹ壬ʼݲʹ */                                                                   
/*-----------------------------------------------------------------------------*/
typedef struct _UPNP_CFG
{
   u8  *UpnpMemory;
   u32  MemoryLen;
   u32  TcpMss;
   u8   GateIPAddr[4];                                                          /* (UPNP豸)IPַ*/
   void (*AppUpnpCallBack)(u8 errcdoe);                                         /* ûص */
}UPNP_CFG;
/*=============================================================================*/
/*  */                                                                   
/*-----------------------------------------------------------------------------*/
u8 CH563NET_UPNPInit(UPNP_CFG *upnpcfg);

void CH563NET_UPNPStart(UPNP_MAP *upnpmap);

u8 CH563NET_UPNPCheckSocketAvail(u8 socket);

void UPNP_CreatTcpPostSocket(void);

void CH563NET_UPNPTimeHandle(void);

void CH563NET_UPNPCreatUpdSocket(void);

void CH563NET_UPNPSendSSDPacket(void);

void CH563NET_UPNPRecvMultiBrocast(u8 socketid,u8 *buf);

void CH563NET_UPNPCreatTcpGetSocket(void);

u8 CH563NET_UPNPStartMapPort(void);

void CH563NET_UPNPInitPostCommand(u8 socketindex);

void CH563NET_UPNPTcpSendGetCommand(u8 socketindex);

void CH563NET_UPNPReceivePostCmd(u8 *buf,u32 len);

void CH563NET_UPNPReceiveGetCmd(u8 *buf,u32 len);

void CH563NET_UPNPReceiveDataHandle(u8 socket );

void CH563NET_UPNPMainTask(void);

void CH563NET_UPNPTCPDisConnectHandle(u8 socketid);
#endif