/********************************** (C) COPYRIGHT *******************************
* File Name          : POWER.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563 USB SLEEP DEMO
*                      (1)CH563 Examples by KEIL;    
*                      (2)0Ϣ,115200bps;
*                      (3)ͨ0Ӧʾرաֹܣ˯ߣѵ
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "POWER.H"                                                              /* оƬUSBĴͷļ */
#include "SYSFREQ.H"

UINT16    my_buffer[ 0x2000 ];

/* һLEDڼʾĽ,͵ƽLED */
#define LED                     1<<3

#define LED_OUT_INIT(  )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }         /* LED ߵƽΪ */
#define LED_OUT_ACT(  )      { R32_PB_CLR |= LED; }                            /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT(  )    { R32_PB_OUT |= LED; }                            /* LED ߵƽرLEDʾ */

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : USBHost_ModeSet
* Description    : óUSBģʽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBHost_ModeSet( void )
{ 
    R8_MISC_CTRL_USB = R8_MISC_CTRL_USB & ( ~RB_MISC_USB_ID_EN );
    R8_MISC_CTRL_USB = R8_MISC_CTRL_USB & ( ~RB_MISC_USB_ID_ST );
    OTG_CONTROL_STATUS = 0x000E0190;
}

/*******************************************************************************
* Function Name  : USBDev_ModeSet
* Description    : óUSB豸ģʽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBDev_ModeSet( void )
{ 
    R8_MISC_CTRL_USB = R8_MISC_CTRL_USB & ( ~RB_MISC_USB_ID_EN );               /* USB OTG ID pin enable */                                    
    R8_MISC_CTRL_USB = R8_MISC_CTRL_USB | RB_MISC_USB_ID_ST;                    /* óUSB豸 */
}

/*******************************************************************************
* Function Name  : WakeUP_PB
* Description    : PB[8]óʼ 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void WakeUP_PB( void )
{
    R32_PB_DIR &= 0xffffff00;                                                   /* GPIO BΪ , direction: 0=in, 1=out */
    R32_PB_PU  |= 0x000000ff;                                                   /* GPIO Bã1ʾ */ 
    Delay_us(10);
    R32_INT_ENABLE_PB |= 0x000000ff;                                            /* GPIO Bλжʹ  1-ʹܣ0-ֹ */
    R32_INT_POLAR_PB  &= 0;                                                     /* PB[8]͵ƽ */      
}

/*******************************************************************************
* Function Name  : Test_Sleep
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Test_Sleep( void )
{
    UINT32    i;

    if ( R8_UART0_LSR & RB_LSR_DATA_RDY ) {                                     /* ͨ0x00001234Ƶ32λֵַ */
        Delay_ms( 20 );
        for ( i=0; i<10; i++ ){
            if ( R8_UART0_LSR & RB_LSR_DATA_RDY ) {
                my_buffer[i] = R8_UART0_RBR;
                if ( my_buffer[i] >= 'a' && my_buffer[i] <= 'z' ) my_buffer[i] -= 'a' - 'A';
                if ( i >= 2 ){
                    if ( my_buffer[i] >= '0' && my_buffer[i] <= '9' ) my_buffer[i] -= '0';
                    else if ( my_buffer[i] >= 'A' && my_buffer[i] <= 'F' ) my_buffer[i] = my_buffer[i] - 'A' + 10;
                    else i = 99;
                }
            }
            else break;
        }
        if ( i == 10 && my_buffer[0] == '0' && my_buffer[1] == 'X' ) {
            i = ( my_buffer[2] << 12 ) | ( my_buffer[3] << 8 ) | ( my_buffer[4] << 4 ) | my_buffer[5];
            i <<= 16;
            i |= ( my_buffer[6] << 12 ) | ( my_buffer[7] << 8 ) | ( my_buffer[8] << 4 ) | my_buffer[9];
            printf("recv = %8lX\n",i);
            i = *((PUINT32)i);
            printf("Data = %8lX\n",i);
        }
        else { 
            printf("my_buffer=%x\n",my_buffer[0]);      
            switch (my_buffer[0]){
                case 1:                                                         /* Ĵд0x95ʹPLLȫ״̬(CPU)ֲ֧
                                                                                   GPIO USB ETH-WOL  */
                    printf("SLEEP\n");
                    R8_SAFE_ACCESS_SIG = 0x57;                                  /* unlock step 1 */
                    R8_SAFE_ACCESS_SIG = 0xA8;                                  /* unlock step 2 */
                    R8_SLP_CTRL_PLL = 0x95;                                     /* д0x95 */
                    R8_SLP_WAKE_CTRL  |= RB_SLP_PB_WAKE;                        /* PB˿ڻʹ */
                    R8_SAFE_ACCESS_SIG = 0;                                     /* ֹд */
                    break;

                case 2:                                                         /* Ĵд0x6AʹCPU״̬ʱPLLȻڹCPU
                                                                                   ԱʹܵĸжϿٻ */
                    printf("CPU \n");
                    R8_SAFE_ACCESS_SIG = 0x57 ;                                 /* unlock step 1 */
                    R8_SAFE_ACCESS_SIG = 0xA8 ;                                 /* unlock step 2 */
                    R8_SLP_CTRL_PLL = 0x6A;                                     /* д0x6A */
                    R8_SLP_WAKE_CTRL  |= RB_SLP_PB_WAKE;                        /* PB˿ڻʹ */
                    R8_SAFE_ACCESS_SIG = 0;                                     /* ֹд */
                    break;

                case 3:                                                         /* ̫ģϵ */
                    printf("ETH PWR ON\n");
                    R8_SAFE_ACCESS_SIG = 0x57;                                  /* unlock step 1 */
                    R8_SAFE_ACCESS_SIG = 0xA8;                                  /* unlock step 2 */
                    R8_SLP_WAKE_CTRL  &= 0x0b;                                  /* ϵ */
                    R8_SAFE_ACCESS_SIG = 0;                                     /* ֹд */
                    break;

                case 4:                                                         /* ̫ģµ */
                    printf("ETH PWR OFF\n");
                    R8_SAFE_ACCESS_SIG = 0x57;                                  /* unlock step 1 */
                    R8_SAFE_ACCESS_SIG = 0xA8;                                  /* unlock step 2 */
                    R8_SLP_WAKE_CTRL  |= 0x80;                                  /* µ */
                    R8_SAFE_ACCESS_SIG = 0;                                     /* ֹд */
                    break;

                case 5:                                                         /* ADCPHY */
                    printf("open ADC PHY\n");
                    R8_SAFE_ACCESS_SIG = 0x57 ;                                 /* unlock step 1 */
                    R8_SAFE_ACCESS_SIG = 0xA8 ;                                 /* unlock step 2 */    
                    R8_SLP_CLK_OFF1 &= ~RB_SLP_CLK_ADC;                
                    R8_SAFE_ACCESS_SIG = 0;                                     /* ֹд */
                    R8_ADC_CTRL_MOD |= RB_ADC_POWER_ON;                         /* ADCģʹ */
                    break;

                case 6:                                                         /* رADCPHY */
                    printf("close ADC PHY\n");
                    R8_SAFE_ACCESS_SIG = 0x57 ;                                 /* unlock step 1 */
                    R8_SAFE_ACCESS_SIG = 0xA8 ;                                 /* unlock step 2 */    
                    R8_SLP_CLK_OFF1 |= RB_SLP_CLK_ADC;                
                    R8_SAFE_ACCESS_SIG = 0;                                     /* ֹд */
                    R8_ADC_CTRL_MOD &= ~RB_ADC_POWER_ON;                        /* ADCģֹ */
                    break;

                case 7:                                                         /* رʱ */
                    printf("close clk\n");
                    R8_SAFE_ACCESS_SIG = 0x57 ;                                 /* unlock step 1 */
                    R8_SAFE_ACCESS_SIG = 0xA8 ;                                 /* unlock step 2 */
                    R8_SLP_CLK_OFF0 |= ( RB_SLP_CLK_UART1 | RB_SLP_CLK_UART0 | 
                                       RB_SLP_CLK_TMR0 | RB_SLP_CLK_TMR1 |
                                       RB_SLP_CLK_TMR2 | RB_SLP_CLK_TMR3 | 
                                       RB_SLP_CLK_SPI0 | RB_SLP_CLK_SPI1 );     /* رʱӿƼĴ0 */
                    R8_SLP_CLK_OFF1 |= ( RB_SLP_CLK_ADC | RB_SLP_CLK_GPIO | 
                                       RB_SLP_CLK_USB | RB_SLP_CLK_ETH );       /* رʱӿƼĴ1 */
                    R8_SAFE_ACCESS_SIG = 0;                                     /* ֹд */
                    Delay_ms( 1000 );
                    R8_SAFE_ACCESS_SIG = 0x57 ;                                 /* unlock step 1 */
                    R8_SAFE_ACCESS_SIG = 0xA8 ;                                 /* unlock step 2 */
                    R8_SLP_CLK_OFF0 &= ~RB_SLP_CLK_UART0;                       /* 1s0ʱ */
                    R8_SAFE_ACCESS_SIG = 0;                                     /* ֹд */
                    Delay_us( 10 );
                    printf("\nOK\n");
                   break;    

                case 8:                                                         /* ʱ */
                    printf("open clk\n");
                    R8_SAFE_ACCESS_SIG = 0x57 ;                                 /* unlock step 1 */
                    R8_SAFE_ACCESS_SIG = 0xA8 ;                                 /* unlock step 2 */
                    R8_SLP_CLK_OFF0 &= 0x00;                                    /* ʱӿƼĴ0 */
                    R8_SLP_CLK_OFF1 &= 0x0f;                                    /* ʱӿƼĴ1 */
                    R8_SAFE_ACCESS_SIG = 0;                                     /* ֹд */
                    break;    

                case 9:                                                         /* رUSB */
                    printf("close usb\n");
                    USBHost_ModeSet( );    
                    R8_SAFE_ACCESS_SIG = 0x57 ;                                 /* unlock step 1 */
                    R8_SAFE_ACCESS_SIG = 0xA8 ;                                 /* unlock step 2 */                     
//                  USB_DEV_CONTROL |= RB_GOSUSP;                               /* 豸ģʽPHY */
                    HC_MISCELLANEOUS |= (1<<6);                                 /* ģʽշ */
                    R8_SLP_CLK_OFF1 |= RB_SLP_CLK_USB;                          /* رUSBʱ */
                    R8_SAFE_ACCESS_SIG = 0;                                     /* ֹд */
                    break;

                 case 10:                                                       /* USBģʽ */
                    printf("USB Host\n");
                    R8_SAFE_ACCESS_SIG = 0x57 ;                                 /* unlock step 1 */
                    R8_SAFE_ACCESS_SIG = 0xA8 ;                                 /* unlock step 2 */                     
                    R8_SLP_CLK_OFF1 &= ~RB_SLP_CLK_USB;                         /* USBʱ */
                    HC_MISCELLANEOUS &= ~(1<<6);
                    R8_SAFE_ACCESS_SIG = 0;                                     /* ֹд */
                    USBHost_ModeSet( );    
                    break;

                 default:
                    printf("!!!! input error !!!\n");
                    printf(" 1................PLLȫ״̬,PB[8]͵ƽ\r\n");
                    printf(" 2................CPU ״̬PB[8]͵ƽ\r\n");
                    printf(" 3................̫ģϵ\r\n");
                    printf(" 4................̫ģµ\r\n");
                    printf(" 5................ADCPHY\r\n");
                    printf(" 6................رADCPHY\r\n");
                    printf(" 7................رʱ\r\n");
                    printf(" 8................ʱ\r\n");
                    printf(" 9................رUSBʱӺPHY\r\n");
                    printf(" A................USBģʽ\r\n");
                    break;
            } 
        }
        while ( R8_UART0_LSR & RB_LSR_DATA_RDY ) i = R8_UART0_RBR;
    }
    for ( i=0; i!=5; i++ ) {
        LED_OUT_ACT( );
        Delay_ms( 100 );
        LED_OUT_INACT( );
        Delay_ms( 100 );
        if ( R8_UART0_LSR & RB_LSR_DATA_RDY ) break;
    }
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void ) 
{ 
    LED_OUT_INIT( );
    LED_OUT_ACT( );                                                             /* LEDһʾ */
    Delay_ms( 100 );
    LED_OUT_INACT( );
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */
    LED_OUT_ACT( );
    LED_OUT_INACT( );
    printf( "Start test\n" );
    printf(" 1................PLLȫ״̬,PB[8]͵ƽ\r\n");
    printf(" 2................CPU ״̬PB[8]͵ƽ\r\n");
    printf(" 3................̫ģϵ\r\n");
    printf(" 4................̫ģµ\r\n");
    printf(" 5................ADCPHY\r\n");
    printf(" 6................رADCPHY\r\n");
    printf(" 7................رʱ\r\n");
    printf(" 8................ʱ\r\n");
    printf(" 9................رUSBʱӺPHY\r\n");
    printf(" A................usbģʽ\r\n");
    WakeUP_PB( );
    while(1){
        Test_Sleep( );
    }
}

/*********************************** endfile **********************************/
