/********************************** (C) COPYRIGHT ******************************
* File Name          : SPI1_SDCARD.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : (1)SDֲ
*                      (2)0Ϣ
*                      (3)ҪSDλʼ/д
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include "CH563BAS.H"                                                           /* CH563ͷļ */
#include "CH563SFR.H"                                                           /* CH563Ĵͷļ */    
#include "SYSFREQ.H"                                                            /* SDͷļ */                            
#include "SD_INC.H"                                                             /* SDͷļ */                            

/******************************************************************************/
/* ṹ嶨 */
volatile struct _SD_STAU  SD_Status;                                            /* SD״̬ṹĶ */
volatile sd_struct  sds;                                                        /* SDϢṹ嶨 */
UINT8  Cur_SD_Status;                                                           /* ǰSD״̬: 00---δ; 01---뵫δʼ; 02---ʼʧ; 03---ʼɹ */ 

#include "SD_HW.H"                                                              /*SDӲ*/

/*******************************************************************************
* Function Name  : SD_Port_Init
* Description    : SDӿڳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SD_Port_Init( void )
{
    /* SPI1 */
    /* SPI1Ϊģʽ: MOSI\SCKʱģʽ03߽ӿڡSPIģʽ */
    R8_SPI1_CTRL_MOD = ( RB_SPI1_SDO_OE | RB_SPI_SCK_OE );
    R8_SPI1_CTRL_DMA = 0x00;                                                    /* DMA */
    R8_SPI1_CLOCK_DIV = 0x20;                                                   /* SPIʱΪϵͳʱ16Ƶ */    
    /* SPIڶӦIOڷ */
    R32_PB_DIR &= ~( PIN_SD_SPI_MISO );                                         /* MISOΪ */
    R32_PB_DIR |= ( PIN_SD_SPI_SCS | PIN_SD_SPI_SCK | PIN_SD_SPI_MOSI );        /* SCSSCKMOSIΪ */
    /* ж */
    R8_SPI1_INTER_EN = 0x00;                                                    /* ֹȫж */
    /* SD_INSERTSD_WPӦIOڷΪ */
#if 0
    R32_PB_DIR &= ~( PIN_SD_INSERT|PIN_SD_WP );                                 /* ÷Ϊ */
    R32_PB_PD &= ~( PIN_SD_INSERT|PIN_SD_WP );                                  /*  */
    R32_PB_PU |= ( PIN_SD_INSERT|PIN_SD_WP );
#else 
    R32_PB_DIR &= ~( PIN_SD_INSERT );                                           /* ÷Ϊ */
    R32_PB_PD &= ~( PIN_SD_INSERT );                                            /*  */
    R32_PB_PU |= ( PIN_SD_INSERT );
    R32_PD_DIR &= ~( PIN_SD_WP  );
    R32_PD_PD &= ~( PIN_SD_WP );
    R32_PD_PU |= ( PIN_SD_WP );        
#endif
}

/*******************************************************************************
* Function Name  : SD_SPI_HighSpeed_Set
* Description    : SDӿڵSPIдʱΪģʽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SD_SPI_HighSpeed_Set( void )
{   
    R8_SPI1_CLOCK_DIV = 0x04;                                                   /* SPIʱΪϵͳʱ4Ƶ */    
}

/*******************************************************************************
* Function Name  : SD_Check_Insert
* Description    : SDǷ,򷵻TRUE; 򷵻FALSE     
* Input          : None
* Output         : None
* Return         : FALSE or TRUE
*******************************************************************************/
UINT8 SD_Check_Insert( void )
{
    if( SD_INSERT_PIN_IN( ) ){
        SD_Status.SD_Inster = 0x01;
        return( FALSE );                                                        /* SDδ */
    }
    else{ 
        Delay_ms( 10 );
        if( !SD_INSERT_PIN_IN( ) ){
            SD_Status.SD_Inster = 0x01;
            return( TRUE );                                                     /* SD */
        }
        else{
            return( FALSE );                                                    /* SDδ */
        }
    }
}

/*******************************************************************************
* Function Name  : SD_Check_WP
* Description    : SDǷд,дTRUE; 򷵻FALSE(д             
*                  ߵƽ,͵ƽ)
* Input          : None
* Output         : None
* Return         : FALSE or TRUE
*******************************************************************************/
UINT8 SD_Check_WP( void )
{
    if( SD_WP_PIN_IN( ) )
    {
        Delay_ms( 10 );
        if( SD_WP_PIN_IN( ) )
          {
            SD_Status.SD_Write_Pro = 0;                                         /* TFд */
            return( TRUE );                                                     /* SDд */
        }
        else
        {
            return( FALSE );                                                    /* SDδд */
        }
    }
    else
    {
        SD_Status.SD_Write_Pro = 0x00;
        return( FALSE );                                                        /* SDδд */
    } 
}

/*******************************************************************************
* Function Name  : SD_SendCmd
* Description    : SD   
* Input          : cmd---
*                  *param---4ֽڲ
*                  resptype---ǰ뷵(ֽ)
*                  *resp---ز 
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_SendCmd( UINT8 cmd, UINT8 *param, UINT8 resptype, UINT8 *resp )
{
    UINT32 i, rlen;
    UINT8 tmp;

    SD_CS_PIN_LOW( );                                               
    SD_SPI1_SENDBYTE( ( cmd & 0x3F ) | 0x40 );                                  /* ͷ send command header and word */    
    SD_SPI1_SENDBYTE( param[ 3 ] );                                             /* Ͳ send parameters */
    SD_SPI1_SENDBYTE( param[ 2 ] );                                             /* Ͳ send parameters */
    SD_SPI1_SENDBYTE( param[ 1 ] );                                             /* Ͳ send parameters */
    SD_SPI1_SENDBYTE( param[ 0 ] );                                             /* Ͳ send parameters */ 
    SD_SPI1_SENDBYTE( 0x95 );                                                   /* CRCУ,ֻڵ1 CRC,only used for the first command */
    
    rlen = 0;
    switch( resptype )                                                          /* ݲͬ,õͬӦ */
    {                                                                           /* according various command,get the various response length */
        case R1:
        case R1B: 
            rlen = 1;  
            break;         
        case R2:  
            rlen = 2;     
            break;         
        case R3:  
            rlen = 5;     
            break;                
        default:  
            SD_SPI1_SENDBYTE( 0xFF );    
            SD_CS_PIN_HIGH( );                         
            return ( SD_ERR_CMD_RESPTYPE );                                     /* Ӧʹ return error of command response type */
    }
    i = 0;                
    do                                                                          /* ȴӦ,ӦĿʼλΪ0 */
    {                                                                           /* Wait for a response,a response is a start bit(zero) */ 
        SD_SPI1_RECVBYTE( tmp );
        i++;
    }while( ( ( tmp & 0x80 ) != 0x00 ) && ( i < SD_CMD_TIMEOUT ) );

    if( i >= SD_CMD_TIMEOUT )
    {                                                 
        SD_CS_PIN_HIGH( );
        return( SD_ERR_CMD_TIMEOUT );                                           /* ʱ return response timeout of command */
    }   
    resp[ 0 ] = 0xfe;
    i = ( rlen - 1 );
    do{
        resp[ i ] = tmp;
        SD_SPI1_RECVBYTE( tmp );                                                /* ѭ8clock  at the last recycle,clock out 8 clock */
    }while(i--);
    SD_CS_PIN_HIGH( );
    return( SD_NO_ERR );                                                        /* ִгɹ return perform sucessfully */
}

/*******************************************************************************
* Function Name  : SD_Read_Register
* Description    : ȡSDĴֵ    
* Input          : buf---ݻ
*                  length---Ҫȡĳ
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_Read_Register( UINT8 *buf , UINT32 length )
{
    UINT8 i,res;
   
    i = 0;
    SD_CS_PIN_LOW( );
    do{
        SD_SPI1_RECVBYTE( res );
        i++;
    }while( ( res == 0xFF ) && ( i < SD_READREG_TIMEOUT ) );  
    if( i > SD_READREG_TIMEOUT ) 
    {
        SD_CS_PIN_HIGH( );
        return( SD_ERR_TIMEOUT_READ );                                          /* ضʱ */            
    }
    if( res != SD_TOK_READ_STARTBLOCK ){                                        /* յʼ not receive data start token */
        buf[ 0 ] = res;                            
        i = 1;                                                                  /* len - 1ֽҪ still len - 1 bytes will be received */
    }
    else 
    {
        i = 0;
    }    
    for( ; i < length; i++ )
    {
        SD_SPI1_RECVBYTE( buf[ i ] );                                           /*  receive data */
    }         
    SD_SPI1_RECVBYTE( i );                                
    SD_SPI1_RECVBYTE( i );                                                      /* ȡ16λCRC get 16-bit CRC */        
    SD_SPI1_SENDBYTE( 0xFF );                                                   /* ֮ǰ8clock  clock out 8 clk before return */
    SD_CS_PIN_HIGH( );        
    return ( SD_NO_ERR );
}

/*******************************************************************************
* Function Name  : SD_Spi_Delay
* Description    : SPIʱ    
* Input          : value---ʱֵ,255
* Output         : None
* Return         : None
*******************************************************************************/
void SD_Spi_Delay( UINT8 value )
{
    UINT8 i;

    for( i = 0; i < value; i++ )
    {
        SD_SPI1_SENDBYTE( 0xFF );                                               /* 0xFF clock out 0xFF */
    }
}

/*******************************************************************************
* Function Name  : SD_Reset
* Description    : λSD,SPIģʽ
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_Reset( void )
{
    UINT8 PARA[ 4 ] = { 0,0,0,0 };
    UINT8 d;
  
    SD_CS_PIN_LOW( );                                                           /* 1. CSΪ assert CS */  
    SD_Spi_Delay( 30 );                                                         /* 2. ʱ 74 clock delay more than 74 clock */
    SD_CS_PIN_HIGH( );                                                          /* 3. CSΪ dessert CS */
    SD_Spi_Delay( 2 );                                                          /* 4. ʱ2(8 clock) delay 2(8 clock) */
    return( SD_SendCmd( CMD0,PARA,CMD0_R,&d ) );
}

/*******************************************************************************
* Function Name  : SD_ReadOCR
* Description    : ȡOCRĴ,,ҪǻȡصSDϢ
* Input          : *buf---ݻ
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_ReadOCR( UINT8 *buf )
{  
    UINT8 PARA[ 4 ] = { 0,0,0,0 };
    UINT8 mStatus, k = 0; 

    Delay_ms( 1 );                                                              /* ʱ */
    while( 1 )
    {
        mStatus = SD_SendCmd( CMD58,PARA,CMD58_R,buf );                         /* ȡCSDĴ */
        if( mStatus )   
        {
            return( mStatus );
        }
        if( buf[ 0 ] != 0x00 ) 
        {
            return( SD_ERR_CMD_RESP );
        }
        k++;
        if( ( k > 0x20 ) && ( ( buf[ 3 ]& 0x80 ) == 0 ) ) 
        {
            return ( SD_Power_Up_Busy );                                        /*ϵæֹɹ,ѭ32ζ */
        }
        else 
        {
            break;
        }    
    }
    if( buf[ 0 ] != 0 )  
    {
        return ( SD_ERR_CMD_RESP );                                             /* شӦ */
    }
    if( ( buf[ 2 ] & 0x30 ) != 0x30 ) 
    {
        return ( SD_ERR_VOL_NOTSUSP );                                          /* ֧3.3V */
    }
    return ( mStatus );
}

/*******************************************************************************
* Function Name  : SD_CRC_OFF
* Description    : ȡCSDĴ
* Input          : *buf---ݻ
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_CRC_OFF( UINT8 *buf )
{  
    UINT8 PARA[ 4 ] = { 0,0,0,0 };
    UINT8 mStatus; 

    Delay_ms( 1 );                                                              /* ʱ */
    while( 1 )
    {
        mStatus = SD_SendCmd( CMD59,PARA,CMD59_R,buf );                         /* ȡCSDĴ */
        if( mStatus )   
        {
            return( mStatus );
        }
        else 
        {
            break;
        }    
    }
    return ( mStatus );
}

/*******************************************************************************
* Function Name  : SD_ReadStatusRegister
* Description    : ȡ״̬Ĵ
* Input          : *buffer---ݻ
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_ReadStatusRegister( UINT8 *buffer )
{
   UINT8 param[ 4 ] = {0,0,0,0};
   
   return( SD_SendCmd( CMD13, param, CMD13_R, buffer ) );                       /* Card StatusĴ */
} 

/*******************************************************************************
* Function Name  : SD_Get_SD_Type
* Description    : ȡSD汾V1.0V2.0
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_Get_SD_Type( void )
{
    UINT8 mStatus,count;
    UINT8 PARA[ 4 ] = { 0x22,0x01,0x00,0x00 };
    UINT8 buf[ 16 ];
    UINT8 i;
    SD_Status.SD_Type = 0x00;                                                   /* ĬSDΪһ */    
    for( count = 0x00; count < 0x02; count++ )
    {
        Delay_ms( 1 );
        mStatus = SD_SendCmd( CMD8,PARA,CMD8_R,buf );                           /* ڶӿʶ */
        if( mStatus ) 
            {
            continue; 
        }
        /* CMD8صĵһֽ,Ϊ0x01Ϊڶ;
           λ2Ϊ1Ϊһ,λ2Ϊ01 */
        for( i=0;i!=5;i++ )printf( "%02x ",(UINT16)buf[i] );
        printf("\n");
        if( buf[ 4 ] == 0x01 )
        {
            SD_Status.SD_Type = 0x01;                                           /* ǰSDΪڶ */    
        }
        else if( ( buf[ 4 ] & 0x04 ) != 0x00 )
        {
            SD_Status.SD_Type = 0x00;                                           /* ǰSDΪһ */                        
        }
        else
        {
            continue;
        }
    }
    return( mStatus );
}

/*******************************************************************************
* Function Name  : SD_Activation
* Description    : ʹSD
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_Activation( void )
{
    UINT8 PARA[ 4 ] = { 0,0,0,0 },res[ 16 ];
    UINT8 mStatus,count;
    UINT32 i = 0; 
      
    for( count = 0x00; count <= 250; count++ )
    {
        /* CMD58 */
        mStatus = SD_SendCmd( CMD58,PARA,CMD58_R,res );                         /* ȡCSDĴ */
        if( mStatus )   
        {
            continue;
        }
        /* CMD55ACMD41 */
        mStatus = SD_SendCmd(CMD55,PARA,CMD55_R,res);                           /* ǰ */
        if( mStatus )  
        {
            continue;
        }
        if( SD_Status.SD_Type )                                                 /* SDΪڶ */
        {
            PARA[ 3 ] = PARA[ 3 ] | 0x40;                                       /* ڶHCS=1 */
        }
        mStatus = SD_SendCmd( ACMD41,PARA,ACMD41_R,res );                       /* SD */
        if( mStatus )  
        {
            continue;
        }
        if( ( res[ 0 ] & 0x01 ) == 0x00 )                                       /* λΪ0,ʼ */
         {
            break;
        }
        Delay_ms( 5 );        
    }
    if( ( i >= 250 ) && ( SD_Status.SD_Type == 0x00 )  )
    {
        /* MMC */    
        for( i = 0x00; i <= 250; i++ )
        {
            mStatus = SD_SendCmd( CMD1,PARA,CMD1_R,res );                       /* ͨϻʾʵCMD1Ҫǲѯǲǳʼ */     
            if( mStatus )  
            {
                continue;
            }
            if( ( res[ 0 ] & MSK_IDLE ) == 0x00 )                               /* ʼ */
            {
                break;        
            }
            Delay_ms( 5 );
        }
        if( i == 250 )
        {
            return( SD_ERR_TIMEOUT_WAITIDLE );                                  /* ʱ,ش */
        }
    }

    for( i = 0x00; i <= 250; i++ )
    {
        Delay_ms( 5 );
         /* CMD58 */
        mStatus = SD_SendCmd( CMD58,PARA,CMD58_R,res );                         /* ȡCSDĴ */
        if( mStatus )   
        {
            continue;
        }
        if( SD_Status.SD_Type == 0x01 )                                         /* ڶSD  */            
        {
            if( ( res[ 3 ] & 0x80 ) == 0x00 )                                   /* SDԴ״̬ */
            {
                continue;    
            }
            SD_Status.SD_Cap_Type = 0x00;                                       /* ǰΪСSD */
            if( ( res[ 3 ] & 0x40 ) == 0x40 )                                   /* ״̬ */
            {
                SD_Status.SD_Cap_Type = 0x01;                                   /* ǰΪSD */    
            }
            break;
        }
        else
        {
            break;
        }
    }
    if( i == 250 )
    {
        return( SD_ERR_TIMEOUT_WAITIDLE );                                      /* ʱ,ش */
    }
    return ( mStatus );
}

/*******************************************************************************
* Function Name  : SD_TYPE
* Description    : ֽд
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 SD_TYPE( void )
{
    UINT8 PARA[ 4 ] = { 0,0,0,0 },res[ 100 ];
    UINT8 mStatus,count;
    UINT8 *pbuf = res;
    UINT32 i = 0; 
    UINT32 tmp,timeout=0xfffff;

    for( count = 0x00; count <= 250; count++ )
    {
        /* CMD55 */
        mStatus = SD_SendCmd(CMD55,PARA,CMD55_R,res);                           /* ǰ */
        if( mStatus )  
        {
            continue;
        }
        mStatus = SD_SendCmd( ACMD13,PARA,ACMD13_R,res );                       /* SD */
        if( mStatus )  
        {
            continue;
        }
        if( ( res[ 0 ] & 0x01 ) == 0x00 )                                       /* λΪ0,ʼ */
         {
            break;
        }
        Delay_ms( 5 );        
    }
    SD_CS_PIN_LOW( );
    i = 0;
    do
    {                                                                           /* ȴݿʼ0xFE  wait for receiving data start token 0xFE */
        SD_SPI1_RECVBYTE( tmp );
        i++;
    }while( ( tmp == 0xFF ) && ( i < timeout ) );                               /* 0xFE */
    if( i >= timeout ) 
    {
        SD_CS_PIN_HIGH( );
        return( SD_ERR_TIMEOUT_READ );
    }
    if( tmp != SD_TOK_READ_STARTBLOCK )                                         /* ʼƴ */
    {
        SD_SPI1_SENDBYTE( 0xFF );
        SD_CS_PIN_HIGH( );
        return( SD_ERR_DATA_START_TOK );
    }
    for( i=0;i!=64;i++ )res[i] = 0;  
    /* ȡ32ֽ */ 
    for( i=0;i!=4;i++ ){
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
        SD_SPI1_RECVBYTE( *pbuf++ );                                            /* ȡһֽ */
    }
    SD_SPI1_RECVBYTE( i );                                
    SD_SPI1_RECVBYTE( i );                                                      /* ȡ16λCRC get 16-bit CRC */
    SD_SPI1_SENDBYTE( 0xFF ); 
    SD_CS_PIN_HIGH( );
    return mStatus;
}


/*******************************************************************************
* Function Name  : SD_Get_Information
* Description    : ȡSDϢ
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_Get_Information( void )
{
    UINT8 mStatus,tmp;
    UINT8 PARA[ 4 ] = {0,0,0,0};
    UINT8 buf[ 16 ];

    Delay_ms( 1 );
    mStatus = SD_SendCmd( CMD9,PARA,CMD9_R,buf );                               /* OCRĴ */
    if( mStatus ) 
    {
        return ( mStatus ); 
    }
    mStatus = SD_Read_Register( buf,16 );
    if( mStatus ) 
    {
        SD_CS_PIN_HIGH( );
        return ( mStatus );
    }
    /* SDĴ,һ桢ڶ治һ */
    if( ( buf[ 0 ] & 0x80 ) == 0x80 )                                           /* CSDݴ,0 */
    {
        return( SD_ERR_VOL_NOTSUSP );    
    }
    else
    {
        /* READ_BL_LEN: λ83--80: 1001------512byte */
        sds.block_len = 1 << ( buf[ 5 ] & 0x0F );
        if( sds.block_len < 512 )  
        {
            return ( SD_BLOCK_ERROR );
        }
        if( ( buf[ 0 ] & 0x40 ) == 0x40  )                                      /* CSDṹ汾:ڶ */
        {
            /* ڵڶ:
               λ83--80:------READ_BL_LEN: 
               λ69--48:------C_SIZE    
                = READ_BL_LEN * ( C_SIZE + 1 ) */
            sds.block_num = ( ( UINT32 )( buf[ 7 ] & 0x3F ) ) << 16 ;
            sds.block_num += ( UINT32 )buf[ 8 ] << 8;
            sds.block_num += ( UINT32 )buf[ 9 ];
            sds.block_num = sds.block_num << 10;

            /*  */
            sds.SD_Capability = ( ( UINT32 ) sds.block_len ) * ( ( UINT32 )( sds.block_num / 1024 ) );
        }
        else                                                                    /* CSDṹ汾:һ */
        {
            /* ڵһ:
               λ83--80:------READ_BL_LEN: 
               λ73--62:------C_SIZE
               λ49--47:------C_SIZE_MULT 

               BLOCKNR = ( C_SIZE + 1 ) * MULT
               MULT = ( C_SIZE_MULT < 8 ) * 2 ^ ( C_SIZE_MULT + 2 )
               BLOCK_LEN = ( READ_BL_LEN < 12 ) * 2 ^ ( READ_BL_LEN )
               洢 = BLOCKNR * BLOCK_LEN */

            /* C_SIZE_MULT */
            tmp  = ( buf[ 9 ] & 0x03 ) << 1;
            tmp += ( ( buf[ 10 ]& 0x80 ) >> 7 ) + 2;             
            /* C_SIZE */
            sds.block_num  = ( buf[ 6 ] & 0x03 ) << 10;
            sds.block_num += ( buf[ 7 ] << 2 );
            sds.block_num += ( ( buf[ 8 ] & 0xc0 ) >> 6 );
            /* ÿп */                                         
            sds.block_num = ( sds.block_num ) * ( 1 << tmp );                
            /*  */
            sds.SD_Capability = ( ( UINT32 ) sds.block_len ) * ( ( UINT32 ) ( sds.block_num / 1024 ) );
        }
        printf( "sds.block_len = %d\n",(UINT16)sds.block_len );    
        printf("sds.block_num = %08ld\n",( UINT32 )sds.block_num );
        sds.block_num =  sds.SD_Capability*2;
        printf("SD_Capability =  %f G\n",( float )( ( ( float )( sds.SD_Capability / 1024 ) / 1024 )  )  );  
    }
    return( mStatus );
}

/*******************************************************************************
* Function Name  : SD_Set_Blocklen
* Description    : ÿ鳤
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_Set_Blocklen( UINT16 blocklen )
{
   UINT8 PARA[ 4 ],mStatus,res;
   
   PARA[ 3 ] = 0x00;
   PARA[ 2 ] = 0x00;
   PARA[ 1 ] = ( UINT8 )( blocklen >> 8 );
   PARA[ 0 ] = ( UINT8 )( blocklen );
   mStatus = SD_SendCmd( CMD16,PARA,CMD16_R,&res );
   return  ( mStatus );
}

/*******************************************************************************
* Function Name  : SD_Init
* Description    : SDʼ
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_Init( void )
{
    UINT8 s,i,mStatus;
    UINT8 buf[ 16 ];

    SD_Status.SD_Type = 0x00;                                                   /* ĬΪV1.0 */            
    SD_Status.SD_Cap_Type = 0x00;                                               /* ĬΪ׼ */    
    SD_Status.SD_Write_Pro = 0x00;                                              /* ĬSDδд */

    /* 豸Ƿд */
    s=SD_Check_WP( );
    printf("S=%02x",s);    
    SD_Status.SD_Write_Pro = 0x00;                                             
    printf("SD_Status.SD_Write_Pro=%02x\n",(UINT16)SD_Status.SD_Write_Pro);
    /* һʼǰ׼ */
    SD_CS_PIN_HIGH( );                                                          /* ֹƬѡ */
    Delay_ms( 5 );    
    SD_CS_PIN_LOW( );                                                           /* Ƭѡ */
    Delay_ms( 5 );    
    for( i = 0x00; i < 250; i++ )
    {
        SD_SPI1_SENDBYTE( 0xFF );    
    }
    SD_CS_PIN_HIGH( );                                                          /* ֹƬѡ */
    printf("wait sd card in:\n");
    while( SD_Check_Insert( ) != TRUE  );                                       /* ȴSD */
    Delay_ms( 50 );    
    /* λSD,ִ: CMD0 */      
    i = 0;
    while( 1 )          
    {
        mStatus = SD_Reset( );                                                              
        if( ( !mStatus ) ) 
        {
            break;
        }
        if( i++ > 0x50 ) break; 
    }
    if( mStatus ) 
    {
        return( mStatus );
    }
    printf("reset\n");
    Delay_ms( 50 );    

    /* ⵱ǰSD汾(V1.0V2.0),ִ: CMD8 */      
    mStatus = SD_Get_SD_Type( );    
    if( mStatus ) 
    {
        return( mStatus );
    }  
    mStatus = SD_CRC_OFF( buf );
    printf("s5=%02x\n",(UINT16)mStatus);

    /* ġȡOCR,ִ: CMD58 */
    mStatus = SD_ReadOCR( buf );
    if( mStatus ) 
    {
        return( mStatus );
    }
    /* 塢SD */
    mStatus = SD_Activation( );                                                          
    if( mStatus ) 
    {
        return( mStatus );
    }
    printf("SD_Status.SD_Cap_Type=%02x\n",(UINT16)SD_Status.SD_Cap_Type);
    printf("s0\n");    
    /* һSD,ҪÿĴСΪ512ֽ */
    if( SD_Status.SD_Type )
    {    
        mStatus = SD_Set_Blocklen( 512 );                                       /* ÿСΪ512ֽ */
        if( mStatus ) 
        {
            return( mStatus );
        }
    }
    SD_TYPE();
    /* ߡȡSDϢ,SD */
    mStatus = SD_Get_Information( ); 
    if( mStatus ) 
    {
        return( mStatus );
    }    
    printf("SD Card is V%x.0\n",( UINT16 )SD_Status.SD_Type + 1 );    
    printf("SD Card Cap_Type is %x \n",( UINT16 )SD_Status.SD_Cap_Type );
    /* ˡʼ֮,SPIӿٶΪģʽ */
    SD_SPI_HighSpeed_Set( );
    return( mStatus );
}

/*******************************************************************************
* Function Name  : SD_StopTransmission
* Description    : ǿֹͣ
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_StopTransmission( void )
{
    UINT8 PARA[ 4 ] = {0,0,0,0};
    UINT8 d;
  
    return( SD_SendCmd( CMD12,PARA,CMD12_R, &d ) );
}

/*******************************************************************************
* Function Name  : SD_ReadMultiBlock
* Description    : ȡ飬ֱCMD12űֹ
* Input          : startadress---ʼBlockַ
*                  *buf---
*                  blockmun---ȡĿС
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_ReadMultiBlock( UINT32 startadress, UINT8 *buf, UINT32 blockmun )
{
    UINT8  PARA[ 4 ],rep,tmp,mStatus;
    UINT32 i = 0, timeout = 0xfFFFF;
    UINT32 k;
    UINT8  *pbuf;

    PARA[ 3 ] = ( UINT8 )( startadress >> 24 );
    PARA[ 2 ] = ( UINT8 )( startadress >> 16 );
    PARA[ 1 ] = ( UINT8 )( startadress >> 8 );
    PARA[ 0 ] = ( UINT8 )( startadress );
    mStatus = SD_SendCmd( CMD18, PARA, CMD18_R, &rep );
    if( mStatus ) 
    {
        return( mStatus ); 
    }
    pbuf = buf;
    for( k = 0; k != blockmun; k++ ){
        SD_CS_PIN_LOW( );
        i = 0;
        do
        {                                                                       /* ȴݿʼ0xFE  wait for receiving data start token 0xFE */
            SD_SPI1_RECVBYTE( tmp );
            i++;
        }while( ( tmp == 0xFF ) && ( i < timeout ) );                           /* 0xFE */
        if( i >= timeout ) 
        {
            SD_CS_PIN_HIGH( );
            return( SD_ERR_TIMEOUT_READ );
        }
        if( tmp != SD_TOK_READ_STARTBLOCK )                                     /* ʼƴ */
        {
            SD_SPI1_SENDBYTE( 0xFF );
            SD_CS_PIN_HIGH( );
            return( SD_ERR_DATA_START_TOK );
        }
        i = 16;
        do
        {   
            /* ȡ32ֽ */ 
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            SD_SPI1_RECVBYTE( *pbuf++ );                                        /* ȡһֽ */
            i--;            
        }while( i ); 
        SD_SPI1_RECVBYTE( i );                                
        SD_SPI1_RECVBYTE( i );                                                  /* ȡ16λCRC get 16-bit CRC */
        SD_SPI1_SENDBYTE( 0xFF ); 
        SD_CS_PIN_HIGH( );
    } 
    mStatus = SD_StopTransmission( );
    mStatus = SD_StopTransmission( );                                           /* ע:˴Ƿ, */    
    SD_CS_PIN_LOW( );
    for( i=0;i!=50;i++ )SD_SPI1_SENDBYTE( 0xFF );
    SD_CS_PIN_HIGH( );
    return( mStatus );
}

/*******************************************************************************
* Function Name  : SD_StopMultiToken
* Description    : Ͷдֹͣ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SD_StopMultiToken( void )
{
    UINT8  i;

    i = i;                                                                      /* ȥ */
    SD_CS_PIN_LOW( );
    SD_SPI1_SENDBYTE( 0xFF );                                                   /* ȷ8clock send 8 clock first */
    SD_SPI1_SENDBYTE( SD_TOK_STOP_MULTI );                                      /* ֹͣݴ send stop transmission token */
    SD_SPI1_RECVBYTE( i );
    SD_CS_PIN_HIGH( );
}

/*******************************************************************************
* Function Name  : SD_WriteMultiBlock
* Description    : д
* Input          : startadress---ʼBlockַ
*                  *buf---
*                  blockmun---дĿС
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 SD_WriteMultiBlock( UINT32 startadress, UINT8 *buf, UINT32 blockmun )
{
    UINT8  PARA[ 4 ], rep, tmp, mStatus;
    UINT32 i = 0, timeout = 0xfffff, k;
 
    PARA[ 3 ] = ( UINT8 )( startadress >> 24 );
    PARA[ 2 ] = ( UINT8 )( startadress >> 16);
    PARA[ 1 ] = ( UINT8 )( startadress >> 8);
    PARA[ 0 ] = ( UINT8 )( startadress );
    mStatus = SD_SendCmd( CMD25,PARA,CMD25_R,&rep );
    if( mStatus )  
    {    
        return( mStatus ); 
    }
    for( k = 0; k != blockmun; k++ )
    {
        SD_CS_PIN_LOW( );
        SD_SPI1_SENDBYTE( 0xFF );
        SD_SPI1_SENDBYTE( 0XFC );                                               /* Ϳʼư,ʾдBLOCK,ʾʼ */
    
        i = 16;
        do
        {
            /* һԷ32ֽѭ */
            SD_SPI1_SENDBYTE( *buf++ );                                         /* 1 */
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );                                        
            SD_SPI1_SENDBYTE( *buf++ );                                         /* 10 */    
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );                                         /* 20 */
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );                                         /* 30 */
            SD_SPI1_SENDBYTE( *buf++ );
            SD_SPI1_SENDBYTE( *buf++ );
            i--;
        }while( i );
        SD_SPI1_SENDBYTE( 0x81 );                                               /* CRC16У send CRC16 check code */
        SD_SPI1_SENDBYTE( 0x81 );                                               /* CRC16У send CRC16 check code */
       
        SD_SPI1_RECVBYTE( i );                                                  /* Ӧ */
        if( ( i & SD_RESP_DATA_MSK ) != SD_RESP_DATA_ACCETPTED )    
        {        
            SD_SPI1_SENDBYTE( 0xFF );                                           /* ֮ǰ8clock  clock out 8 clk before return */
            SD_CS_PIN_HIGH( );
            return( SD_ERR_DATA_RESP );                                         /* Ӧ data response error */
        }         
        SD_CS_PIN_HIGH( );        
        SD_CS_PIN_LOW( );
        i = 0;
        do
        {                                                                       /* ȴæ wait for being busy end */
            SD_SPI1_RECVBYTE( tmp );                                            /* Ϊ0ʱʾæ */
            i++;
        }while( ( tmp != 0xFF ) && ( i < timeout ) );                           /* æʱյֵΪ0 always receive 0 when card is busy */    
        if( i > timeout )
        {
            SD_CS_PIN_HIGH( );
            return( SD_ERR_TIMEOUT_WAIT );
        }  
        SD_SPI1_SENDBYTE( 0xFF );
        SD_CS_PIN_HIGH( );            
    }
    /* ǿƽݴ */
    SD_StopMultiToken( );                                                       /* ͽ */
    SD_CS_PIN_LOW( );                                 
    i = 0;
    do
    {                                                                           /* ȴæ wait for being busy end */
        SD_SPI1_RECVBYTE( tmp );                                                /* Ϊ0ʱʾæ */
        i++;
    }while( ( tmp != 0xFF ) && ( i < timeout ) );                               /* æʱյֵΪ0 always receive 0 when card is busy */    
    if( i > timeout )
    {
        SD_CS_PIN_HIGH( );
        return(    SD_ERR_TIMEOUT_WAIT );
    }
    SD_SPI1_SENDBYTE( 0xFF ); 
    SD_CS_PIN_HIGH( );
    /* жǷдȷ */
    mStatus = SD_ReadStatusRegister( PARA );
    if( mStatus )  
    {    
        SD_CS_PIN_HIGH( );
        return( mStatus );
    }
    if( ( PARA[ 0 ] != 0 ) || ( PARA[ 1 ] != 0 ) )
    {
        mStatus = SD_ERR_WRITE_BLK;
        SD_CS_PIN_HIGH( );
    }
    SD_CS_PIN_LOW( );                                 
    for( i=0;i!=50;i++ )SD_SPI1_SENDBYTE( 0xFF );
    SD_CS_PIN_HIGH( );
    return( mStatus );
}

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    while( 1 );
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void FIQ_Handler( void )
{
    while( 1 );
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void ) 
{
    UINT8  status;
    UINT8  buf1[1024];
    UINT32 i;

    Delay_ms( 100 );
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */
    printf("SD_Start!\n");
    SD_Port_Init( );

    SD_Init( );
    status = SD_ReadMultiBlock(0,buf1,1);
    printf("status***************:%02x\n",status);
    for(i=0;i<512;i++) printf("buf1:%d-%02x\n",i,buf1[i]);
    for(i=0;i<512;i++) buf1[i] =i;
    status  = SD_WriteMultiBlock(0x03,buf1,1);
    printf("status###################:%02x\n",status);
}

/*********************************** endfile **********************************/
