/********************************** (C) COPYRIGHT *******************************
* File Name          : CAT.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH56X CAT DEMO
*                      (1)CH56X Examples by KEIL;
*                      (2)0Ϣ,115200bps;
*                      (3)ARM9-CH56XƬCԵĲʾ,
*                           ʾʱ0ܣʱ123ƣ֮֮ͬͬڳעָ;
*                           PB1ŵһߵƽߵ͵ƽ
*                           ߵ͵ƽʱ816ʱڣѡ񣩣ʱPclk*(2^27),PclkΪϵͳʱ.
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"

/******************************************************************************/
/*  */
UINT32 Capture;   /* 沶ֵ */
UINT8 FLAG=0;     /* FLAGΪ1ʱʾбش */

/* һLEDڼʾĽ,͵ƽLED */
#define LED                     1<<3

#define LED_OUT_INIT(  )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }         /* LED ߵƽΪ */
#define LED_OUT_ACT(  )      { R32_PB_CLR |= LED; }                            /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT(  )    { R32_PB_OUT |= LED; }                            /* LED ߵƽرLEDʾ */

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void IRQ_Handler( void )
{
    UINT8 i;
    if(R8_INT_FLAG_0&RB_IF_TMR0){
        i= R8_TMR0_INT_FLAG;
        if(i&RB_TMR_IF_DATA_ACT){                                               /* ƽ仯ж */
            R8_TMR0_INT_FLAG = RB_TMR_IF_DATA_ACT | RB_TMR_IF_FIFO_HF |
                               RB_TMR_IF_FIFO_OV;                               /* Ӧжϱ־ */
            R8_INT_FLAG_0 |= RB_IF_TMR0;                                        /* Ӧжϱ־ */
            Capture=R32_TMR0_FIFO;                                              /* 񵽵ʱֵ */
            FLAG = 1;   
        }                
        if(i&RB_TMR_IF_CYC_END){                                                /* ʱж */
            R8_TMR0_INT_FLAG=0xff;                                              /* Ӧжϱ־ */
            R8_INT_FLAG_0 |= RB_IF_TMR0;                                        /* Ӧжϱ־ */
            R32_TMR0_FIFO;
            PRINT("overtime\n") ;
        }
    }
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : IRQ_Init
* Description    : IRQжϳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void IRQ_Init( void )
{    
    /* ежϱ־ */    
    R8_TMR0_INT_FLAG=RB_TMR_IF_DATA_ACT|RB_TMR_IE_CYC_END|RB_TMR_IF_FIFO_HF|RB_TMR_IF_DMA_END|RB_TMR_IF_FIFO_OV|RB_TMR_IF_DMA_ERR;                                                                   
    R8_TMR0_INTER_EN=RB_TMR_IE_DATA_ACT|RB_TMR_IE_CYC_END;                      /* ģʽеƽ仯жʹܣģʽ²ʱжʹ */
    R8_INT_EN_IRQ_0=RB_IE_IRQ_TMR0;                                             /* ʱ0жϲ */
    R8_INT_EN_IRQ_GLOB= RB_IE_IRQ_GLOB;                                         /* ֻIRQȫж */
}

/*******************************************************************************
* Function Name  : Timer0_Init
* Description    : ʱ0ʼ
* Input          : max_time--  Ϊʱʱãʱʱtime = Pclk*max_time, PclkΪϵͳʱ
*                  min_time--  С:0:16ʱ,1:8ʱ
*                  catch_edge--ģʽ±شʽ:    00:ô,01:καشʱ,10:½ص½֮ʱ,
*                              11:ص֮ʱ
* Output         : None
* Return         : None
*******************************************************************************/

void Timer0_Init( UINT32 max_time ,UINT8 min_time,UINT8 capture_edge  ) 
{
    R32_PB_PU|=0x00000002;                                                      /*     */
    R32_PB_DIR&=0xfffffffd;                                                     /* PB1Ϊ */
    R8_TMR0_CTRL_MOD=(RB_TMR_CATCH_EDGE&(capture_edge<<6))|RB_TMR_MODE_IN|(RB_TMR_CAT_WIDTH&(min_time<<3));
                                                                                /* شʽ,ģʽ,8ʱڲ */
    R32_TMR0_CNT_END=max_time;                                                  /* ʱʱ */
    R8_TMR0_CTRL_MOD|=(RB_TMR_COUNT_EN|RB_TMR_OUT_EN);                          /* ʱ */
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : UART1_SendByte
* Description    : ͨڷһֽ
* Input          : dat--Ҫ͵һֽ
* Output         : None
* Return         : None
*******************************************************************************/

void UART1_SendByte( UINT8 dat )   
{        
    R8_UART1_THR  = dat;
    while( ( R8_UART1_LSR & RB_LSR_TX_ALL_EMP ) == 0 );                         /* ȴݷ */         
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void ) 
{
    LED_OUT_INIT( );
    LED_OUT_ACT( );                                                             /* LEDһʾ */ 
    Delay_ms( 100 );
    LED_OUT_INACT( );
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */
    PRINT( "Start Capture demo\xd\xa" );
    IRQ_Init( );                                                                /* жϳʼ */
    Timer0_Init( 0x0fffffff,1,1);                                               /* ʱʱ䣬СΪ8ʱӣش */
    while ( 1 ){
        if(FLAG){
            FLAG = 0;
            if(Capture&(1<<27))                                                 /* ĴR32_TMR_FIFOֵλΪ1ʾƽΪߵƽ,֮Ϊ͵ƽ */
                PRINT("Hig=%ld\n",(Capture&0x07ffffff));
            else
                PRINT("Low=%ld\n",Capture);
        }   
    }
}

/*********************************** endfile **********************************/
