/********************************** (C) COPYRIGHT *******************************
* File Name          : COUNT.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH56X COUNT DEMO
*                      (1)CH56X Examples by KEIL;
*                      (2)0Ϣ,115200bps;
*                      (3)ARM9-CH56XƬCԵļʾ,
*                           ʾʱ3ܣ
*                           PB6ŵźżʱ816ʱ.
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"

/******************************************************************************/
/*  */

/* һLEDڼʾĽ,͵ƽLED */
#define LED                     1<<3

#define LED_OUT_INIT(  )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }          /* LED ߵƽΪ */
#define LED_OUT_ACT(  )      { R32_PB_CLR |= LED; }                             /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT(  )    { R32_PB_OUT |= LED; }                             /* LED ߵƽرLEDʾ */

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void IRQ_Handler( void )
{
    UINT8 i;

   PRINT( "irq#  " );
   if(R8_INT_FLAG_0&RB_IF_TMR3){
       i= R8_TMR3_INT_FLAG;
       if(i&RB_TMR_IF_CYC_END){                                                /* ʱж */
            R8_TMR3_INT_FLAG=0xff;                                             /* Ӧжϱ־ */
            R8_INT_FLAG_0 |= RB_IF_TMR3;                                       /* Ӧжϱ־ */
            R32_TMR3_FIFO;
        }
    }
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : IRQ_Init
* Description    : IRQжϳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void IRQ_Init( void )
{    
    R8_TMR0_INT_FLAG   = RB_TMR_IF_DATA_ACT|RB_TMR_IE_CYC_END|RB_TMR_IF_FIFO_HF|
                         RB_TMR_IF_DMA_END|RB_TMR_IF_FIFO_OV|RB_TMR_IF_DMA_ERR; /* ежϱ־ */    
    R8_TMR3_INTER_EN   = RB_TMR_IE_CYC_END;                                     /* ֵжʹ */
    R8_INT_EN_IRQ_0    = RB_IE_IRQ_TMR3;                                        /* ʱ3жϲ */
    R8_INT_EN_IRQ_GLOB = RB_IE_IRQ_GLOB;                                        /* ֻIRQȫж */
}

/*******************************************************************************
* Function Name  : Timer3_Init
* Description    : ʱ3ʼ
* Input          : count_end-- ֵ
*                  min_time--  С:0:16ʱ,1:8ʱ
*                  catch_edge--ģʽ  
* Output         : None
* Return         : None
*******************************************************************************/

void Timer3_Init( UINT32 count_end ,UINT8 min_time,UINT8 capture_edge  ) 
{
    R32_PB_PU |= CAT3;                                                          /*     */
    R32_PB_DIR &= ~CAT3;                                                    
    R8_TMR3_CTRL_MOD = RB_TMR_CATCH_EDGE&(capture_edge<<6) | 
                       (RB_TMR_CAT_WIDTH&(min_time<<3)) | RB_TMR3_MODE_COUNT;    
    R32_TMR3_CNT_END = count_end;                                               /* ʱʱ */
    R8_TMR3_CTRL_MOD |= RB_TMR_COUNT_EN ;                                       /* ʱ */
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void ) 
{
    LED_OUT_INIT( );
    LED_OUT_ACT( );                                                             /* LEDһʾ */ 
    Delay_ms( 100 );
    LED_OUT_INACT( );
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */
    PRINT( "TIM3 count demo\xd\xa" );
    IRQ_Init( );                                                                /* жϳʼ */
    Timer3_Init( 10,1,1);                                               
    while ( 1 ){
        PRINT( "COUNT =%-8x",R32_TMR3_COUNT );
    }
}

/*********************************** endfile **********************************/
