/********************************** (C) COPYRIGHT *******************************
* File Name          : PWM_DMA.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH56X PWM_DMA DEMO
*                      (1)CH56X Examples by KEIL;    
*                      (2)0Ϣ,115200bps;
*                      (3)ARM9-CH56XƬCԵĶʱͨDMAʽΪ20msռձȲϸıPWMʾ             
*                           ʾʱ0PWMܣʱ123ƣ֮֮ͬͬڳעָ;  
*                           ͨPB020msPWMΣεռձͨ˳ڣһߵƽ100US͵ƽ
*                           ʱΪ(20ms-100us),˲ظ16;ڶߵƽ100us+100us(Ժÿߵƽʱ100us)
*                           ˲ظ16еDMA䣬Դֱ100β;PMMPB0.
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"

/******************************************************************************/
/* ͷļ */
UINT32 FIFO_DMA[100]={0};    /* ݻ */

/* һLEDڼʾĽ,͵ƽLED */
#define LED                     1<<3

#define LED_OUT_INIT(  )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }         /* LED ߵƽΪ */
#define LED_OUT_ACT(  )      { R32_PB_CLR |= LED; }                            /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT(  )    { R32_PB_OUT |= LED; }                            /* LED ߵƽرLEDʾ */

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void IRQ_Handler( void )
{
    UINT8 i;

    if(R8_INT_FLAG_0&RB_IF_TMR0){
        i= R8_TMR0_INT_FLAG;
        if(i&RB_TMR_IF_DMA_END){
            R16_TMR0_DMA_NOW = (UINT32)FIFO_DMA;
            for( i=0;i!=100;i++ ){
                if(i%16 == 0)PRINT("\n");
                PRINT("%-8x",FIFO_DMA[i]);
            }
            PRINT("\n");
            R8_TMR0_INT_FLAG=RB_TMR_IF_DMA_END;                                 /* Ӧжϱ־ */
            R8_INT_FLAG_0 |= RB_IF_TMR0;                                        /* Ӧжϱ־ */
            R8_TMR0_CTRL_MOD&=0xf7;                                             /* رնʱ */
            R8_TMR0_INTER_EN&=0xf7;                                             /* رDMAʹж */
            PRINT("DMA OVER\n");                                                /* DMA򲻶DMA OVER */
        }
    }
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : IRQ_Init
* Description    : IRQжϳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void IRQ_Init( void )
{
    R8_TMR0_INT_FLAG=0xff;                                                      /* ежϱ־ */                                           
    R8_TMR0_INTER_EN=RB_TMR_IE_DMA_END;                                         /* ֻDMAж */
    R8_INT_EN_IRQ_0=RB_IE_IRQ_TMR0;                                             /* ֻʱ0жϲ */
    R8_INT_EN_IRQ_GLOB= RB_IE_IRQ_GLOB;                                         /* ֻIRQȫж */
}

/*******************************************************************************
* Function Name  : Timer0_Init
* Description    : ʱ0ʼ
* Input          : end    -ʱ0ʱڣʱTime = Pclk*end, PclkΪϵͳʱ
*                  repeat -PWMԴ00:ظ1Σ01:ظ4Σ10:ظ8Σ11:ظ16
* Output         : None
* Return         : None
*******************************************************************************/

void Timer0_Init( UINT32 end ,UINT8 repeat ) 
{
    R32_PB_DIR |= PWM0;                                                         /* PB0Ϊʱ0ţΪ */
    R8_TMR0_CTRL_MOD=(RB_TMR_PWM_REPEAT&(repeat<<6));                           /* PWMģʽĬΪߵƽʱʱ/PWMģʽ*/
    /* TIM1TIM2,ҪRB_TMR_MODE_NRZIλ0                        */
    /* ĬR8_TMR0_CTRL_MODλRB_TMR_ALL_CLEARΪ1ʼʱѴλ0*/
    /* R32_TMR0_FIFOʹֵɹҲܹ,R32_TMR0_CNT_ENDֵɹ  */
    /* Ӱ */
    R32_TMR0_CNT_END=end;                                                       /* PWM */
    R8_TMR0_CTRL_DMA= (RB_TMR_DMA_ENABLE)|(RB_TMR_DMA_LOOP&0);                  /* DMAֹDMAѭ */
    R8_TMR0_CTRL_MOD|=(RB_TMR_COUNT_EN|RB_TMR_OUT_EN);                          /* ʱ */
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void ) 
{
    UINT32    i,j=1000;
    LED_OUT_INIT( );
    LED_OUT_ACT( );                                                             /* LEDһʾ */
    Delay_ms( 100 );
    LED_OUT_INACT( );
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */
    LED_OUT_ACT( );
    LED_OUT_INACT( );
    PRINT( "Start PWM_DMA DEMO:\n" );
    /* FIFO_DMAһֵȴR32_TMR0_FIFOĴR32_TMR0_FIFOĴǲPWMռձȣ*/
    /* PWMɲҼR32_TMR0_CNT_ENDֵʱFIFO_DMAڶֵR32_TMR0_FIFOĴ    */
    /* ֱһԪֵR32_TMR0_FIFOʱDMA                                            */
    for(i=0;i<10;i++)FIFO_DMA[i]=(j*i+j);                            
    R16_TMR0_DMA_BEG=(UINT32)FIFO_DMA;                                          /* ׵ַDMAʼַ */
    R16_TMR0_DMA_END=(UINT32)(&FIFO_DMA[10]);                                   /* ĽַDMAַ */
    IRQ_Init( );                                                                /* жϳʼ */
    Timer0_Init( 2000000,3 );                                                   /* PWMΪ20ms,ÿPWMԴΪ16 */
    while(1);
}

/*********************************** endfile **********************************/
