/********************************** (C) COPYRIGHT *******************************
* File Name          : PWM_WAVE.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH56X ADC_QUERY DEMO
*                      (1)CH56X Examples by KEIL;    
*                      (2)0Ϣ,115200bps;
*                      (3)ʾʱ0PWM.һƵݡ
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"
#include "WAVE.H"

/******************************************************************************/
/*  */
extern UINT8 sound[];                                                           /* ԭwave.cļ */
extern UINT8 *pdata_addr;                                                       /* ݿʼλõĵַⲿԭwave.cļ */
extern UINT32 datasize;                                                         /* ʵݴӳȣⲿԭwave.cļ */
extern UINT32 CountEnd;
UINT8 PWM_Flag = 0;
UINT8 PlayTimes = 0;
UINT8 *pdata_now;
/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void IRQ_Handler( void )
{
    UINT8 i;

    if(R8_INT_FLAG_0 & RB_IF_TMR0){                                             /* жǲǶʱ0صж */
        i= R8_TMR0_INT_FLAG;
        if(i&RB_TMR_IF_CYC_END){
            PlayTimes++;                                                        /* Ŵ */
            if(PlayTimes==4){                                                   /* ͬһݲŴpwmƵʣʹЧ */
                R32_TMR0_FIFO = (UINT32)(CountEnd*((*pdata_now)/256.0));        /* ݲֵӦзֵֵ */
                pdata_now++;                                                    /* ָԼ */
                if((pdata_now-pdata_addr)>datasize){                            /* ڲŵļĽβˣô¿ʼ */
                    R8_INT_EN_IRQ_0 &= ~RB_IE_IRQ_TMR0;                         /* ʧܶʱ0жϲ */
                    R8_INT_EN_IRQ_GLOB &= ~RB_IE_IRQ_GLOB;                      /* رIRQȫж */
                    PRINT("Play End\n");                                        /* ӡϢ */
                    goto IRQ_End;                                               /* תжϺ */
                }
                PlayTimes = 0;
            }
IRQ_End:
            R8_TMR0_INT_FLAG=RB_TMR_IF_CYC_END;                                 /* Ӧжϱ־ */
            R8_INT_FLAG_0 |= RB_IF_TMR0;                                        /* Ӧжϱ־ */
        }
    }
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : IRQ_Init
* Description    : IRQжϳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void IRQ_Init( void )
{
    R8_TMR0_INT_FLAG=0xff;                                                      /* ежϱ־ */
    R8_TMR0_INTER_EN=RB_TMR3_FORCE_EN|RB_TMR_IE_CYC_END|RB_TMR_IE_DATA_ACT;;    /* ʱʱڽжʹܣPWM жʹ */
    R8_INT_EN_IRQ_0=RB_IE_IRQ_TMR0;                                             /* ʱ0жϲ */
    R8_INT_EN_IRQ_GLOB= RB_IE_IRQ_GLOB;                                         /* ֻIRQȫж */
}

/*******************************************************************************
* Function Name  : Timer0_Init
* Description    : ʱ0ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Timer0_Init( UINT32 end )
{
    R8_TMR0_CTRL_MOD=0x00;                                                      /* RB_TMR_MODE_COUNTλ0 */
    R32_PB_DIR|=PWM0;                                                           /* PB0Ϊʱ0ţΪ */
    R32_TMR0_CNT_END=end;                                                       /* PWM */
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/
int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : main
* Description    : I
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void )
{
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */
    PRINT("System Init OK\n");
    IRQ_Init( );                                                                /* жϳʼ */
    filehead_load(sound);                                                       /* еݣȡвصϢ */
    Timer0_Init( CountEnd );                                                    /* ݲβļֵдĴ */
    pdata_now = pdata_addr;
    R32_TMR0_FIFO=(UINT32)(CountEnd*((*pdata_now)/256.0));                      /* еĵһݷ */
    R8_TMR0_CTRL_MOD|=(RB_TMR_COUNT_EN|RB_TMR_OUT_EN);                          /*  */
    while(1);
}

/*********************************** endfile **********************************/
