/********************************** (C) COPYRIGHT *******************************
* File Name          : USB_DEVICE.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563 USB_Device Example
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include  <stdio.h>
#include  <string.h>
#include  "CH563BAS.H"                                                          /* оƬͶͷļ */    
#include  "CH563SFR.H"                                                          /* оƬĴͷļ */
#include  "SYSFREQ.H"                                                           /* ϵͳͷļ */
#include  "CH563USBSFR.H"                                                       /* оƬUSBĴͷļ */    
#include  "CH563USB.H"                                                          /* USBöͷļ */    
#include  "USB_DEVICE.H"                                                        /* USB豸ͷļ */
#include  "PRINTF.H"                                                            /* ڴӡͷļ */
#include  "AUDIO.H"


UINT32 MyBuf[1024];
UINT32 count=0;
/******************************************************************************/
/* 豸 */
const UINT8 MyDevDescr[ ] = {
 0x12,            //Length            
 0x01,            //DescriptorType:Descriptor
 0x00, 0x02,      //USB2.0
 0x00,            //bDeviceClass
 0x00,            //bDeviceSubClass    
 0x00,            //bDeviceProtocol
 0x40,            //MaxPacketSize 64
 0x54, 0x68,      //ID Vendor
 0x54, 0x57,      //ID product    
 0x00, 0x01,      //bcdDevice
 0x00,                
 0x00,
 0x00,
 0x01,            //bNumConfigurations 
};

/* ȫ */
const UINT8 My_FS_CfgDescr[ ] = {
//                  
  //Configuration1  
 0x09,           //Length                            
 0x02,           //DescriptorType : ConfigDescriptor 
 0xFE, 0x00,     //TotalLength               
 0x04,           //NumInterfaces:4                 
 0x01,           //ConfigurationValue                
 0x00,           //Configuration String              
 0x80,           //Attributes:Bus Power              
 0x32,           //MaxPower = 0x32*2ma  

//ӿ
 //standard interface AC         descriptor(Interface 0, Alternate Setting 0):
 0x09,           //Length                     
 0x04,           //DescriptorType:Inerface    
 0x00,           //InterfaceNum:0             
 0x00,           //AlternateSetting:0   (identified)      
 0x00,           //NumEndpoint:0              
 0x01,           //InterfaceClass:audio       
 0x01,           //InterfaceSubClass:audio control
 0x00,           //          
 0x00,           //       

 //class-specific AC interface descriptor
 0x0A,           //Length                                                                                        
 0x24,           //DescriptorType:audio interface descriptor                                                     
 0x01,           //DescriptorSubType:audio control header                                                        
 0x00,0x01,      //bcdADC:audio Device Class 1.0       
 0x6B,0x00,      //TotalLength of class-specific AC interface descriptors                                                                            
 0x02,           //InCollection:2 //the number of AudioStreaming interface                                                       
 0x01,           //InterfaceNr(1)   
 0x02,           // 
             
 //USB Streaming ITD    ID=01
 0x0C,           //Length                                    
 0x24,           //DescriptorType:audio interface descriptor 
 0x02,           //DescriptorSubType:Input Terminal          
 0x01,           //Terminal   ID:0x01                           
 0x01,0x01,      //TerminalType:USB Streaming              
 0x00,           //bAssocTerminal                            
 0x02,           //NrChannels:2 channel                              
 0x03,0x00,      //ChannelConfig:Left Front,Right Front,     
 0x00,           //ChannelName String                        
 0x00,           //Terminal String                           
 //mono mic ITD     ID=04
 0x0C,           //Length                                    
 0x24,           //DescriptorType:audio interface descriptor 
 0x02,           //DescriptorSubType:Input Terminal          
 0x04,           //Terminal   ID:0x04                           
 0x01,0x02,      //TerminalType:microphone              
 0x00,           //bAssocTerminal                            
 0x01,           //NrChannels:1 channel                              
 0x01,0x00,      //ChannelConfig:center Front,  //0001     
 0x00,           //ChannelName String                        
 0x00,           //Terminal String  

//SU 
 0x07,           //Length                                    
 0x24,           //DescriptorType:audio interface descriptor 
 0x05,           //DescriptorSubType:SU
 0x09,           //ID
 0x01,           //bNrInPins
 0x05,           //SID
 0x00,

//Audio Feature Unit Descriptor FU1      ID=2
 //SourceId 0x08,ControlSize 0x02, Mute,Volume,  
 0x0D,          //Length                                   
 0x24,          //DescriptorType:audio interface descriptor
 0x06,          //DescriptorSubType:Audio Feature Unit     
 0x02,          //UnitID:0x02                             
 0x08,          //SID:8 MU                  
 0x02,          //ControlSize:n=2byte                       
 0x01,0x00,     //Controls(0):Volume supported for master channel
                             //D0: Mute
                            //D1: Volume
                            //D2: Bass
                            //D3: Mid
                            //D4: Treble
                            //D5: Graphic Equalizer
                            //D6: Automatic Gain
                            //D7: Delay
                            //D8: Bass Boost
                            //D9: Loudness                     
 0x02,0x00,     //Controls(1):supported for logical channel 1.
 0x02,0x00,     //Controls(2):supported for logical channel 2.
 0x00,          //Feature String

 //SourceId 0x04,ControlSize 0x02,Mute,Volume,   FU2    ID=05
 0x0B,         //Length                                   
 0x24,         //DescriptorType:audio interface descriptor
 0x06,         //DescriptorSubType:Audio Feature Unit     
 0x05,         //UnitID:0x05                             
 0x04,         //SourceID:4    #USB mic IT                
 0x02,         //ControlSize:n=2byte                       
 0x03,0x00,    //Controls(0):Volume supported for master channel
                             //D0: Mute
                            //D1: Volume
                            //D2: Bass
                            //D3: Mid
                            //D4: Treble
                            //D5: Graphic Equalizer
                            //D6: Automatic Gain
                            //D7: Delay
                            //D8: Bass Boost
                            //D9: Loudness                     
 0x00,0x00,     //Controls(1):supported for logical channel 1.
 0x00,          //Feature String 
 //SourceId 0x04,ControlSize 0x02,Mute,Volume,    FU3    ID=07
 0x0B,          //Length                                   
 0x24,          //DescriptorType:audio interface descriptor
 0x06,          //DescriptorSubType:Audio Feature Unit     
 0x07,          //UnitID:0x07                             
 0x04,          //SourceID:4    #USB mic IT                
 0x02,          //ControlSize:n=2byte                       
 0x03,0x00,     //Controls(0):Volume supported for master channel
                             //D0: Mute
                            //D1: Volume
                            //D2: Bass
                            //D3: Mid
                            //D4: Treble
                            //D5: Graphic Equalizer
                            //D6: Automatic Gain
                            //D7: Delay
                            //D8: Bass Boost
                            //D9: Loudness                     
 0x00,0x00,     //Controls(1):    
 0x00,          //Feature String 

//MU 
 //SourceId 0x01,0x07,MU  
 0x0D,          //Length                                   
 0x24,          //DescriptorType:audio interface descriptor
 0x04,          //DescriptorSubType:Audio MU     
 0x08,          //UnitID:0x08                             
 0x02,          //TWO InPinS
 0x01,          //SourceID:1    #USB  IT 
 0x07,          //SourceID:7    #USB  FU3            
 0x02,          //two channel                      
 0x03,0x00,     //left,right
 0x00,          //
 0x00,          //
 0x00,          //

 //USB Speaker    OTD    ID=03
 0x09,          //Length                                    
 0x24,          //DescriptorType:audio interface descriptor 
 0x03,          //DescriptorSubTYpe:Output Terminal         
 0x03,          //Terminal      ID:0x03                           
 0x01, 0x03,    //TerminalType:Speaker                
 0x00,      //AssocTerminal: 00                      
 0x02,      //SourceID:2   
 0x00,      //Terminal String
  //USB_IN    OTD      ID=06
 0x09,      //Length                                    
 0x24,      //DescriptorType:audio interface descriptor 
 0x03,      //DescriptorSubTYpe:Output Terminal         
 0x06,      //Terminal      ID:0x06                           
 0x01, 0x01,//TerminalType: USB Streaming               
 0x04,      //AssocTerminal: 04                      
 0x09,      //SourceID:9   
 0x00,      //Terminal String 

//-------------------Speaker  interface---------------------//
 //standard interface AS descriptor(Interface 1, Alternate Setting 0):
 0x09,       //Length                           
 0x04,       //DescriptorType:Interface         
 0x01,       //InterfaceNum:1                   
 0x00,       //AlternateSetting:0               
 0x00,       //NumEndpoint:0                    
 0x01,       //InterfaceClass:audio             
 0x02,       //InterfaceSubClass:audio streaming
 0x00,       //InterfaceProtocol                
 0x00,       //Interface String                 

 //standard interface AS descriptor(Interface 1, Alternate Setting 1):                        
 0x09,       //Length                           
 0x04,       //DescriptorType:Interface         
 0x01,       //InterfaceNum:1                   
 0x01,       //AlternateSetting:1               
 0x01,       //NumEndpoint:1                    
 0x01,       //InterfaceClass:audio             
 0x02,       //InterfaceSubClass:audio streaming
 0x00,       //InterfaceProtocol                
 0x00,       //Interface String                
 //Audio Streaming Interface Descriptor:AS_GENERAL(0x01),
 0x07,       //Length                                   
 0x24,       //DescriptorType:audio interface descriptor
 0x01,       //DescriptorSubType:AS_GENERAL             
 0x01,       //TerminalLink    
 0x01,       //Delay:0                                  
 0x01, 0x00, //FormatTag:PCM  0x0001
 
 //Class-Specific AS Format Type Descriptor
 0x0B,              //Length                                   
 0x24,              //DescriptorType:audio interface descriptor
 0x02,              //DescriptorSubType:Format_type            
 0x01,              //FormatType:Format type 1                 
 0x02,              //NumberOfChannel:2                       
 0x02,              //SubframeSize:2byte The number of bytes occupied by one audio subframe. Can be 1, 2, 3 or 4.                      
 0x10,              //BitsResolution:16bit   The number of effectively used bits from the available bits in an audio subframe                  
 0x01,              //SampleFreqType:One sampling frequency.   
 0x40,0x1f,0x00,    //8K(0x001f40)12k(0x002ee0) 16k(0x003e80)  32k(0x007300) 44.1k(0x00ac44) 48k(0x00bb80) 
 //Endpoint 1 - Standard Descriptor:Output Endpoint                  
 //Isochronous,Synchronization Type(Asynchronous)
 0x09,       //Length                                                                
 0x05,       //DescriptorType:endpoint descriptor                                    
 0x02,       //EndpointAddress:Output                                       
 0x09,       // D3..2: Synchronization type    01 = Asynchronous  10 = Adaptive  11 = Synchronous
             //    D1..0: Transfer type        01 = Isochronous   10 = bulk      11 = interrupt
 0x40,0x00,  //MaxPacketSize 64                                       
 0x01,       //delay 1                              
 0x00,       //bRefresh      
 0x00,       //bSynchAddress
 //Endpoint - Audio Streaming Descriptor
 //Audio Endpoint descriptor,General
 0x07,      //Length                                     
 0x25,      //DescriptorType:audio endpoint descriptor   
 0x01,      //DescriptorSubType:audio endpiont general   
 0x00,      //Attributes:0x00.............               
 0x01,      //LockDelayUnits                             
 0x01,
 0x00, 
//------------------mono-mic---------------------//
 //standard interface AS descriptor(Interface 2, Alternate Setting 0):
 0x09,       //Length                           
 0x04,       //DescriptorType:Interface         
 0x02,       //InterfaceNum:2                   
 0x00,       //AlternateSetting:0               
 0x00,       //NumEndpoint:0                    
 0x01,       //InterfaceClass:audio             
 0x02,       //InterfaceSubClass:audio streaming
 0x00,       //InterfaceProtocol                
 0x00,       //Interface String                 

 //standard interface AS descriptor(Interface 2, Alternate Setting 1):                        
 0x09,       //Length                           
 0x04,       //DescriptorType:Interface         
 0x02,       //InterfaceNum:2                   
 0x01,       //AlternateSetting:1               
 0x01,       //NumEndpoint:1                    
 0x01,       //InterfaceClass:audio             
 0x02,       //InterfaceSubClass:audio streaming
 0x00,       //InterfaceProtocol                
 0x00,       //Interface String 

//Audio Streaming Interface Descriptor:AS_GENERAL(0x01),
 0x07,       //Length                                   
 0x24,       //DescriptorType:audio interface descriptor
 0x01,       //DescriptorSubType:AS_GENERAL             
 0x06,       //TerminalLink    
 0x01,       //Delay:0                                  
 0x01, 0x00, //FormatTag:PCM  0x0001
 
 //Class-Specific AS Format Type Descriptor
 0x0B,              //Length                                   
 0x24,              //DescriptorType:audio interface descriptor
 0x02,              //DescriptorSubType:Format_type            
 0x01,              //FormatType:Format type 1                 
 0x01,              //NumberOfChannel:1                       
 0x02,              //SubframeSize:2byte The number of bytes occupied by one audio subframe. Can be 1, 2, 3 or 4.                      
 0x10,              //BitsResolution:16bit   The number of effectively used bits from the available bits in an audio subframe                  
 0x01,              //SampleFreqType:One sampling frequency.   
 0x40,0x1F,0x00,    //8K(0x001f40) 16k(0x003e80)  32k(0x007300)  48k(0x00bb80)    
 //Endpoint 2 - Standard Descriptor:Input Endpoint                  
 //Isochronous,Synchronization Type(Asynchronous)
 0x09,       //Length                                                                
 0x05,       //DescriptorType:endpoint descriptor                                    
 0x82,       //EndpointAddress:Input                                       
 0x05,       // D3..2: Synchronization type    01 = Asynchronous  10 = Adaptive  11 = Synchronous
             //    D1..0: Transfer type        01 = Isochronous   10 = bulk      11 = interrupt
 0x40,0x00,  //MaxPacketSize 64                                       
 0x01,       //delay 1                              
 0x00,       //bRefresh      
 0x00,       //bSynchAddress

 //Endpoint - Audio Streaming Descriptor
 //Audio Endpoint descriptor,General
 0x07,      //Length                                     
 0x25,      //DescriptorType:audio endpoint descriptor   
 0x01,      //DescriptorSubType:audio endpiont general   
 0x00,      //Attributes:0x00.............               
 0x00,      //LockDelayUnits                             
 0x00,
 0x00,   

//------------------HID--------------------//
 //interface HID descriptor(Interface 3, Alternate Setting 0):
 0x09,       //Length                           
 0x04,       //DescriptorType:Interface         
 0x03,       //InterfaceNum:3                   
 0x00,       //AlternateSetting:0               
 0x01,       //NumEndpoint:1                    
 0x03,       //InterfaceClass: HID            
 0x00,       //InterfaceSubClass:not used
 0x00,       //InterfaceProtocol                
 0x00,       //Interface String 
 //
 0x09,       //Length
 0x21,       //DescriptorType:HID
 0x00,0x01,  //bcdHID
 0x00,       //bCountyCode
 0x01,       //bNumHID
 0x22,       //bDescriptorType:
 0x32,       //TotalLength
 0x00,       //
 //Endpoint 3 - Standard Descriptor: Endpoint                  
 0x07,       //Length                                                                
 0x05,       //DescriptorType:endpoint descriptor                                    
 0x81,       //EndpointAddress:Output                                       
 0x03,       // D3..2: Synchronization type    01 = Asynchronous  10 = Adaptive  11 = Synchronous
             //    D1..0: Transfer type        01 = Isochronous   10 = bulk      11 = interrupt
 0x04,0x00,  //MaxPacketSize 4                                       
 0x08,       //delay 8               
};

/*  */         
const UINT8 My_HS_CfgDescr[ ] = { 0x09, 0x02, 0x27, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
                                  0x09, 0x04, 0x00, 0x00, 0x03, 0xFF, 0x80, 0x37, 0x00,
                                  0x07, 0x05, 0x82, 0x02, 0x00, 0x02, 0x00,
                                  0x07, 0x05, 0x02, 0x02, 0x00, 0x02, 0x00,
                                  0x07, 0x05, 0x81, 0x03, 0x40, 0x00, 0x0A };

/* 豸޶ */
const UINT8    My_QueDescr[ ] = { 0x0A, 0x06, 0x00, 0x02, 0xFF, 0x00, 0xFF, 0x40, 0x01, 0x00 };

/* ȫģʽٶ */
const UINT8    My_FS_OscDescr[ ] = { 0x09, 0x07, 0x27, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
                                  0x09, 0x04, 0x00, 0x00, 0x03, 0xFF, 0x80, 0x37, 0x00,
                                  0x07, 0x05, 0x82, 0x02, 0x00, 0x02, 0x00,
                                  0x07, 0x05, 0x02, 0x02, 0x00, 0x02, 0x00,
                                  0x07, 0x05, 0x81, 0x03, 0x40, 0x00, 0x0A };

/* ģʽٶ */
const UINT8    My_HS_OscDescr[ ] = { 0x09, 0x07, 0x27, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
                                  0x09, 0x04, 0x00, 0x00, 0x03, 0xFF, 0x80, 0x37, 0x00,
                                  0x07, 0x05, 0x82, 0x02, 0x40, 0x00, 0x00,
                                  0x07, 0x05, 0x02, 0x02, 0x40, 0x00, 0x00,
                                  0x07, 0x05, 0x81, 0x03, 0x08, 0x00, 0x0A };

//
const UINT8 MyReportDescr[] = 
{
0x05, 0x0C,               // Usage page(consumer device)
0x09, 0x01,               // Usage(remote control)
0xa1, 0x01,               // Cellection(application)
    0x15, 0x00,           // L_Min(0)
    0x25, 0x01,           // L_Max(1)
    0x09, 0xE9,           // Usage(volume up)
    0x09, 0xEA,           // Usage(volume down)
    0x75, 0x01,           // R_Size(1 bit)
    0x95, 0x02,           // R_Count(2)
    0x81, 0x02,           // Input(data,var,abs)

    0x09, 0xE2,           // Usage(mute)
    0x09, 0x00,           // Usage(unassigned)
    0x81, 0x06,           // Input(data,var,rel)

    0x09, 0x00,           // Usage
    0x95, 0x04,           // R_Count
    0x81, 0x02,           // Input

    0x26, 0xFF, 0x00,     // L_Max(2byte)255
    0x09, 0x00,           // Usage
    0x75, 0x08,           // R_Size(8bit)
    0x95, 0x03,           // R_Count(3)
    0x81, 0x02,           // Input

    0x09, 0x00,           // Usage
    0x95, 0x04,           // R_Count
    0x91, 0x02,           // Output
0xc0                      // end
};

// 
const    UINT8 MyLangDescr[] = { 0x04, 0x03, 0x09, 0x04 };

// Ϣ
const    UINT8 MyManuInfo[] = { 0x0e, 0x03, 0x77, 0x00, 0x63, 0x00, 0x68, 0x00, 0x2e, 0x00, 0x63, 0x00, 0x6e, 0x00 };

// ƷϢ
const    UINT8 MyProdInfo[16] = { 0x10, 0x03, 'h', 0, 'e', 0, 'a', 0, 'd', 0, 's', 0, 'e', 0, 't', 0};

UINT8    cla81_buf[12] = { 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00 };
UINT8    cla82_buf[12] = { 0x00, 0x00, 0x00, 0x80,0x00, 0x00, 0x00, 0x80,0x00, 0x00, 0x00, 0x00 };



/*******************************************************************************/
/*  */
UINT8V  gUsbConfig;                                                             /* USB豸ñ־ */
UINT8V  gSetupReq;                                                              /* USBƴ */    
UINT16V gSetupLen;                                                              /* USBƴ䴫䳤 */
UINT8V  gUsbSpeed;                                                              /* ǰUSBٶ(Ĭ0: ;1:ȫ) */    
UINT8V  gUsbInterCfg;                                                           /* USB豸ӿ */
UINT8V  gUsbFlag;                                                               /* USB豸ֲ־,λ0=߸λ,λ1=ȡ豸,λ2=õַ,λ3=ȡ,λ4= */
UINT8   *pDescr;                                                                /* ָ */        
UINT32  USB_Recv_Buf[ 512 ];                                                    /* USB豸ݽջ */
UINT32  USB_Tran_Buf[ 512 ];                                                    /* USB豸ݷͻ */
UINT32V gRecvLen;                                                               /* ǰճ */
AUDIO_PWM pwm;

/*******************************************************************************
* Function Name  : USBDev_ModeSet
* Description    : óUSB豸ģʽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_ModeSet( void )
{ 
    R8_MISC_CTRL_USB &= ~RB_MISC_USB_ID_EN;                                     /* USB OTG ID pin enable */                                    
    R8_MISC_CTRL_USB |= RB_MISC_USB_ID_ST;                                      /* óUSB豸 */
}

/*******************************************************************************
* Function Name  : USBDev_SpeedSet
* Description    : USB豸ٶ
* Input          : speed---USB_DEV_SPEED_HS: ģʽ
*                          USB_DEV_SPEED_FS: ȫģʽ
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_SpeedSet( UINT8 speed )
{
    if( speed == USB_DEV_SPEED_HS )
    {
        USB_DEV_CONTROL &= ~RB_FORCE_FS;                                        /* ģʽ(Ĭ) */
    }
    else
    {
        USB_DEV_CONTROL |= RB_FORCE_FS;                                         /* ȫģʽ */
    }    
}

/*******************************************************************************
* Function Name  : USBDev_SpeedCheck
* Description    : USB豸ٶȼ
* Input          : None
* Output         : None
* Return         : USB_DEV_SPEED_HS: ģʽ; USB_DEV_SPEED_FS: ȫģʽ
*******************************************************************************/

UINT8 USBDev_SpeedCheck( void )
{
     if( USB_DEV_CONTROL & RB_HS_EN )
    {
#if  MY_DEBUG_PRINTF         
        printf("Current Device is High Speed!\n");    
#endif                                    
        gUsbSpeed = USB_DEV_SPEED_HS;                                           /* ǰUSB豸ٶΪ */
        return( USB_DEV_SPEED_HS );    
    }
    else
    {
#if  MY_DEBUG_PRINTF         
          printf("Current Device is Full Speed!\n");
#endif          
        gUsbSpeed = USB_DEV_SPEED_FS;                                           /* ǰUSB豸ٶΪȫ */
        return( USB_DEV_SPEED_FS );    
    }
}

/*******************************************************************************
* Function Name  : USBDev_UsbInt_Enable
* Description    : USB豸USBжʹ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_UsbInt_Enable( void )  
{
    /* USBж */
    R8_INT_EN_IRQ_1 |= RB_IE_IRQ_USB;                                           /* USBжʹ */
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                       /* ȫжʹ */
}

/*******************************************************************************
* Function Name  : USBDev_Init
* Description    : USB豸ʼ
*                  ҪĴã˵㡢FIFO
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_Init( void )
{
    /* ģCH372豸 */
    /* ENDP1_IN Ϊж϶˵㣬ռ8ֽڣʹFIFO0(IN) */
    /* ENDP2_IN Ϊ˵㣬ռ64ֽڣʹFIFO1(IN) */
    /* ENDP2_OUTΪ˵㣬ռ64ֽڣʹFIFO2(OUT) */

    /* λUSB豸 */
    USB_DEV_CONTROL = RB_SFRST;
    while( USB_DEV_CONTROL & 0x10 );                                            /* ȴλ */

    /* λUSB豸FIFO */
    USB_DEV_FIFO0_INFO = RB_FFRST;                                              /* FIFO0 Reset */
    USB_DEV_FIFO1_INFO = RB_FFRST;                                              /* FIFO1 Reset */
    USB_DEV_FIFO2_INFO = RB_FFRST;                                              /* FIFO2 Reset */
    USB_DEV_FIFO3_INFO = RB_FFRST;                                              /* FIFO3 Reset */
    Delay_us( 10 );    
    
#if 0
    /* һ˵ԼFIFO(Ĵֱ÷ʽ) */
    USB_DEV_FIFO_CONFIG    = 0x00222223;                                        /* R(0x1AC) */
    USB_DEV_EP1_4_MAP      = 0x33332130;                                        /* R(0x1A0) FIFO0(ENDP1_IN)FIFO1(ENDP2_IN)FIFO2(ENDP2_OUT) */         
    USB_DEV_FIFO_MAP       = 0x0F021211;                                        /* R(0x1A8) */                                          
    USB_DEV_EP1_IN_MAXPKS  = 0x00000008;                                        /* R(0x160) EP1_IN_MAXPKS  = 8 bytes */
    USB_DEV_EP2_IN_MAXPKS  = 0x00000040;                                        /* R(0x164) EP2_IN_MAXPKS  = 64 bytes */
    USB_DEV_EP2_OUT_MAXPKS = 0x00000040;                                        /* R(0x184) EP2_OUT_MAXPKS = 64 bytes */ 
#endif

#if 1        
    /* ˵ԼFIFO(÷ʽ) */

    /* ˵1 */
    USBDev_EPx_Init( ENDP1, 
                     ENDP_TYPE_IN,                                              /* ENDP1 IN˵ */
                     FIFO_TYPE_INTERRUPT,                                       /* ˵Ϊж϶˵ */
                     FIFO_DIR_IN,                                               /* FIFOΪΪIN */
                     FIFO_BK_NUM_SINGLE,                                        /* FIFOΪ,512ֽ */    
                     FIFO_BK_SIZE_0,                                            /* FIFOССڵ512ֽ */
                     FIFO_NUM_0,                                                /* ö˵ӦFIFOΪFIFO 0 */
                     FIFO_ENABLE,                                               /* ʹܸö˵ӦFIFO */
                     USB_EP1_IN_MAX_PKT );                                      /* øö˵С */
    
    /* ˵2 */    
    USBDev_EPx_Init( ENDP2,     
                     ENDP_TYPE_IN,                                              /* ENDP2 IN˵ */
                     FIFO_TYPE_ISO,                                             /* ˵Ϊ˵ */
                     FIFO_DIR_IN,                                               /* FIFOΪΪIN */
                     FIFO_BK_NUM_SINGLE,                                        /* FIFOΪ,512ֽ */
                     FIFO_BK_SIZE_0,                                            /* FIFOССڵ512ֽ */    
                     FIFO_NUM_1,                                                /* ö˵ӦFIFOΪFIFO 1 */
                     FIFO_ENABLE,                                               /* ʹܸö˵ӦFIFO */    
                     USB_EP2_IN_MAX_PKT );                                      /* øö˵С */

    /* ˵2 */
    USBDev_EPx_Init( ENDP2, 
                     ENDP_TYPE_OUT,                                             /* ENDP2 OUT˵ */
                     FIFO_TYPE_ISO,                                             /* ˵Ϊ˵ */
                     FIFO_DIR_OUT,                                              /* FIFOΪΪOUT */
                     FIFO_BK_NUM_SINGLE,                                        /* FIFOΪ,512ֽ */
                     FIFO_BK_SIZE_0,                                            /* FIFOССڵ512ֽ */    
                     FIFO_NUM_2,                                                /* ö˵ӦFIFOΪFIFO 2 */
                     FIFO_ENABLE,                                               /* ʹܸö˵ӦFIFO */    
                     USB_EP2_OUT_MAX_PKT );                                     /* øö˵С */        
#endif        

    /* USB豸жʹ */
    /* óʹ˳FIFOжж,ԸҪرӦж */
    USB_DEV_MASK_INT_GROP  = 0x00000000;                                        /* Enable USB Device interrupt of source group 012*/
    USB_DEV_MASK_INT_GROP0 = 0x00000000;
    USB_DEV_MASK_INT_GROP1 = RB_F3_IN_INT | RB_F2_IN_INT | RB_F1_IN_INT | 
        RB_F0_IN_INT;                                                           /* ֹFIFOϴж */
    USB_DEV_MASK_INT_GROP2 = 0x00000000;        

    /* ʹоƬ(Ҫǿȫģʽ) */
    USB_DEV_CONTROL = RB_CHIP_EN | RB_GLINT_EN;                                 /* ʹоƬʹȫжϡʹܸ */                  
    USBDev_SpeedSet( USB_DEV_SPEED_FS );                                        /* ǿȫģʽ */
    Delay_ms( 1 );                                                
    USB_PHY_TEST_MODE &= ~RB_UNPLUG;                                            /* Ĵ(0x114)λ00,֪ͨ */
} 

/*******************************************************************************
* Function Name  : USB_Dev_SetAddress
* Description    : USB豸ַ
* Input          : addre---豸ַ
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_SetAddress( UINT8 addre )
{
    USB_DEV_ADDRESS = ( USB_DEV_ADDRESS & RB_AFT_CONF ) | addre;                /* ַĴ7λ */    
}

/*******************************************************************************
* Function Name  : USBDev_SetConfig
* Description    : USB豸ñ־λ
*                  ע: ڴSET_CONFIGURATIONøñ־λ,򲻻Ӧ
*                        ǿƶ˵Ĵ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_SetConfig( void )
{
    USB_DEV_ADDRESS |= RB_AFT_CONF;                                             /* ñ־λ */     
    
#if  MY_DEBUG_PRINTF         
    printf("USB Enumerate Success!\n ");
#endif
}

/*******************************************************************************
* Function Name  : USBDev_EP0_Stall
* Description    : USB豸STALL
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EP0_Stall( void )
{
    USB_DEV_CX_CONF_FIFO_STATUS |= RB_CX_STL;                                   /* reg=0x120 */    
}

/*******************************************************************************
* Function Name  : USBDev_EPx_IN_Stall
* Description    : USB豸EPxIN˵STALL
* Input          : epx_num---˵(ΧΪ:1---8)
*                  mode------ģʽ(1ΪSTALL, 0ΪSTALL)
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_IN_Stall( UINT8 epx_num, UINT8 mode )
{
    UINT32 addr;
    UINT32 reg;    
    
    addr = USB_BASE_ADDR + 0x160 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));    
    if( mode )
    {
        (*((PUINT32V)addr)) = reg | RB_STL_IEPx;        
    }
    else
    {
        (*((PUINT32V)addr)) = reg & ( ~RB_STL_IEPx );    
    }                
}

/*******************************************************************************
* Function Name  : USBDev_EPx_OUT_Stall
* Description    : USB豸EPxOUT˵STALL
* Input          : epx_num---˵(ΧΪ:1---8)
*                  mode------ģʽ(1ΪSTALL, 0ΪSTALL)
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_OUT_Stall( UINT8 epx_num, UINT8 mode )
{
    UINT32 addr;
    UINT32 reg;    
    
    addr = USB_BASE_ADDR + 0x180 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));

    if( mode )
    {
        (*((PUINT32V)addr)) = reg | RB_STL_OEPx;        
    }
    else
    {
        (*((PUINT32V)addr)) = reg & ( ~RB_STL_OEPx );    
    }
}

/*******************************************************************************
* Function Name  : USBDev_EPx_IN_ResetToggle
* Description    : USB豸EPxIN˵㸴λͬλ
* Input          : epx_num---˵(ΧΪ:1---8)
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_IN_ResetToggle( UINT8 epx_num )
{
    UINT32 addr;
    UINT32 reg;    
    
    addr = USB_BASE_ADDR + 0x160 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));
    (*((PUINT32V)addr)) = reg | RB_RSTG_IEPx;
    Delay_us( 5 );
    (*((PUINT32V)addr)) = reg & ( ~RB_RSTG_IEPx );            
}

/*******************************************************************************
* Function Name  : USBDev_EPx_OUT_ResetToggle
* Description    : USB豸EPxOUT˵㸴λͬλ
* Input          : epx_num---˵(ΧΪ:1---8)
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_OUT_ResetToggle( UINT8 epx_num )
{
    UINT32 addr;
    UINT32 reg;    
    
    addr = USB_BASE_ADDR + 0x180 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));
    (*((PUINT32V)addr)) = reg | RB_RSTG_OEPx;
    Delay_us( 5 );
    (*((PUINT32V)addr)) = reg & ( ~RB_RSTG_OEPx );                
}

/*******************************************************************************
* Function Name  : USBDev_EPx_IN_SetMaxPKS
* Description    : USB豸EPxIN˵
* Input          : epx_num---˵(ΧΪ:1---8)
*                  maxpks_len---С 
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_IN_SetMaxPKS( UINT8 epx_num, UINT16 maxpks_len )
{
    UINT32 addr;
    UINT32 reg;    
    
    maxpks_len = maxpks_len & 0x7FF;
    addr = USB_BASE_ADDR + 0x160 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));
    (*((PUINT32V)addr)) = ( reg & 0xFFFFFC00 ) | maxpks_len;        
}

/*******************************************************************************
* Function Name  : USBDev_EPx_OUT_SetMaxPKS
* Description    : USB豸EPxOUT˵
* Input          : epx_num---˵(ΧΪ:1---8)
*                  maxpks_len---С 
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_OUT_SetMaxPKS( UINT8 epx_num, UINT16 maxpks_len )
{
    UINT32 addr;
    UINT32 reg;    
    
    maxpks_len = maxpks_len & 0x7FF;
    addr = USB_BASE_ADDR + 0x180 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));
    (*((PUINT32V)addr)) = ( reg & 0xFFFFFC00 ) | maxpks_len;        
}

/*******************************************************************************
* Function Name  : USBDev_EPx_Init
* Description    : USB豸˵
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EPx_Init( UINT8 epx_num, 
                      UINT8 epx_type,
                      UINT8 fifo_type, 
                      UINT8 fifo_dir, 
                      UINT8 fifo_bk_num, 
                      UINT8 fifo_bk_size, 
                      UINT8 fifo_num, 
                      UINT8 fifo_en,
                      UINT16 maxpks_len )
{    
    UINT32 addr;
    UINT32 reg1, reg2, mask;    
    
    /* øö˵INOUTС */
    if( epx_type == ENDP_TYPE_IN )
    {    
        USBDev_EPx_IN_SetMaxPKS( epx_num, maxpks_len );                         /* EPx_IN˵С */
    }
    else if( epx_type == ENDP_TYPE_OUT )
    {
        USBDev_EPx_OUT_SetMaxPKS( epx_num, maxpks_len );                        /* EPx_OUT˵С */
    }        

    /* øö˵INOUTӦFIFO */
    /* Endpoint1-4 Map Register(Addr=0X1A0)ԼEndpoint5-8 Map Register(Addr=0X1A4)*/    
    if( epx_num <= 4 )
    {
        addr = USB_BASE_ADDR + 0x1A0;    
    }
    else
    {
        addr = USB_BASE_ADDR + 0x1A4;            
        epx_num = epx_num - 4;
    }    
    reg1 = (*((PUINT32V)addr));                                                 /* ȡĴ0X1A00X1A4ԭֵ */

    mask = 0x00000003;
    reg2 = fifo_num;
    if( epx_type == ENDP_TYPE_OUT )
    {    
        mask = mask << 4;
        reg2 = reg2 << 4;
    }
    mask = mask << ( ( epx_num - 1 ) * 8 );    
    reg2 = reg2 << ( ( epx_num - 1 ) * 8 );                
    reg1 = ( reg1 & ( ~mask ) ) | reg2;    
    reg1 = reg1 & 0x33333333;
    (*((PUINT32V)addr)) = reg1;        

    /* FIFO Map Register(Addr=0X1A8) */
    mask = 0x000000FF;
    reg2 = ( ( fifo_dir & 0x03 ) << 4 ) | epx_num;
    mask = mask << ( fifo_num * 8 );    
    reg2 = reg2 << ( fifo_num * 8 );    
    reg1 = USB_DEV_FIFO_MAP;    
    USB_DEV_FIFO_MAP = ( reg1 & ( ~mask ) ) | reg2;        
    
    /* FIFO Configuration Register(Addr=0X1AC) */    
    mask = 0x000000FF;
    reg2 = fifo_type | ( ( fifo_bk_num & 0x03 ) << 2 ) | ( fifo_bk_size << 4 ) | ( fifo_en << 5 );        
    mask = mask << ( fifo_num * 8 );    
    reg2 = reg2 << ( fifo_num * 8 );    
    reg1 = USB_DEV_FIFO_CONFIG;    
    USB_DEV_FIFO_CONFIG = ( reg1 & ( ~mask ) ) | reg2; 
}

/*******************************************************************************
* Function Name  : USBDev_RD_FIFOx
* Description    : FIFOжȡUSB
* Input          : fifonum---FIFO
*                  len-------ݳ
*                  *pbuf-----ݴ洢    
* Output         : None
* Return         : len---ʵʶȡ
*******************************************************************************/

UINT32 USBDev_RD_FIFOx( UINT8 fifonum, UINT32 len, UINT8 *pbuf )
{
    UINT32 i = 0;
        
    if( ( fifonum != USB_DMA_ACC_F0 ) && ( fifonum != USB_DMA_ACC_F1 ) &&
        ( fifonum != USB_DMA_ACC_F2 ) && ( fifonum != USB_DMA_ACC_F3 ) &&
        ( fifonum != USB_DMA_ACC_CXF ) )
    {
        USB_DEV_DMA_TARGET_FIFO = USB_DMA_ACC_NO;                               /* DMAӦκFIFO */
        return( 0x00 );
    }
    
#if  0 
    printf("USBDev_RD_FIFOx:\n ");
#endif    
    USB_DEV_DMA_TARGET_FIFO = fifonum;                                          /* DMAӦFIFO */
    if( fifonum == USB_DMA_ACC_CXF )                                            /* SETUPֱӶȡ */
    {
        if( len == 8 ) 
        {
            *(PUINT32)pbuf = USB_DEV_SETUP_CMD_RPORT;
            *(PUINT32)( pbuf + 4 ) = USB_DEV_SETUP_CMD_RPORT;
        }
        else 
        {
            len = 0;
        }            
    }
    else
    {
        if( USB_DEV_DMA_SET1 & RB_DMA_ABORT )                                   /* жǷDMA_ABORT */
        {
            USB_DEV_DMA_SET1 |= RB_CLRFIFO_DMAABORT;    
            len = 0x00;                            
        }
        else
        {        
            /* FIFO x Instruction and Byte Count Register(0X1B0--0X1BC)жȡӦFIFOݵĳ */
            if( fifonum == USB_DMA_ACC_F0 )
            {
                i = USB_DEV_FIFO0_INFO & 0x7FF;                                            
            }
            else if( fifonum == USB_DMA_ACC_F1 )
            {
                i = USB_DEV_FIFO1_INFO & 0x7FF;                                        
            }            
            else if( fifonum == USB_DMA_ACC_F2 )
            {
                i = USB_DEV_FIFO2_INFO & 0x7FF;                                        
            }            
            else if( fifonum == USB_DMA_ACC_F3 )
            {
                i = USB_DEV_FIFO3_INFO & 0x7FF;
            }    
            if( len > i )
            {
                len = i;                                                        /* ȡȴʵʳ,ȡʵʳ */
            }
#if 0 
            printf("rd_len:%04x\n",(UINT32)len);
#endif
            /* ͨDMAݴRAMFIFO */
            USB_DEV_DMA_SET1 = len << 8;                                        /* USB DMAͨų */
            USB_DEV_DMA_SET2 = (UINT32)pbuf;                                    /* USB DMAͨŻʼַ */    
            USB_DEV_DMA_SET1 = USB_DEV_DMA_SET1 | RB_DMA_START;                 /* USB DMAFIFOݴ */
            while( USB_DEV_DMA_SET1 & RB_DMA_START );                           /* ȴDMA */
            USB_DEV_INT_GROP2 = USB_DEV_INT_GROP2 | RB_DMA_CMPLT;               /* DMAɱ־ */        
        }
    }
    USB_DEV_DMA_TARGET_FIFO = USB_DMA_ACC_NO;                                   /* DMAӦκFIFO */
    return( len );
}

/*******************************************************************************
* Function Name  : USBDev_WR_FIFOx
* Description    : FIFOдUSB
* Input          : fifonum---FIFO
*                  len-------ݳ
*                  *pbuf-----ݴ洢    
* Output         : None
* Return         : len---д볤
*******************************************************************************/

UINT32 USBDev_WR_FIFOx( UINT8 fifonum, UINT32 len, UINT8 *pbuf )
{
    if( ( fifonum != USB_DMA_ACC_F0 ) && ( fifonum != USB_DMA_ACC_F1 ) &&
        ( fifonum != USB_DMA_ACC_F2 ) && ( fifonum != USB_DMA_ACC_F3 ) &&
        ( fifonum != USB_DMA_ACC_CXF ) )
    {
        USB_DEV_DMA_TARGET_FIFO = USB_DMA_ACC_NO;                               /* DMAӦκFIFO */
        return( 0x00 );
    }

#if  MY_DEBUG_PRINTF 
    printf("USBDev_WR_FIFOx:\n ");
#endif
    if( USB_DEV_DMA_SET1 & RB_DMA_ABORT )                                       /* жǷDMA_ABORT */
    {
        USB_DEV_DMA_SET1 = RB_CLRFIFO_DMAABORT;    
        return( 0x00 );                            
    }
    else
    {        
#if  MY_DEBUG_PRINTF 
        printf("wr_len:%04x\n",(UINT32)len);
#endif

        /* ͨDMAݴFIFORAM */
        USB_DEV_DMA_TARGET_FIFO = fifonum;                                      /* USB DMAӦFIFO */                                                 
        USB_DEV_DMA_SET1 = ( len  << 8 ) | RB_DMA_TYPE;                         /* USB DMAͨų */
        
        /* ȲΪ0DMAݴ */
        if( len )
        {
            USB_DEV_DMA_SET2 = ( UINT32 )pbuf;                                  /* USB DMAͨŻʼַ */    
            USB_DEV_DMA_SET1 = USB_DEV_DMA_SET1 | RB_DMA_START;                 /* USB DMAFIFOݴ */
            while( ( USB_DEV_DMA_SET1 & RB_DMA_START ) );                       /* ȴDMA */
        }
        USB_DEV_INT_GROP2 = USB_DEV_INT_GROP2 | RB_DMA_CMPLT;                   /* DMAɱ־ */    
        USB_DEV_DMA_TARGET_FIFO = USB_DMA_ACC_NO;                               /* DMAӦκFIFO */
        return( len );        
    }        
}

/*******************************************************************************
* Function Name  : USBDev_EP0_Setup_Deal
* Description    : USBƶ˵Setup
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EP0_Setup_Deal( void )
{
    UINT32 len;
    UINT32 status;    
    UINT8  buf[ 8 ];
    USB_SETUP_REQ SetupReqBuf;

    /* ȡSETUP */    
    len = USBDev_RD_FIFOx( USB_DMA_ACC_CXF, 8, (PUINT8)&SetupReqBuf );          /* FIFO4жȡSETUP */
    if( len == sizeof( USB_SETUP_REQ ) )                                        /* жϳǷSetup */
    {
        gSetupLen = ( SetupReqBuf.wLengthH << 8 ) + SetupReqBuf.wLengthL;       /* 洫䳤 */
        gSetupReq = SetupReqBuf.bRequest;                                       /* 浱ǰ */

        /* ǰSETUP */
        len = 0;                                                                /* ĬϴΪ0 */
        status = 0x00;                                                          /* ĬϲΪɹ״̬ */    
        if( ( SetupReqBuf.bReqType & USB_REQ_TYPE_MASK ) != USB_REQ_TYPE_STAND ) 
        {  
            /* 󣬲 */
                        switch(gSetupReq){
                            case DEF_USB_SET_CUR:
                                switch(SetupReqBuf.wIndexH){
                                    case DEF_USB_CLA_SU:                        //SU control
                                        break;
                                    case DEF_USB_CLA_FU1:                       //FU
                                    case DEF_USB_CLA_FU2:
                                    case DEF_USB_CLA_FU3:
                                        switch( SetupReqBuf.wValueH ){
                                            case DEF_USB_CLA_VOL:               //volume
                                                break;
                                             case DEF_USB_CLA_MUT:              //mute
                                                break;
                                            default:
                                                status = 0xFF;                  // ʧ
                                                break;                            
                                        }
                                        break;
                                     default:
                                        status = 0xFF;                          // ʧ
                                        break;    
                                }
                                break;

                            case DEF_USB_SET_UnK:
                                break;

                            case DEF_USB_GET_CUR:            
                                switch(SetupReqBuf.wIndexH){      
                                    case DEF_USB_CLA_MU:                        /* MU control */
                                        pDescr = (PUINT8)( &cla81_buf[0] );
                                        len = sizeof( cla81_buf );
                                        break;                                           
                                    case DEF_USB_CLA_SU:                        /* SU control */
                                        buf[0] = 0x01;
                                        pDescr = buf;
                                        if ( gSetupLen >= 1 ) len = 1;
                                        else len = gSetupLen;
                                        break;                            
                                    case DEF_USB_CLA_FU1:                       /* FU */
                                    case DEF_USB_CLA_FU2:
                                    case DEF_USB_CLA_FU3:
                                        switch( SetupReqBuf.wValueH ){
                                            case DEF_USB_CLA_VOL:               /* volume */
                                                buf[0] = 0x00;
                                                buf[1] = 0xf9;
                                                pDescr = buf;
                                                if ( gSetupLen >= 2 ) len = 2;
                                                else len = gSetupLen;                                                
                                                break;
                                             case DEF_USB_CLA_MUT:              /* mute */
                                                buf[1] = 0x00;
                                                pDescr = buf;
                                                if ( gSetupLen >= 1 ) len = 1;
                                                else len = gSetupLen;
                                                break;
                                            default:
                                                status = 0xFF;                  /* ʧ */
                                                break;                            
                                        }
                                        break;
                                }
                                break;
                            
                            case DEF_USB_GET_MIN:        
                                switch(SetupReqBuf.wIndexH){
                                    case DEF_USB_CLA_MU:
                                        pDescr = (PUINT8)( &cla82_buf[0] );
                                        len = sizeof( cla82_buf );
                                        break;
                                    case DEF_USB_CLA_FU1:                       /* FU */
                                    case DEF_USB_CLA_FU2:
                                    case DEF_USB_CLA_FU3:
                                        switch( SetupReqBuf.wValueH ){
                                            case DEF_USB_CLA_VOL:               /* volume */
                                                buf[0] = 0xa0;
                                                buf[1] = 0xe3;
                                                pDescr = buf;
                                                if ( gSetupLen >= 2 ) len = 2;
                                                else len = gSetupLen;
                                                break;
                                            default:
                                                status = 0xFF;                  /* ʧ */
                                                break;
                                        }
                                        break;
                                }
                                break;            
                            
                            case DEF_USB_GET_MAX:
                                switch(SetupReqBuf.wIndexH){
                                     case DEF_USB_CLA_FU1:                      /* FU */
                                     case DEF_USB_CLA_FU2:
                                     case DEF_USB_CLA_FU3:
                                        switch( SetupReqBuf.wValueH ){
                                            case DEF_USB_CLA_VOL:               /* volume */
                                                buf[0] = 0xf0;
                                                buf[1] = 0xff;
                                                pDescr = buf;
                                                if ( gSetupLen >= 2 ) len = 2;
                                                else len = gSetupLen;                                            
                                                break;
                                            default:
                                                status = 0xFF;                  /* ʧ */
                                                break;
                                        }
                                        break;
                                }
                                break;            
                            
                            case DEF_USB_GET_RES:            
                                switch(SetupReqBuf.wIndexH){
                                    case DEF_USB_CLA_FU1:                       /* FU */
                                    case DEF_USB_CLA_FU2:
                                    case DEF_USB_CLA_FU3:
                                        switch( SetupReqBuf.wValueH ){
                                            case DEF_USB_CLA_VOL:               /* volume */
                                                buf[0] = 0x30;
                                                buf[1] = 0x00;
                                                pDescr = buf;
                                                if ( gSetupLen >= 2 ) len = 2;
                                                else len = gSetupLen;
                                                break;
                                            default:
                                                status = 0xFF;                  /* ʧ */
                                                break;
                                        }
                                        break;
                                    default:
                                        status = 0xFF;
                                        break;
                                }
                                break;
                        }
        }
        else 
        {  
            /* ׼ */
            switch( gSetupReq ) 
            {
                case USB_REQ_GET_DESCR:                                         /* CMD: GET_DESCR */
#if  MY_DEBUG_PRINTF                     
                    printf("USB_REQ_GET_DESCR:\n ");
#endif
                    switch( SetupReqBuf.wValueH ) 
                    {
                        case 1:
                            gUsbFlag |= DEF_BIT_USB_DEV_DESC;                   /* ûȡ豸־ */
                            pDescr = (PUINT8)( &MyDevDescr[ 0 ] );
                            len = sizeof( MyDevDescr );
                            USBDev_SpeedCheck(  );                              /* жϵǰUSB豸ٶ */
                            break;
                        
                        case 2:
                            gUsbFlag |= DEF_BIT_USB_CFG_DESC;                   /* ûȡ־ */
                            if( gUsbSpeed == USB_DEV_SPEED_HS )                 /* ģʽ */
                            {
                                gUsbFlag |= DEF_BIT_USB_HS;                     /* øٱ־ */
                                pDescr = (PUINT8)( &My_FS_CfgDescr[ 0 ] );
                                len = sizeof( My_FS_CfgDescr );
                                
                                /* Ӧ˵С */                                
                                USBDev_EPx_IN_SetMaxPKS( ENDP1, 64 );
                                USBDev_EPx_IN_SetMaxPKS( ENDP2, 512 );
                                USBDev_EPx_OUT_SetMaxPKS( ENDP2, 512 );                                
                            }
                            else                                                /* ȫģʽ */        
                            {
                                gUsbFlag &= ~DEF_BIT_USB_HS;                    /* ȫٱ־ */
                                pDescr = (PUINT8)( &My_FS_CfgDescr[ 0 ] );
                                len = sizeof( My_FS_CfgDescr );
                            }
                            break;
                        
                        case 3:                            
                            switch( SetupReqBuf.wValueL ) 
                            {
                                case 1:
                                    pDescr = (PUINT8)( &MyManuInfo[ 0 ] );      /* ȡַ */
                                    len = sizeof( MyManuInfo );
                                    break;
                                    
                                case 2:
                                    pDescr = (PUINT8)( &MyProdInfo[ 0 ] );      /* ȡƷַ */
                                    len = sizeof( MyProdInfo );
                                    break;
                                    
                                case 0:
                                    pDescr = (PUINT8)( &MyLangDescr[ 0 ] );     /* ȡIDַ */
                                    len = sizeof( MyLangDescr );
                                    break;
                                
                                default:
                                    status = 0xFF;                              /* ʧ */
                                    break;
                            }
                            break;
                        
                        case 6:                                                 /* 豸޶ */
                            pDescr = ( PUINT8 )( &My_QueDescr[ 0 ] );
                            len = sizeof( My_QueDescr );
                            break;
                        
                        case 7:                                                 /* ٶ */
                            if( gUsbSpeed == USB_DEV_SPEED_HS )                 /* ģʽ */
                            {
                                pDescr = ( PUINT8 )( &My_HS_OscDescr[ 0 ] );
                                len = sizeof( My_HS_OscDescr );                                
                            }
                            else
                            {
                                pDescr = ( PUINT8 )( &My_FS_OscDescr[ 0 ] );
                                len = sizeof( My_FS_OscDescr );    
                            }
                            break;
                        case 0x22:
                            pDescr = ( PUINT8 )( &MyReportDescr[ 0 ] );
                            len = sizeof( MyReportDescr );    
                            break;                                               
                        default:
                            status = 0xFF;                                      /* ʧ */
                            break;
                    }
                    break;
                                
                case USB_REQ_SET_ADDRESS:                                       /* CMD: SET_ADDRESS */    
                    gUsbFlag |= DEF_BIT_USB_ADDRESS;                            /* õַ־ */            
                    if( SetupReqBuf.wValueL < 0x80 )
                    {
                        USBDev_SetAddress( SetupReqBuf.wValueL );               /* õַ: עооƬһSETUPʱõַЧ */                            
                    }
                    else
                    {
                        status = 0xFF;                                          /* ʧ */    
                    }
                    break;
                                
                case USB_REQ_GET_CONFIG:                                        /* CMD: GET_CONFIG */
                    buf[ 0 ] = gUsbConfig;
                    len = 0x01;
                    pDescr = buf;
                    break;
                                
                case USB_REQ_SET_CONFIG:                                        /* CMD: SET_CONFIG */
                    gUsbFlag |= DEF_BIT_USB_SET_CFG;                            /* ñ־ */
                    gUsbConfig = SetupReqBuf.wValueL;
                    USBDev_SetConfig( );                                        /* USBλ */
                    break;
                                
                case USB_REQ_CLR_FEATURE:                                       /* Clear Feature */
                    if( ( SetupReqBuf.bReqType & 0x1F ) == 0x00 )               /* 豸 */ 
                    {                                         
                        if( ( ( ( UINT16 )SetupReqBuf.wValueH << 8 ) | SetupReqBuf.wValueL ) == 0x01 )
                        {
                            if( gUsbSpeed == USB_DEV_SPEED_HS )                 /* ģʽ */
                            {
                                if( My_HS_CfgDescr[ 7 ] & 0x20 ) 
                                {
                                    gUsbFlag &= ~DEF_BIT_USB_WAKE;              /* ûѽֹ־ */
                                }
                                else 
                                {
                                    status = 0xFF;                              /* ʧ */
                                }
                            }
                            else
                            {
                                if( My_FS_CfgDescr[ 7 ] & 0x20 ) 
                                {    
                                    gUsbFlag &= ~DEF_BIT_USB_WAKE;              /* ûѽֹ־ */
                                }
                                else 
                                {
                                    status = 0xFF;                              /* ʧ */
                                }
                            }
                        }
                        else 
                        {
                            status = 0xFF;                                      /* ʧ */
                        }    
                    }                    
                    else if( ( SetupReqBuf.bReqType & 0x1F ) == 0x02 )          /* ˵ */
                    {      
                        switch( ( ( UINT16 )SetupReqBuf.wIndexH << 8 ) | SetupReqBuf.wIndexL ) 
                        {
                            case 0x82:
                                USBDev_EPx_IN_Stall( 0x02, 0x00 );              /* STALL */
                                USBDev_EPx_IN_ResetToggle( 0x02 );              /* λͬ־ */
                                break;
                            
                            case 0x02:
                                USBDev_EPx_OUT_Stall( 0x02, 0x00 );             /* STALL */
                                USBDev_EPx_OUT_ResetToggle( 0x02 );             /* λͬ־ */
                                break;
                            
                            case 0x81:
                                USBDev_EPx_IN_Stall( 0x01, 0x00 );              /* STALL */
                                USBDev_EPx_IN_ResetToggle( 0x01 );              /* λͬ־ */
                                break;
                            
                            case 0x01:
                                USBDev_EPx_OUT_Stall( 0x01, 0x00 );             /* STALL */
                                USBDev_EPx_OUT_ResetToggle( 0x01 );             /* λͬ־ */
                                break;
                            
                            default:
                                status = 0xFF;                                  /* ʧ */
                                break;
                        }
                    }
                    else
                    {
                        status = 0xFF;                                          /* ʧ */
                    }
                    break;

                case USB_REQ_SET_FEATURE:                                       /* Set Feature */
                    if( ( SetupReqBuf.bReqType & 0x1F ) == 0x00 )               /* 豸 */
                    {
                        if( ( ( ( UINT16 )SetupReqBuf.wValueH << 8 ) | SetupReqBuf.wValueL ) == 0x01 )
                        {
                            if( gUsbSpeed == USB_DEV_SPEED_HS )                 /* ģʽ */
                            {
                                if( My_HS_CfgDescr[ 7 ] & 0x20 ) 
                                {
                                    gUsbFlag |= DEF_BIT_USB_WAKE;               /* ûʹܱ־ */
                                }
                                else 
                                {
                                    status = 0xFF;                              /* ʧ */
                                }
                            }
                            else
                            {
                                if( My_HS_CfgDescr[ 7 ] & 0x20 ) 
                                {
                                    gUsbFlag |= DEF_BIT_USB_WAKE;               /* ûʹܱ־ */
                                }
                                else 
                                {    
                                    status = 0xFF;                              /* ʧ */
                                }
                            }
                        }
                        else 
                        {
                            status = 0xFF;                                      /* ʧ */
                        }
                    }
                    else if( ( SetupReqBuf.bReqType & 0x1F ) == 0x02 )          /* ö˵ */
                    {
                        if( ( ( ( UINT16 )SetupReqBuf.wValueH << 8 ) | SetupReqBuf.wValueL ) == 0x00 )
                        {
                            switch( ( ( UINT16 )SetupReqBuf.wIndexH << 8 ) | SetupReqBuf.wIndexL ) 
                            {
                                case 0x82:
                                    USBDev_EPx_IN_Stall( 0x02, 0x01 );          /* ö˵2 IN STALL */
                                    break;

                                case 0x02:
                                    USBDev_EPx_OUT_Stall( 0x02, 0x01 );         /* ö˵2 OUT Stall */
                                    break;

                                case 0x81:
                                    USBDev_EPx_IN_Stall( 0x01, 0x01 );          /* ö˵1 IN STALL */
                                    break;

                                default:
                                    status = 0xFF;                              /* ʧ */
                                    break;
                            }
                        }
                        else 
                        {
                            status = 0xFF;                                      /* ʧ */
                        }
                    }
                    else 
                    {
                        status = 0xFF;                                          /* ʧ */
                    }    
                    break;

                case USB_REQ_SET_INTERF:                                        /* Set Interface */
                    gUsbInterCfg = SetupReqBuf.wIndexL;                         /* ӿ */
#if 1
                    if( gUsbInterCfg == 1 ){
                        if( SetupReqBuf.wValueL == 1 ) 
                            USB_DEV_FIFO_CONFIG = USB_DEV_FIFO_CONFIG & (~(1<<17)) | (1<<16);                        
                                                                                /* FIFO2  OUT ISO */
                       else USB_DEV_FIFO_CONFIG = USB_DEV_FIFO_CONFIG & (~(1<<17)) & (~(1<<16));                        
                                                                                /* FIFO2  OUT RESV */

                    }
                    if( gUsbInterCfg == 2){
                        if( SetupReqBuf.wValueL == 1 )
                            USB_DEV_FIFO_CONFIG = USB_DEV_FIFO_CONFIG & (~(1<<9)) | (1<<8);                        
                                                                                /* FIFO1  IN  ISO */
                        else USB_DEV_FIFO_CONFIG = USB_DEV_FIFO_CONFIG & (~(1<<9)) & (~(1<<8));
                                                                                /* FIFO1  IN  RESV */
                    } 
#endif
                    break;
                
                case USB_REQ_GET_INTERF:                                        /* CMD: GET_INTERF */
                    buf[ 0 ] = gUsbInterCfg;
                    pDescr = buf;
                    len = 1;                                        
                    break;
                
                case USB_REQ_GET_STATUS:                                        /* Get Status */
                    if( ( SetupReqBuf.bReqType & 0x1F ) == 0x00 )               /* ȡ豸״̬ */
                    {
                        if( ( ( UINT16 )SetupReqBuf.wValueH << 8 | SetupReqBuf.wValueL ) == 0x00 && 
                            ( ( UINT16 )SetupReqBuf.wIndexH << 8 | SetupReqBuf.wIndexL ) == 0x00 )
                        {
                            buf[ 0 ] = ( gUsbFlag & DEF_BIT_USB_WAKE ) ? 0x02 : 0x00;
                            buf[ 1 ] = 0x00;
                            pDescr = buf;
                            len = 2;
                        }
                        else 
                        {
                            status = 0xFF;                                      /* ʧ */    
                        }
                    }
                    else if( ( SetupReqBuf.bReqType & 0x1F ) == 0x02 )          /* ȡ˵״̬ */
                    {
                        if( ( ( UINT16 )SetupReqBuf.wValueH << 8 | SetupReqBuf.wValueL ) == 0x00 )
                        {
                            switch( ( UINT16 )SetupReqBuf.wIndexH << 8 | SetupReqBuf.wIndexL )   
                            {
                                case 0x82:
                                    buf[ 0 ] = ( USB_DEV_EP2_IN_MAXPKS & RB_STL_IEPx ) ? 0x01 : 0x00;
                                    break;

                                case 0x02:
                                    buf[ 0 ] = ( USB_DEV_EP2_OUT_MAXPKS & RB_STL_OEPx ) ? 0x01 : 0x00;
                                    break;

                                case 0x81:
                                    buf[ 0 ] = ( USB_DEV_EP1_IN_MAXPKS & RB_STL_IEPx ) ? 0x01 : 0x00;
                                    break;

                                default:
                                    status = 0xFF;                              /* ʧ */
                                    break;
                            }
                            buf[ 1 ] = 0x00;
                            len = 2;
                            pDescr = buf;                            
                        }
                        else 
                        {
                            status = 0xFF;                                      /* ʧ */
                        }
                    }
                    else 
                    {
                        status = 0xFF;                                          /* ʧ */
                    }
                    break;
                                
                default:
                    status = 0xFF;                                              /* ʧ */
                    break;
            }
        }
    }
    else 
    {
        status = 0xFF;                                                          /* ʧ */
    }
    
    if( status == 0xFF ) 
    {  
        /* ʧ */
        USBDev_EP0_Stall( );                                                    /* ˵0STALL */
    }
    else
    {
        gSetupLen = gSetupLen < len ? gSetupLen : len;                          /* ܳ */
        if( gSetupLen )
        {                
            if( SetupReqBuf.bReqType & 0x80 )                                   /* ϴ */
            {                
                len = gSetupLen>=USB_EP0_MAX_PKT ? USB_EP0_MAX_PKT : gSetupLen; /* 㱾δ䳤 */                    
                memcpy( USB_Tran_Buf, pDescr, len );                            /* FlashROMеconstݸƵRAMУԱDMAȡ */ 
                  USBDev_WR_FIFOx( USB_DMA_ACC_CXF, len, (UINT8 *)USB_Tran_Buf ); /* ϴݵFIFO 4 */
                gSetupLen -= len;                                               /* 㴫䳤 */
                pDescr += len;                                                  /* ָƫ */
                if( gSetupLen == 0 )
                {
                    USB_DEV_CX_CONF_FIFO_STATUS |= RB_DONE;                     /* ȫϴ,ö˵0ݴ */
                }
            }        
        }
        else                                            
        {
            USB_DEV_CX_CONF_FIFO_STATUS |= RB_DONE;                             /* ö˵0ݴ */    
        }    
    }    
}

/*******************************************************************************
* Function Name  : USBDev_EP0_IN_Deal
* Description    : USBƶ˵IN
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EP0_IN_Deal( void )
{
    UINT16 len;
        
    switch( gSetupReq ) 
    {
        case USB_REQ_GET_DESCR:        
            len = gSetupLen >= USB_EP0_MAX_PKT ? USB_EP0_MAX_PKT : gSetupLen;   /* δ䳤 */
            memcpy( USB_Tran_Buf, pDescr, len );                                /* FlashROMеconstݸƵRAMУԱDMAȡ */
            USBDev_WR_FIFOx( USB_DMA_ACC_CXF, len, (UINT8 *)USB_Tran_Buf );     /* ϴ */
            gSetupLen -= len;
            pDescr += len;                    
            if( len < USB_EP0_MAX_PKT )                                         /* жǷȫϴ */    
            {
                USB_DEV_CX_CONF_FIFO_STATUS |= RB_DONE;                         /* ö˵0ݴ */    
            }                
            break;
            
        default:
            break;
    }
}

/*******************************************************************************
* Function Name  : USBDev_EP0_OUT_Deal
* Description    : USBƶ˵OUT
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EP0_OUT_Deal( void )
{
    
}

/*******************************************************************************
* Function Name  : USBDev_EP2_IN_Deal
* Description    : USB˵2 IN
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EP2_IN_Deal( void )
{
#if  MY_DEBUG_PRINTF         
    printf("USBDev_EP2_IN_Deal...\n");
#endif

    /* ϴе */
    if( gUsbSpeed == USB_DEV_SPEED_HS )                                         /* ģʽ */
    {
        USBDev_WR_FIFOx( USB_DMA_ACC_F1, gRecvLen, (PUINT8)USB_Tran_Buf );
    }
    else
    {
        memset(USB_Tran_Buf,0x55,16);
        gRecvLen = 16;
        USBDev_WR_FIFOx( USB_DMA_ACC_F1, gRecvLen, (PUINT8)USB_Tran_Buf );
    }
}

/*******************************************************************************
* Function Name  : USBDev_EP2_OUT_Deal
* Description    : USB˵2 OUT
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void USBDev_EP2_OUT_Deal( void )
{
    UINT32    len,i;

    /* ´ȡ */
    if( gUsbSpeed == USB_DEV_SPEED_HS )                                         /* ģʽ */
    {
        len = USBDev_RD_FIFOx( USB_DMA_ACC_F2, 512, (PUINT8)USB_Recv_Buf );     /* ȡEP2_OUT */                
    }
    else
    {
        len = USBDev_RD_FIFOx( USB_DMA_ACC_F2, 64, (PUINT8)USB_Recv_Buf );      /* ȡEP2_OUT */
    }
    pwm.DatLen = len>>2;
    for( i=0;i<pwm.DatLen;i++ ){
        pwm.DatBuf[i] = ((USB_Recv_Buf[i]>>8) + 0x80)&0xff;
        pwm.DatBuf[i] = pwm.DatBuf[i]*6;
    }
    pwm.DatBuf[i] = pwm.DatBuf[i-1]; 
    Star_PWM_DMA( );
}

/*******************************************************************************
* Function Name  : USBDev_EPx_Up_0BytePack
* Description    : USB豸EPxIN˵ϴ0Ȱ
* Input          : epx_num---˵(ΧΪ:1---8)
* Output         : None
* Return         : None
*******************************************************************************/
void USBDev_EPx_Up_0BytePack( UINT8 epx_num )
{
    UINT32 addr;
    UINT32 reg;    
    
    addr = USB_BASE_ADDR + 0x160 + 4 * ( epx_num - 1 );
    reg  = (*((PUINT32V)addr));
    (*((PUINT32V)addr)) = reg | RB_TX0BYTE_IEPx;        
}
                            
/*******************************************************************************
* Function Name  : USBDev_IRQHandler
* Description    : USBжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBDev_IRQHandler( void )
{
    UINT32 grp_int, intstatus;

    /* жǷUSB豸жϲ, */    
    if( USB_GL_INT_STATUS & RB_DEV_INT )                                        /* жǷUSB豸жϲ */
    {
        USB_GL_INT_STATUS = USB_GL_INT_STATUS | RB_DEV_INT;                     /* λд10 */  

        grp_int = USB_DEV_INT_GROP;                                             /* ȡUSBжϵжԴ */
        if( grp_int & 0x01 )                                                    /* grop0: control transfer interrupt */
        {
            intstatus = USB_DEV_INT_GROP0;             
            if( intstatus & RB_CX_COMABORT_INT  )                               /* R(0x140)λ5 ƴʧ */
            {        
                USB_DEV_INT_GROP0 = intstatus | RB_CX_COMABORT_INT;             /* USB˵0 OUTж(д10) */                        
            }    
            if( intstatus & RB_CX_COMFAIL_INT )                                 /* R(0x140)λ4ƶ˵INOUTʧ */
            {
                /* жλֻ,Ӳ0 */                
                USBDev_EP0_Stall( );                                            /* ˵0STALL */
            }
            if( intstatus & RB_CX_COMEND )                                      /* R(0x140)λ3״̬׶ */
            {
                /* ƴ״̬׶ */
                /* жλֻ,Ӳ0 */
            }
            if( intstatus & RB_CX_OUT_INT )                                     /* R(0x140)λ2ƶ˵OUTж */
            {                
                /* ƶ˵OUTжϴ */                                    
                USBDev_EP0_OUT_Deal( );        
                        
                /* жλֻ,Ӳ0 */
            }
            if( intstatus & RB_CX_IN_INT )                                      /* R(0x140)λ1ƶ˵INж */
            {
                /* ƶ˵INжϴ */                                
                USBDev_EP0_IN_Deal( );
                
                /* жλֻ,Ӳ0 */
            }
            if( intstatus & RB_CX_SETUP_INT )                                   /* R(0x140)λ0ƶ˵SETUPж */
            {
                /* ƶ˵SETUPжϴ */
                USBDev_EP0_Setup_Deal( );
                
                /* жλֻ,Ӳ0 */
            }                        
        }    
        if( grp_int & 0x02 )                                                    /* grop1: bulk/ISO/Interrupt interrupt */
        {
            intstatus = USB_DEV_INT_GROP1;         

            /* üĴжλΪֻ,Ӳ0 */
            if( intstatus & RB_F3_IN_INT )                                      /* FIFO3 IN interrupt */
            {                
                USB_DEV_MASK_INT_GROP1 |= RB_MF3_IN_INT;                        /* ֹFIFO3ж */
                /* Ӵ */                                                
            }
            if( intstatus & RB_F2_IN_INT )                                      /* FIFO2 IN interrupt */
            {                
                USB_DEV_MASK_INT_GROP1 |= RB_MF2_IN_INT;                        /* ֹFIFO2ж */
                /* Ӵ */    
            }
            if( intstatus & RB_F1_IN_INT )                                      /* FIFO1 IN interrupt */
            {
                USB_DEV_MASK_INT_GROP1 |= RB_MF1_IN_INT;                        /* ֹFIFO1ж */
                /* Ӵ */                    
            }
            if( intstatus & RB_F0_IN_INT )                                      /* FIFO0 IN interrupt */
            {    
                USB_DEV_MASK_INT_GROP1 |= RB_MF0_IN_INT;                        /* ֹFIFO0ж */
                /* Ӵ */                                    
            }
            if( intstatus & RB_F3_SPK_INT )                                     /* FIFO3 Short OUT interrupt */
            {                
            }
            if( intstatus & RB_F3_OUT_INT )                                     /* FIFO3 OUT interrupt */
            {                
                /* Ӵ */
            }
            if( intstatus & RB_F2_SPK_INT )                                     /* FIFO2 Short OUT interrupt */
            {                
            }
            if( intstatus & RB_F2_OUT_INT )                                     /* FIFO2 OUT interrupt */
            {                
                USBDev_EP2_OUT_Deal( );                                         /* ´ */
            }
            if( intstatus & RB_F1_SPK_INT )                                     /* FIFO1 Short OUT interrupt */
            {                
            }
            if( intstatus & RB_F1_OUT_INT )                                     /* FIFO1 OUT interrupt */
            {
                /* Ӵ */                            
            }
            if( intstatus & RB_F1_IN_INT )                                     /* FIFO1 IN interrupt */
            {
                USBDev_EP2_IN_Deal( );                                            
            }
            if( intstatus & RB_F0_SPK_INT )                                     /* FIFO0 Short OUT interrupt */
            {                
            }
            if( intstatus & RB_F0_OUT_INT )                                     /* FIFO0 OUT interrupt */
            {                
                /* Ӵ */
            }
        }    
        if( grp_int & 0x04 )                                                    /* grop2: bulk/ISO/Interrupt interrupt */ 
        {
            intstatus = USB_DEV_INT_GROP2; 
            
            if( intstatus & RB_DEV_WAKEUP_BYBUS )                               /* Dev_Wakeup_byVBUS interrupt */
            {                
                /* 豸VBUSж */
                /* жλֻ,Ӳ0 */                
            }            
            if( intstatus & RB_DEV_IDLE )                                       /* Dev_Idle interrupt */
            {                
                /* 豸ж */
                /* жλֻ,Ӳ0 */                
            }            
            if( intstatus & RB_DMA_ERROR )                                      /* DMA Error interrupt */
            {                
                /* DMAж */
                USB_DEV_INT_GROP2 = RB_DMA_ERROR;                               /* DMAж(д10) */                                
            }            
            if( intstatus & RB_DMA_CMPLT )                                      /* DMA Completion interrupt */
            {                
                /* DMAж */
                USB_DEV_INT_GROP2 = RB_DMA_CMPLT;                               /* DMAж(д10) */                
            }            
            if( intstatus & RB_RX0BYTE_INT )                                    /* Received Zero-length Data Packet interrupt */
            {                
                /* 0ݰж */
                USB_DEV_INT_GROP2 |= RB_RX0BYTE_INT;                            /* 0ݰж(д10) */
                USB_DEV_RECV_0_LEN_PACK = 0x00;
            
                /* Ӵ,ʵҪUSB_DEV_RECV_0_LEN_PACKж´0ȰĶ˵,ٽд */
            }            
            if( intstatus & RB_TX0BYTE_INT )                                    /* Transferred Zero-length Data Packet interrupt */
            {                
                /* 0ݰж */
                USB_DEV_INT_GROP2 |= RB_TX0BYTE_INT;                            /* 巢0ݰж(д10) */
                USB_DEV_SEND_0_LEN_PACK = 0x00;                                 /* жϱ־ */
                
                /* Ӵ,ʵҪUSB_DEV_SEND_0_LEN_PACKжϴ0ȰĶ˵,ٽд */                            
            }            
            if( intstatus & RB_ISO_SEQ_ABORT_INT )                              /* ISO Sequential Abort interrupt */
            {                                
                /* USB ISO쳣ж */
                USB_DEV_INT_GROP2 = RB_ISO_SEQ_ABORT_INT;                       /* USB ISO쳣ж(д10) */            
            }            
            if( intstatus & RB_ISO_SEQ_ERR_INT )                                /* ISO Sequential Error interrupt */
            {            
                /* USB ISOж */
                USB_DEV_INT_GROP2 = RB_ISO_SEQ_ERR_INT;                         /* USB ISOж(д10) */            
            }            
            if( intstatus & RB_RESMQ_INT )                                      /* Resume interrupt */
            {                
                /* USB߻ָж */
                USB_DEV_INT_GROP2 = RB_RESMQ_INT;                               /* USB߻ָж(д10) */
                gUsbFlag &= ~DEF_BIT_USB_SUPD;                                  /* ߹־ */
                USB_DEV_CONTROL &= ~RB_GOSUSP;                                  /* PHY */            
            }            
            if( intstatus & RB_SUSP_INT )                                       /* Suspend interrupt */
            {                
                /* USB߹ж */
                USB_DEV_INT_GROP2 = RB_SUSP_INT;                                /* USB߹ж(д10) */    
                gUsbFlag |= DEF_BIT_USB_SUPD;                                   /* ߹־ */
                USB_DEV_CONTROL |= RB_GOSUSP;                                   /* PHY */        
            }            
            if( intstatus & RB_USBRST_INT )                                     /* USB Reset interrupt */
            {    
                USB_DEV_INT_GROP2 = RB_USBRST_INT;            
                gUsbFlag = DEF_BIT_USB_RESET;                                   /*  ־,øλ־ */
        
                /* USB߸λ,Զַ */                                                                     
                USB_DEV_ADDRESS = 0;                                            /* USB豸ַ(ʵʸλʱԶ0) */
            }
        }
    }
    else 
    {
        USB_GL_INT_STATUS = USB_GL_INT_STATUS | RB_HC_INT | RB_OTG_INT;         /* λд10 */  
    }        
}

/*********************************** endfile **********************************/
