/********************************** (C) COPYRIGHT ******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563 AUDIO Demo Test
*                      (1)CH563 USB Device Examples by KEIL;    
*                      (2)0Ϣ,115200bps;
*                      (3)óжϷʽ;
*                      (4)ģUSB.CH563Բ
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "CH563USBSFR.H"                                                        /* оƬUSBĴͷļ */
#include "USB_DEVICE.H"                                                         /* USB豸ͷļ */
#include "SYSFREQ.H"                                                            /* ϵͳͷļ */    
#include "PRINTF.H"                                                             /* ڴӡͷļ */
#include "AUDIO.H"

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void IRQ_Handler( void )
{
    UINT8 i;

    if( R8_INT_FLAG_1 & RB_IF_USB )                                             /* USBж */
    {
        if( USB_GL_INT_STATUS & RB_DEV_INT )
        {
            USBDev_IRQHandler( );                                               /* USB豸жϴ */
        }
    }
    if(R8_INT_FLAG_0 & RB_IF_TMR0)                                              /* жǲǶʱ0صж */
    {
        i = R8_TMR0_INT_FLAG;
           if( i&RB_TMR_IF_DMA_END ){
            R8_TMR0_CTRL_MOD &= ~(RB_TMR_COUNT_EN|RB_TMR_OUT_EN);               /* رնʱ */
            R16_TMR0_DMA_BEG = (UINT32)&pwm.DatBuf[0];                          /* ׵ַDMAʼַ */
            R8_TMR0_INT_FLAG = RB_TMR_IF_DMA_END;                               /* Ӧжϱ־ */
            R8_INT_FLAG_0 |= RB_IF_TMR0;                                        /* Ӧжϱ־ */
        }
    }
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}
/*******************************************************************************
* Function Name  : Tim0_IRQ_Init
* Description    : PWMʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Tim0_IRQ_Init( )
{
    pwm.EndCount = 100000000/8000/8;
    printf("end count=%8d\n",pwm.EndCount);
    R8_TMR0_INT_FLAG=0xff;                                                      /* ежϱ־ */                                           
    R8_INT_EN_IRQ_0=RB_IE_IRQ_TMR0;                                             /* ֻʱ0жϲ */
    R8_TMR0_INTER_EN |= RB_TMR_IE_DMA_END;                                      /* DMAж */
    R8_INT_EN_IRQ_GLOB= RB_IE_IRQ_GLOB;                                         /* ֻIRQȫж */
    R8_TMR0_CTRL_DMA= (RB_TMR_DMA_ENABLE)|(RB_TMR_DMA_LOOP&0);                  /* DMAֹDMAѭ */
    R32_TMR0_CNT_END = pwm.EndCount;                                            /* PWM */
    R8_TMR0_CTRL_MOD = 0x00;                                                    /* 0 */
/* 16 */
//    R8_TMR0_CTRL_MOD |= (1<<7)|(1<<6);                                        /* timer PWM repeat mode: 00=1, 01=4, 10=8, 11-16 */
/* 8 */
    R8_TMR0_CTRL_MOD |= (1<<7);                                                 /* timer PWM repeat mode: 00=1, 01=4, 10=8, 11-16 */
/* 4 */
//    R8_TMR0_CTRL_MOD |= (1<<6);                                               /* timer PWM repeat mode: 00=1, 01=4, 10=8, 11-16 */
    R32_PB_DIR |= PWM0;                                                         /* PB0Ϊʱ0ţΪ */
}
void Star_PWM_DMA( )
{
    R16_TMR0_DMA_BEG = (UINT32)&pwm.DatBuf[0];                                  /* ׵ַDMAʼַ */
    R16_TMR0_DMA_END = (UINT32)&pwm.DatBuf[pwm.DatLen+2];                       /* ĽַDMAַ */
    R8_TMR0_CTRL_MOD|=(RB_TMR_COUNT_EN|RB_TMR_OUT_EN);                          /* ʱ */
}
/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void ) 
{
    Delay_ms( 100 );
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */
#if  MY_DEBUG_PRINTF 
    printf("CH563 USB Device Test\n");
#endif
    Tim0_IRQ_Init( );
    USBDev_ModeSet( );                                                          /* USBΪ豸ģʽ */
    USBDev_Init( );                                                             /* USB豸ʼ */
    USBDev_UsbInt_Enable( );                                                    /* USB豸жʹ */
    while( 1 )
    {
        /* вжд */
    }
}

/*********************************** endfile **********************************/
