/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.0
* Date               : 2013/11/15
* Description        : CH563 USB WAKE_INT DEMO
*                      (1)CH563 USB Device Examples by KEIL;    
*                      (2)0Ϣ,115200bps;
*                      (3)óжϷʽ,PB3һź(͸ߵƽź)ɲź;
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"
#include "CH563USBSFR.H"                                                        /* оƬUSBĴͷļ */
#include "USB_DEVICE.H"                                                         /* USB豸ͷļ */
#include "PRINTF.H"                                                             /* ڴӡͷļ */
/* һLEDڼʾĽ,͵ƽLED */
#define LED                     1<<4

#define LED_OUT_INIT(  )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }          /* LED ߵƽΪ */
#define LED_OUT_ACT(  )      { R32_PB_CLR |= LED; }                             /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT(  )    { R32_PB_OUT |= LED; }                             /* LED ߵƽرLEDʾ */

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    if( !(R32_PB_PIN & (1<<3)) ) {
        Delay_ms( 100 );
        if( !(R32_PB_PIN & (1<<3)) ) {
            R32_PA_DIR |= 1<<8;
            R32_PA_OUT &= ~( 1<<8 );
            while( !(R32_PB_PIN & (1<<3)) );
            R32_PA_OUT |= ( 1<<8 );
#if  MY_DEBUG_PRINTF    
            printf("GPIO PB input = %8x\n",(UINT32)R32_PB_PIN&(1<<3));
#endif
            R8_SAFE_ACCESS_SIG = 0x57;                                          /* unlock step 1 */ 
            R8_SAFE_ACCESS_SIG = 0xA8;                                          /* unlock step 2 */ 
//            R8_SLP_WAKE_CTRL |= RB_SLP_USB_WAKE;                              /* USBʹ */ 
            R8_SLP_WAKE_CTRL |= RB_SLP_AP_WAK_USB;                              /* ӦóUSB */ 
            R8_SAFE_ACCESS_SIG = 0;
            Delay_ms( 20 );

            R8_SAFE_ACCESS_SIG = 0x57;        
            R8_SAFE_ACCESS_SIG = 0xA8;         
//            R8_SLP_WAKE_CTRL &= ~RB_SLP_USB_WAKE;                             /* ѽֹ */
            R8_SLP_WAKE_CTRL &= ~RB_SLP_AP_WAK_USB;                             /* رջź */ 
            R8_SAFE_ACCESS_SIG = 0;    
        }
    }
    if( R8_INT_FLAG_1 & RB_IF_USB ){                                            /* USBж */
        if( USB_GL_INT_STATUS & RB_HC_INT ){
//            USBHOST_EHCI_IRQHandler( );                                       /* USBжϴ */
        }
        else if( USB_GL_INT_STATUS & RB_DEV_INT ){
            USBDev_IRQHandler( );                                               /* USB豸жϴ */
        }
    }
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void FIQ_Handler( void )
{
    while( 1 );
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void ) 
{
    LED_OUT_INIT( );
    LED_OUT_ACT( );                                                             /* LEDһʾ */
    Delay_ms( 100 );
    LED_OUT_INACT( );
    R32_PB_DIR &= ~(1<<3);
    R32_PB_PU  |= (1<<3);
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */

#if  MY_DEBUG_PRINTF    
    printf( "CH563 Test\n" );
#endif
    /************************** 豸ģʽ **************************/       
    USBDev_ModeSet( );                                                          /* USBΪ豸ģʽ */
    USBDev_Init( );                                                             /* USB豸ʼ */
    USBDev_UsbInt_Enable( );                                                    /* USB豸жʹ */
    while( 1 );
}

/*********************************** endfile **********************************/
