/********************************** (C) COPYRIGHT *******************************
* File Name          : HID.C
* Author             : WCH
* Version            : V1.20
* Date               : 2013/11/15
* Description        : CH563 USB Host Controller HID Operate
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "CH563BAS.H"
#include "CH563SFR.H"
#include "CH563USBSFR.H"                                                        /* оƬUSBĴͷļ */    
#include "CH563USB.H"                                                           /* USBöͷļ */    
#include "EHCI_HCD.H"                                                           /* Ͳͷļ */
#include "PRINTF.H"                                                             /* ڴӡͷļ */
#include "HID.H"                                                                /* HIDඨͷļ */

/*******************************************************************************
* Function Name  : HID_CofDescrAnalyse
* Description    : HID
* Input          : *Hidinfo-----ǰHID豸ؽṹ
*                  *pbuf--------ǰҪ
* Output         : None
* Return         : USB_OPERATE_SUCCESS----HID豸; 
*                  USB_OPERATE_ERROR------豸
*******************************************************************************/
UINT8 HID_CofDescrAnalyse( HID_INFO *Hidinfo, UINT8 *pbuf )
{
    UINT16 i, j;
    UINT32 temp;

    /* 򵥷,Ϣ */    
    /* ڷ豸,ֻ̡Ľӿ,ӿ */
    Hidinfo->IntfacNum = pbuf[ 4 ];                                             /* ӿں */
    Hidinfo->ReportDes_Len1 = 0x00;
    Hidinfo->ReportDes_Len2 = 0x00;    
    for( i = 0; i < pbuf[ 2 ]; i++ )
    {
        if( ( pbuf[ i ] == 0x09 ) && ( pbuf[ i + 1 ] == 0x04 ) && ( pbuf[ i + 2 ] == 0x00 ) )
        {
            for( j = 0 ; j < pbuf[ 2 ] - i; j++ ) 
            {
                if( ( pbuf[ i + j ] == 0x09 ) && ( pbuf[ i + j + 1 ] == 0x21 ) && 
                    ( pbuf[ i + j + 6 ] == 0x22 ) )                             /* жǷΪHID˵ */    
                {    
                    Hidinfo->ReportDes_Len1 = pbuf[ i + j + 7 ];                /* 汨ĳ */    
                    Hidinfo->HidType = pbuf[ i + 7 ];                    
                    break;
                }
            }
            if( Hidinfo->IntfacNum == 0x01 )
            {
                break;
            }                    
        }
        else if( ( pbuf[ i ] == 0x09 ) && ( pbuf[ i + 1 ] == 0x04 ) && ( pbuf[ i + 2 ] == 0x01 ) )
        {
            for( j = 0 ; j < pbuf[ 2 ] - i; j++ ) 
            {
                if( ( pbuf[ i + j ] == 0x09 ) && ( pbuf[ i + j + 1 ] == 0x21 ) && 
                    ( pbuf[ i + j + 6 ] == 0x22 ) )                             /* жǷΪHID˵ */    
                {    
                    Hidinfo->ReportDes_Len2 = pbuf[ i + j + 7 ];                /* 汨ĳ */    
                    break;
                }
            }
            if( Hidinfo->ReportDes_Len2 != 0x00 )
            {
                break;
            }                    
        }                                
    }

    for( i = 0; i < pbuf[ 2 ]; i++ )
    {
        if( ( pbuf[ i ] == 0x09 ) && ( pbuf[ i + 1 ] == 0x04 ) && 
            ( pbuf[ i + 2 ] == 0x00 ) && ( pbuf[ i + 5 ] == 0x03 ) )            /* ӿΪHIDꡢ */   
        { 
            for( j = 0 ; j < pbuf[ 2 ] - i; j++ ) 
            {
                if( ( pbuf[ i + j ] == 0x07 ) && ( pbuf[ i + j + 1 ] == 0x05 ) && 
                    ( pbuf[ i + j + 3 ] == 0x03 ) )                             /* жǷΪж϶˵ */    
                {    
                    if( pbuf[ i + j + 2 ] & 0x80 )                              /* IN˵ĵַ */
                    {
                        Hidinfo->IntInEp1 = pbuf[ i + j + 2 ];                  /* IN˵1˵ */
                        Hidinfo->IntInEp1Size = pbuf[ i + j + 4 ];              /* IN˵1˵С */
                    }
                    break;                    
                }       
            }
            if( Hidinfo->IntfacNum == 0x01 )
            {
                break;
            }                    
        }
        else if( ( pbuf[ i ] == 0x09 ) && ( pbuf[ i + 1 ] == 0x04 ) && 
               ( pbuf[ i + 2 ] == 0x01 ) && ( pbuf[ i + 5 ] == 0x03 ) )         /* ӿΪHIDꡢ */   
        { 
            for( j = 0 ; j < pbuf[ 2 ] - i; j++ ) 
            {
                if( ( pbuf[ i + j ] == 0x07 ) && ( pbuf[ i + j + 1 ] == 0x05 ) && 
                    ( pbuf[ i + j + 3 ] == 0x03 ) )                             /* жǷΪж϶˵ */    
                {    
                    if( pbuf[ i + j + 2 ] & 0x80 )                              /* IN˵ĵַ */
                    {
                        Hidinfo->IntInEp2 = pbuf[ i + j + 2 ];                  /* IN˵2˵ */
                        Hidinfo->IntInEp2Size = pbuf[ i + j + 4 ];              /* IN˵2˵С */                                        
                    }
                    break;                     
                }       
            }                
        }                
    }
    if( ( Hidinfo->IntInEp1 == 0x00 ) && ( Hidinfo->IntInEp2 == 0x00 ) )
    {
        return( USB_OPERATE_ERROR );                                            /* ǰHID豸,ֱӷ */
    }

#ifdef  MY_DEBUG_PRINTF 
    printf(" Hidinfo->HidType:%x\n ",(UINT16)Hidinfo->HidType);            
    printf("Hidinfo->IntfacNum:%x\n",(UINT16)Hidinfo->IntfacNum);        
    printf("Hidinfo->IntInEp1:%x\n",(UINT16)Hidinfo->IntInEp1);
    printf("Hidinfo->IntInEp1Size:%x\n",(UINT16)Hidinfo->IntInEp1Size);
    printf("Hidinfo->ReportDes_Len1:%x\n",(UINT16)Hidinfo->ReportDes_Len1);
    printf("Hidinfo->IntInEp2:%x\n",(UINT16)Hidinfo->IntInEp2);
    printf("Hidinfo->IntInEp2Size:%x\n",(UINT16)Hidinfo->IntInEp2Size);
    printf("Hidinfo->ReportDes_Len2:%x\n",(UINT16)Hidinfo->ReportDes_Len2);
#endif

    /*******************************HID豸ڴ漰QH******************/
    if( Hidinfo->IntInEp1 )
    {    
        /* жϴQH(qHD_INT_In1) */
        temp = USBHOST_GetStructure( EHCI_MEM_TYPE_QHD );
        if( temp == USB_MEM_ALLOCATE_ERROR )
        {
            return( USB_MEM_ALLOCATE_ERROR );
        }    
        Hidinfo->qHD_INT_In1 = ( qHD_Structure *)temp;                          /* qHD_Structure */
    
        /* ʼIN˵QHD */
        USBHOST_Allocate_QHD( &Hidinfo->Device, 
                              Hidinfo->qHD_INT_In1, 
                              EHCI_HD_TYPE_QH, 
                              EHCI_EP_TYPE_NO_CONTROL, 
                              0, 
                              Hidinfo->IntInEp1, 
                              Hidinfo->IntInEp1Size );    
    
           /* ԴQHDָ */
        Hidinfo->qHD_INT_In1->bTerminate = 0x01;                                /* һָЧ */
    }
    
    if( Hidinfo->IntInEp2 )
    {    
        /* жϴQH(qHD_INT_In2) */
        temp = USBHOST_GetStructure( EHCI_MEM_TYPE_QHD );
        if( temp == USB_MEM_ALLOCATE_ERROR )
        {
            return( USB_MEM_ALLOCATE_ERROR );
        }    
        Hidinfo->qHD_INT_In2 = ( qHD_Structure *)temp;                          /* qHD_Structure */
    
        /* ʼIN˵QHD */
        USBHOST_Allocate_QHD( &Hidinfo->Device, 
                              Hidinfo->qHD_INT_In2, 
                              EHCI_HD_TYPE_QH, 
                              EHCI_EP_TYPE_NO_CONTROL, 
                              0, 
                              Hidinfo->IntInEp2, 
                              Hidinfo->IntInEp2Size );    

           /* ԴQHDָ */
        Hidinfo->qHD_INT_In2->bTerminate = 0x01;                                /* һָЧ */        
    }    
    return( USB_OPERATE_SUCCESS );
}

/*******************************************************************************
* Function Name  : HID_SetIdle
* Description    : HID豸SET IDLE
* Input          : *Hidinfo---ǰHIDؽṹ
*                   intface----ǰӿں
                   *buf-------ݻ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 HID_SetIdle( HID_INFO *Hidinfo, UINT8 intface, UINT8 *buf ) 
{
    UINT16 l;
    UINT8  status;
    
    /* SETUP */
    Ctl_Setup->bReqType = 0x21;
    Ctl_Setup->bRequest = 0x0A;
    Ctl_Setup->wValueL  = 0x00;
    Ctl_Setup->wValueH  = 0x00;
    Ctl_Setup->wIndexL  = intface;
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x00;
    Ctl_Setup->wLengthH = 0x00;
    
    /* SET_IDLE */
    l = 0x00;
    status = USBHOST_Issue_Control( &Hidinfo->Device, Ctl_Setup, buf, &l );     /* ִпƴ */    
    return( status );
}

/*******************************************************************************
* Function Name  : HID_GetReportDescr
* Description    : ȡHID౨
* Input          : *Hidinfo---ǰHIDؽṹ
*                   intface----ǰӿں
                   *buf-------ݻ
                   *len-------ݳ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 HID_GetReportDescr( HID_INFO *Hidinfo, UINT8 intface, UINT8 *buf, UINT16 len ) 
{
    UINT16 l;
    UINT8  status;
    
    /* SETUP */
    Ctl_Setup->bReqType = 0x81;
    Ctl_Setup->bRequest = 0x06;
    Ctl_Setup->wValueL  = 0x00;
    Ctl_Setup->wValueH  = 0x22;
    Ctl_Setup->wIndexL  = intface;
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = ( UINT8 )len;
    Ctl_Setup->wLengthH = ( UINT8)( len >> 8 );
    
    /* ȡHID౨ */
    l = len;
    status = USBHOST_Issue_Control( &Hidinfo->Device, Ctl_Setup, buf, &l );     /* ִпƴ */    
    return( status );
}

/*******************************************************************************
* Function Name  : HID_SetReport
* Description    : HID豸SET REPORT
* Input          : *Hidinfo---ǰHIDؽṹ
*                   intface----ǰӿں
                   *buf-------ݻ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 HID_SetReport( HID_INFO *Hidinfo, UINT8 intface, UINT8 *buf ) 
{
    UINT16 l;
    UINT8  status;
    
    /* SETUP */
    Ctl_Setup->bReqType = 0x21;
    Ctl_Setup->bRequest = 0x09;
    Ctl_Setup->wValueL  = 0x00;
    Ctl_Setup->wValueH  = 0x02;
    Ctl_Setup->wIndexL  = intface;
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x01;
    Ctl_Setup->wLengthH = 0x00;
    *buf = 0x00;                                                                /* ϨLEDָʾ */
    
    /* SET REPORT */
    l = 0x01;
    status = USBHOST_Issue_Control( &Hidinfo->Device, Ctl_Setup, buf, &l );     /* ִпƴ */    
    return( status );
}

/*******************************************************************************
* Function Name  : HID_ClassRequest_Deal
* Description    : HID
* Input          : *Hidinfo-----ǰHID豸ؽṹ
*                  *pbuf--------
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 HID_ClassRequest_Deal( HID_INFO *Hidinfo, UINT8 *pbuf )
{
    UINT8  status;
    UINT16 i;

    /**************************************************************************/    
    /* Set Idle */ 
#ifdef  MY_DEBUG_PRINTF            
    printf("Set Idle\n");        
#endif
    status = HID_SetIdle( Hidinfo, 0x00, pbuf );
    if( status )
    {
#ifdef  MY_DEBUG_PRINTF            
    printf("Set Idle Error\n");        
#endif        
    }
    
    /* еڶHIDӿ,ýӿ */
    if( ( Hidinfo->IntfacNum > 1 ) && ( Hidinfo->IntInEp2 != 0x00 ) )
    {
#ifdef  MY_DEBUG_PRINTF            
        printf("Set Idle2\n");        
#endif
        status = HID_SetIdle( Hidinfo, 0x01, pbuf );
        if( status )
        {
#ifdef  MY_DEBUG_PRINTF            
        printf("Set Idle2 Error\n");        
#endif        
        }        
    }

    /***********************************************************************************/      
    /* Get Report Desc */ 
#ifdef  MY_DEBUG_PRINTF            
    printf("Get Report Desc\n");        
#endif
    status = HID_GetReportDescr( Hidinfo, 0x00, pbuf, Hidinfo->ReportDes_Len1 + 0x40 );
    if( status )
    {
#ifdef  MY_DEBUG_PRINTF            
        printf("Get Report Desc Error\n");    
#endif        
    }
    else
    {
#ifdef  MY_DEBUG_PRINTF
        for( i = 0; i < Hidinfo->ReportDes_Len1; i++ )
        {
            printf("%02x ",pbuf[ i ]);        
        } 
        printf("\n"); 
#endif
    }

    /* еڶHIDӿ,ýӿ */
    if( ( Hidinfo->IntfacNum > 1 ) && ( Hidinfo->IntInEp2 != 0x00 ) )
    {
#ifdef  MY_DEBUG_PRINTF            
        printf("Get Report Desc2\n");        
#endif
        status = HID_GetReportDescr( Hidinfo, 0x01, pbuf, Hidinfo->ReportDes_Len2 + 0x40 );
        if( status )
        {
#ifdef  MY_DEBUG_PRINTF            
        printf("Get Report Desc2 Error\n");    
#endif        
        }
        else
        {
#ifdef  MY_DEBUG_PRINTF    
            for( i = 0; i < Hidinfo->ReportDes_Len2; i++ )
            {
                printf("%02x ",pbuf[ i ]);        
            } 
            printf("\n"); 
#endif
        }        
    }

    /***********************************************************************************/      
    /* SET REPORT */ 
    /* ֻ豸 */
    if( Hidinfo->HidType == HID_TYPE_KEYBOARD )
    {
#ifdef  MY_DEBUG_PRINTF            
        printf("Set Report\n");        
#endif
        status = HID_SetReport( Hidinfo, 0x00, pbuf );
        if( status )
        {
#ifdef  MY_DEBUG_PRINTF            
            printf("Set Report Error\n");    
#endif        
        }
    }
    return( status );        
}

/*******************************************************************************
* Function Name  : HID_Issue_GetData
* Description    : ȡ˵
* Input          : *Hidinfo-----ǰHID豸ؽṹ
*                  *spTempqHD---ǰҪִеQHD
*                  *pbuf--------ǰݻ
*                  len----------ǰȡ 
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 HID_Issue_GetData( HID_INFO *Hidinfo, qHD_Structure *spTempqHD, UINT8 *pbuf, UINT16 len )
{
    UINT32 temp;
    qTD_Structure *spTempqTD;

    /* ʼжϴķqTD */    
    spTempqTD = ( qTD_Structure *)USBHOST_GetStructure( EHCI_MEM_TYPE_QTD ); 
    spTempqTD->bTotalBytes = len;      
//    spTempqTD->bDataToggle = 0;  
    spTempqTD->ArrayBufferPointer_Word[ 0 ] = (UINT32)pbuf;
    temp = ( ( ( UINT32 )( pbuf ) >> 12 ) + 1 ) << 12;
    spTempqTD->ArrayBufferPointer_Word[ 1 ] = (UINT32)temp; 
    spTempqTD->ArrayBufferPointer_Word[ 2 ] = (UINT32)temp + 4096;                    
    spTempqTD->ArrayBufferPointer_Word[ 3 ] = (UINT32)temp + 2 * 4096;                    
    spTempqTD->ArrayBufferPointer_Word[ 4 ] = (UINT32)temp + 3 * 4096;                       
    spTempqTD->bPID = EHCI_QTD_PID_IN;             

    /* USBһQTD */
    temp = USBHOST_Issue_qTD( &Hidinfo->Device, spTempqTD, spTempqHD );

    if( spTempqHD == Hidinfo->qHD_INT_In1 )
    {    
        Hidinfo->IntInEp1qTD = ( qTD_Structure *)temp;                          /* ݴִеqTD */
    }
    else if( spTempqHD == Hidinfo->qHD_INT_In2 )
    {
        Hidinfo->IntInEp2qTD = ( qTD_Structure *)temp;                          /* ݴִеqTD */        
    } 
    return( USB_OPERATE_SUCCESS );
}

/*******************************************************************************
* Function Name  : HID_Check_Data
* Description    : ѯ˵Ƿȡ
* Input          : *Hidinfo-----ǰHID豸ؽṹ
*                  *spTempqHD---ǰҪִеQHD
*                  len----------ǰȡ 
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 HID_Check_Data( HID_INFO *Hidinfo, qHD_Structure *spTempqHD, UINT16 *len )
{
    UINT8  status = 0xFF;

    if( spTempqHD == Hidinfo->qHD_INT_In1 )
    {    
        status = USBHOST_Check_qTD( &Hidinfo->Device, Hidinfo->IntInEp1qTD, Hidinfo->qHD_INT_In1, len );    
    }
    else if( spTempqHD == Hidinfo->qHD_INT_In2 )
    {
        status = USBHOST_Check_qTD( &Hidinfo->Device, Hidinfo->IntInEp2qTD, Hidinfo->qHD_INT_In2, len );        
    } 
    return( status );
}

/*******************************************************************************
* Function Name  : HID_Stop_GetData
* Description    : ǿƳö˵ȡ
* Input          : *Hidinfo-----ǰHID豸ؽṹ
*                  *spTempqHD---ǰҪִеQHD
*                  len----------ǰȡ 
* Output         : None
* Return         : None
*******************************************************************************/

UINT8 HID_Stop_GetData( HID_INFO *Hidinfo, qHD_Structure *spTempqHD )
{
    UINT8  status = 0xFF;

    if( spTempqHD == Hidinfo->qHD_INT_In1 )
    {    
        status = USBHOST_Remove_qTD( &Hidinfo->Device, Hidinfo->IntInEp1qTD, Hidinfo->qHD_INT_In1 );    
    }
    else if( spTempqHD == Hidinfo->qHD_INT_In2 )
    {
        status = USBHOST_Remove_qTD( &Hidinfo->Device, Hidinfo->IntInEp2qTD, Hidinfo->qHD_INT_In2 );        
    }
    return( status );        
}

/*********************************** endfile **********************************/
