/********************************** (C) COPYRIGHT *******************************
* File Name          : HUB.C
* Author             : WCH
* Version            : V1.20
* Date               : 2013/11/15
* Description        : CH563 USB Host Controller HUB Operate
*                      ע: HUB˿ںСֵΪ1 
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include  <stdio.h>
#include  <string.h>
#include  <stdlib.h>
#include  "CH563BAS.H"
#include  "EHCI_HCD.H"                                                          /* Ͳͷļ */
#include  "CH563SFR.H"                                                          /* CH563Ĵͷļ */
#include  "CH563USBSFR.H"                                                       /* оƬUSBĴͷļ */    
#include  "CH563USB.H"                                                          /* USBöͷļ */    
#include  "HUB.H"                                                              
#include  "PRINTF.H"                                                            /* ڴӡͷļ */

/*******************************************************************************
* Function Name  : HUB_CofDescrAnalyse
* Description    : HUB
* Input          : *Hubinfo----ǰHUBؽṹ
*                  *pbuf-------ǰҪݻ
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 HUB_CofDescrAnalyse( HUB_INFO *Hubinfo, UINT8 *pbuf )
{
    UINT16 i;

    /* ,ȡ˵(˵ַ/˵С) */
    if ( ( (PUSB_CFG_DESCR_LONG)pbuf ) -> itf_descr.bInterfaceClass != USB_DEV_CLASS_HUB ) 
    {
        return( USB_OPERATE_ERROR );                                            /* HUB豸,ֱӷ  */
    }    

    Hubinfo->InterfNumber = ( (PUSB_CFG_DESCR_LONG)pbuf ) -> itf_descr.bInterfaceNumber;  /* ӿں */
    Hubinfo->IntInEp = 0x00;
    for( i = 0; i < 1; i ++ )                                                   /* ֻ1˵ */
    {
        if( ( (PUSB_CFG_DESCR_LONG)pbuf ) -> endp_descr[ i ].bLength == 0x07
            && ( (PUSB_CFG_DESCR_LONG)pbuf ) -> endp_descr[ i ].bDescriptorType == 0x05  
            && ( (PUSB_CFG_DESCR_LONG)pbuf ) -> endp_descr[ i ].bmAttributes == 0x03 ) 
        {      
            if( ( (PUSB_CFG_DESCR_LONG)pbuf ) -> endp_descr[ i ].bEndpointAddress & 0x80 )
            {    
                /* жIN˵ */
                Hubinfo->IntInEp = ( (PUSB_CFG_DESCR_LONG)pbuf ) -> endp_descr[ i ].bEndpointAddress & 0x0F;   /* IN˵ */
                Hubinfo->IntInEpSize = ( (PUSB_CFG_DESCR_LONG)pbuf ) -> endp_descr[ i ].wMaxPacketSizeH;
                Hubinfo->IntInEpSize = Hubinfo->IntInEpSize << 8;
                Hubinfo->IntInEpSize += ( (PUSB_CFG_DESCR_LONG)pbuf ) -> endp_descr[ i ].wMaxPacketSizeL;                
            }
        }
    }
    if( ( ( (PUSB_CFG_DESCR_LONG)pbuf ) -> itf_descr.bInterfaceClass != USB_DEV_CLASS_HUB )
      || ( Hubinfo->IntInEp == 0 ) )
    {                                                                           /* USB洢豸,֧ */
        return( USB_OPERATE_ERROR );                                            /* ֹ,ֱӷ */
    }

#ifdef  MY_DEBUG_PRINTF 
    printf("Hubinfo->IntInEp:%02x\n ",Hubinfo->IntInEp);
    printf("Hubinfo->IntInEpSize:%02x\n ",Hubinfo->IntInEpSize);
    printf("Hubinfo->InterfNumber:%02x\n ",Hubinfo->InterfNumber);
#endif
    return( TRUE );
}

/*******************************************************************************
* Function Name  : HUB_GetClassDevDescr
* Description    : ȡHUB
* Input          : *Hubinfo---ǰHUBؽṹ
                   *buf-------ݻ
                   *len-------ݳ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 HUB_GetClassDevDescr( HUB_INFO *Hubinfo, UINT8 *buf, UINT16 *len ) 
{
    UINT16 l;
    UINT8  status;
    
    /* SETUP */
    Ctl_Setup->bReqType = USB_GET_HUB_DESCR;
    Ctl_Setup->bRequest = USB_REQ_GET_DESCR;
    Ctl_Setup->wValueL  = 0x00;
    Ctl_Setup->wValueH  = 0x29;
    Ctl_Setup->wIndexL  = 0x00;
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x02;
    Ctl_Setup->wLengthH = 0x00;
    
    /* ȻȡHUBǰ2ֽ */    
    l = Ctl_Setup->wLengthL;
    status = USBHOST_Issue_Control( &Hubinfo->Device, Ctl_Setup, buf, &l );     /* ִпƴ */    
    if( status == USB_OPERATE_SUCCESS )
    {        
        /* ٻȡȫHUB */
        Ctl_Setup->wLengthL = buf[ 0 ];
        l = Ctl_Setup->wLengthL;
        status = USBHOST_Issue_Control( &Hubinfo->Device, Ctl_Setup, buf, &l ); /* ִпƴ */    
        if( status == USB_OPERATE_SUCCESS )
        {
            *len = l;
        }        
        else
        {
            *len = 0x00;
        }
        return( status );
    }
    return( status );
}

/*******************************************************************************
* Function Name  : HUB_ClearHubFeature
* Description    : HUB
* Input          : *Hubinfo---ǰHUBؽṹ
*                  *buf---ݻ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 HUB_ClearHubFeature( HUB_INFO *Hubinfo, UINT8 *buf, UINT8 selector ) 
{
    UINT16 len;
    
    /* SETUP */
    Ctl_Setup->bReqType = USB_CLEAR_HUB_FEATURE;
    Ctl_Setup->bRequest = USB_REQ_CLR_FEATURE;
    Ctl_Setup->wValueL  = selector;
    Ctl_Setup->wValueH  = 0x00;
    Ctl_Setup->wIndexL  = 0x00;
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x00;
    Ctl_Setup->wLengthH = 0x00;
    
    /* ִпƴ */        
    len = Ctl_Setup->wLengthL;
    return( USBHOST_Issue_Control( &Hubinfo->Device, Ctl_Setup, buf, &len ) );  /* ִпƴ */
}

/*******************************************************************************
* Function Name  : HUB_ClearPortFeature
* Description    : HUB˿
* Input          : *Hubinfo---ǰHUBؽṹ
*                  *buf---ݻ
*                  port---˿ں
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 HUB_ClearPortFeature( HUB_INFO *Hubinfo, UINT8 *buf, UINT8 port, UINT8 selector ) 
{
    UINT16 len;
    
    /* SETUP */
    Ctl_Setup->bReqType = USB_CLEAR_PORT_FEATURE;
    Ctl_Setup->bRequest = USB_REQ_CLR_FEATURE;
    Ctl_Setup->wValueL  = selector;
    Ctl_Setup->wValueH  = 0x00;
    Ctl_Setup->wIndexL  = port + 1;                                             /* С˿ںΪ1 */
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x00;
    Ctl_Setup->wLengthH = 0x00;
    
    /* ִпƴ */        
    len = Ctl_Setup->wLengthL;
    return( USBHOST_Issue_Control( &Hubinfo->Device, Ctl_Setup, buf, &len ) );  /* ִпƴ */
}

/*******************************************************************************
* Function Name  : HUB_GetHubStatus
* Description    : ѯHUB״̬
* Input          : *Hubinfo---ǰHUBؽṹ
*                   *buf-------ݻ(4ֽ: wHubStatuswHubChange)
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 HUB_GetHubStatus( HUB_INFO *Hubinfo, UINT8 *buf ) 
{
    UINT16 len;
    
    /* SETUP */
    Ctl_Setup->bReqType = USB_GET_PORT_STATUS;
    Ctl_Setup->bRequest = USB_REQ_GET_STATUS;
    Ctl_Setup->wValueL  = 0x00;
    Ctl_Setup->wValueH  = 0x00;
    Ctl_Setup->wIndexL  = 0x00;
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x04;
    Ctl_Setup->wLengthH = 0x00;
    
    /* ִпƴ */    
    len = Ctl_Setup->wLengthL;
    return( USBHOST_Issue_Control( &Hubinfo->Device, Ctl_Setup, buf, &len ) );  /* ִпƴ */
}

/*******************************************************************************
* Function Name  : HUB_GetPortStatus
* Description    : ѯHUB˿״̬
* Input          : *Hubinfo---ǰHUBؽṹ(4ֽ: wPortStatuswPortChange)
*                   *buf-------ݻ
*                  port-------˿ں
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 HUB_GetPortStatus( HUB_INFO *Hubinfo, UINT8 *buf, UINT8 port ) 
{
    UINT16 len;
    
    /* SETUP */
    Ctl_Setup->bReqType = USB_GET_PORT_STATUS;
    Ctl_Setup->bRequest = USB_REQ_GET_STATUS;
    Ctl_Setup->wValueL  = 0x00;
    Ctl_Setup->wValueH  = 0x00;
    Ctl_Setup->wIndexL  = port + 1;                                             /* С˿ںΪ1 */
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x04;
    Ctl_Setup->wLengthH = 0x00;
    
    /* ִпƴ */    
    len = Ctl_Setup->wLengthL;
    return( USBHOST_Issue_Control( &Hubinfo->Device, Ctl_Setup, buf, &len ) );  /* ִпƴ */
}

/*******************************************************************************
* Function Name  : HUB_SetHubFeature
* Description    : HUB˿
* Input          : *Hubinfo---ǰHUBؽṹ
*                  *buf---ݻ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 HUB_SetHubFeature( HUB_INFO *Hubinfo, UINT8 *buf, UINT8 selector ) 
{
    UINT16 len;
    
    /* SETUP */
    Ctl_Setup->bReqType = USB_SET_HUB_FEATURE;
    Ctl_Setup->bRequest = USB_REQ_SET_FEATURE;
    Ctl_Setup->wValueL  = selector;
    Ctl_Setup->wValueH  = 0x00;
    Ctl_Setup->wIndexL  = 0x00;                                            
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x00;
    Ctl_Setup->wLengthH = 0x00;
    
    /* ִпƴ */    
    len = Ctl_Setup->wLengthL;
    return( USBHOST_Issue_Control( &Hubinfo->Device, Ctl_Setup, buf, &len ) );  /* ִпƴ */
}

/*******************************************************************************
* Function Name  : HUB_SetPortFeature
* Description    : HUB˿
* Input          : *Hubinfo---ǰHUBؽṹ
*                  *buf---ݻ
*                  port---˿ں
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 HUB_SetPortFeature( HUB_INFO *Hubinfo, UINT8 *buf, UINT8 port, UINT8 selector ) 
{
    UINT16 len;
    
    /* SETUP */
    Ctl_Setup->bReqType = USB_SET_PORT_FEATURE;
    Ctl_Setup->bRequest = USB_REQ_SET_FEATURE;
    Ctl_Setup->wValueL  = selector;
    Ctl_Setup->wValueH  = 0x00;
    Ctl_Setup->wIndexL  = port + 1;                                             /* С˿ںΪ1 */
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x00;
    Ctl_Setup->wLengthH = 0x00;
    
    /* ִпƴ */    
    len = Ctl_Setup->wLengthL;
    return( USBHOST_Issue_Control( &Hubinfo->Device, Ctl_Setup, buf, &len ) );  /* ִпƴ */
}

/*******************************************************************************
* Function Name  : HUB_CheckPortConnect
* Description    : HUBζ˿״̬
* Input          : *Hubinfo---ǰHUBؽṹ
*                  *buf---ݻ
*                  port---˿ں(ΧΪ0---3)
* Output         : None
* Return         : صǰִ״̬˿豸״̬
*                    0x00-----------------USB豸
*                  0x02-----------------USB豸
*                  USB_HUBDEVICE_CONNECT------⵽HUBµUSB豸¼
*                  USB_HUBDEVICE_DISCONNECT---⵽HUBµUSB豸Ͽ¼
*******************************************************************************/
UINT8 HUB_CheckPortConnect( HUB_INFO *Hubinfo, UINT8 *pbuf, UINT8 port ) 
{
    UINT8  status;

    /* ѯ˿״̬ */
    status = HUB_GetPortStatus( Hubinfo, pbuf, port );                                                                    
    if( status )
    {
        return( status );                                                       /* ʧֱӷ */
    }
    
    /* жϵǰ˿״̬ */
    if( pbuf[ 2 ] & 0x01 )                                                      /* ö˿״̬ı */
    {
        if( pbuf[ 0 ] & 0x01 )
        {
            return( USB_HUBDEVICE_CONNECT );                                    /* ö˿ڣ⵽豸 */    
        }
        else
        {
            return( USB_HUBDEVICE_DISCONNECT );                                 /* ö˿ڣ⵽豸Ͽ */    
        }                    
    }
    else                                                                        /* ö˿״̬δı */
    {
        if( pbuf[ 0 ] & 0x01 )
        {
            return( 0x02 );                                                     /* ö˿ڣ豸 */
        }
        else
        {
            return( 0x00 );                                                     /* ö˿ڣ豸 */
        }                            
    }    
}

/*******************************************************************************
* Function Name  : HUB_CheckPortSpeed
* Description    : HUBζ˿豸ٶ
* Input          : *Hubinfo---ǰHUBؽṹ
*                  *buf---ݻ
*                  port---˿ں(ΧΪ0---3)
* Output         : None
* Return         : صǰ˿豸ٶ
*                  0x00----ȫ豸
*                  0x01----豸
*                  0x02----豸
*******************************************************************************/
UINT8 HUB_CheckPortSpeed( HUB_INFO *Hubinfo, UINT8 *pbuf, UINT8 port ) 
{
    UINT8  status;

    /* ѯ˿״̬ */
    status = HUB_GetPortStatus( Hubinfo, pbuf, port );                                                                    
    if( status )
    {
        return( status );                                                       /* ʧֱӷ */
    }
    
    /* ٶɷصĵһ˫ֽڵĵ9λ͵10λ */
    if( pbuf[ 1 ] & 0x02 )
    {
        return( EHCI_DEVICE_SPEED_LS );                                         /* ǰΪ豸 */
    }    
    else
    {
        if( pbuf[ 1 ] & 0x04 )
        {
            return( EHCI_DEVICE_SPEED_HS );                                     /* ǰΪ豸 */
        }
        else
        {
            return( EHCI_DEVICE_SPEED_FS );                                     /* ǰΪȫ豸 */            
        }        
    }        
}     

/*********************************** endfile **********************************/
