/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.20
* Date               : 2013/11/15
* Description        : CH563 USB Host Examples
*                      (1)CH563 USB Examples by KEIL    
*                      (2)0Ϣ,115200bps
*                      (3)USB HOSTԲѯʽ
*                      (4):HUBԼHUBµU(4U),д 
*                      (5)ֻ֧1HUB,֧HUB´HUB
*                           HIBֻܹỤ豸в
*                      (6)ַ: ģ豸HUBַΪĬϲַ0x02;
*                           HUB豸ĵַΪ: HUBַ + ˿ںţ  
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "absacc.h"
#include "SYSFREQ.H"                                                            /* ϵͳͷļ */
#include "CH563SFR.H"
#include "EHCI_HCD.H"                                                           /* Ͳͷļ */
#include "CH563USBSFR.H"                                                        /* оƬUSBĴͷļ */
#include "Udisk.H"                                                              /* Udiskͷļ */
#include "HUB.H"                                                                /* HUBͷļ */
#include "PRINTF.H"                                                             /* ڴӡͷļ */

/******************************************************************************/
/*  */
UINT8 EHCI_Allocate_Buf[ EHCI_ALLOCATE_BUF_LEN ];                               /* ڴ仺(QHQTDȽṹҪ32ֽڶ, QHQTDڴʹ) */
__align( 4096 ) UINT8 EHCI_Data_Buf[ EHCI_DATA_BUF_LEN ];                       /* ڴݻ(Ҫ4K) */                                
__align( 4096 ) UINT8 EHCI_PERIODIC_LIST_Buf[ EHCI_PER_LISE_BUF_LEN ];          /* ֡б(Ҫ4K) */                                

/* HUBؽṹ */
HUB_INFO  RootHub;                                                              /* HUBؽṹϢ */
ROOT_HUB_DEVICE HubDevice;                                                        

/* Uؽṹ */
BULK_ONLY_CMD    mBOC;                                                           /* BulkOnlyṹ */
DISK_INFO        UDisk;                                                          /* Uؽṹ嶨 */                                                        
DISK_INFO        HUB_UDisk[ 4 ];                                                 /* HUBUؽṹ嶨 */

/******************************************************************************/
/*  */
extern UINT8 Disk_Test( DISK_INFO *Diskinfo );                                  /* U̲ */
extern UINT8 HUB_Test( HUB_INFO *Hubinfo );                                     /* HUB */    

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    while( 1 );
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void FIQ_Handler( void )
{
    while( 1 );
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int    main( void ) 
{
    UINT8  status;

//    SysFreq( );                                                               /* ҪPLLӦʱƵ */
    Delay_ms( 100 );
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */

#ifdef  MY_DEBUG_PRINTF    
    printf( "CH563_HUB_Example_2013.03.15.................................................\xd\xa" );
#endif

    USBHOST_ModeSet( );                                                         /* USBģʽ */
    USBHOST_EHCI_Init( );                                                       /* USBEHCIλʼ */
    USBHOST_Structure_DeInit( );                                                /* USBݽṹʼ */
    USBHOST_DevicePara_Init( &RootHub.Device );                                 /* USBزʼ */

    while( 1 )
    {                
        /***********************************************************************/
        /* ѯȴ豸 */
#ifdef  MY_DEBUG_PRINTF 
        printf("Wait USB Device In:\n" );
#endif
HOST_WAIT_DEVICE_IN:
        while( 1 )
        {
            if( USBHOST_EHCI_Detect_Connect( &RootHub.Device ) == USB_INT_CONNECT )  /* 豸 */
            {
                break;
            }
               Delay_ms( 50 );
        }
        Delay_ms( 200 );                                                        /* ʱ */
        if(USBHOST_EHCI_Detect_Connect( &RootHub.Device ) == USB_INT_DISCONNECT)/* 豸 */
        {
            goto HOST_WAIT_DEVICE_IN;                                           /* 豸Ͽתǰȴ */
        }

#ifdef  MY_DEBUG_PRINTF            
        printf("USB Device In:\n" ); 
        printf("Device Speed is: %02x\n",(UINT16)RootHub.Device.bSpeed );       /* 0x01:豸, 0x00:ȫ豸, 0x02:豸, 0xFF:δ֪ */            
#endif

        /**********************************************************************/
        /* USB豸ö */    
        status = USBHOST_EHCI_EP0_Init( &RootHub.Device );                      /* ʼ˵0 */
        if( status != USB_OPERATE_SUCCESS )
        {
#ifdef  MY_DEBUG_PRINTF            
            printf("USBHOST_EP0_Init Error\n");
#endif                
            return( status );
        }

        status = USBHOST_EHCI_Enumerate( &RootHub.Device, EHCI_Data_Buf );      /* USB豸ö */
        if( status == USB_OPERATE_SUCCESS )
        {
            if( gDeviceClassType == USB_DEV_CLASS_HUB )                         /* ǰ豸ΪHUB豸 */
            {
#ifdef  MY_DEBUG_PRINTF    
                printf("Current USB Device is HUB Device\n");                
#endif
                status = HUB_Test( &RootHub );                                  /* HUB */
            }                            
        }

        /***********************************************************************/
        /* Խ,ѯȴ豸γ */
        while( 1 )
        {
            if( USBHOST_EHCI_Detect_Connect( &RootHub.Device ) == USB_INT_DISCONNECT )
            {
                printf("USB Device Out\n");
                USBHOST_EHCI_Init( );
                USBHOST_DevicePara_Init( &RootHub.Device );                     /* USBزʼ */
                USBHOST_DevicePara_Init( &UDisk.Device );                       /* USBزʼ */
                USBHOST_Structure_DeInit( );                                    /* USBݽṹʼ */
#ifdef  MY_DEBUG_PRINTF    
                printf("USB Device Out\n");
#endif
                break;
            }
        }    
    }
}

/*******************************************************************************
* Function Name  : Disk_Test
* Description    : U̲
* Input          : *Diskinfo----ǰUؽṹ
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 Disk_Test( DISK_INFO *Diskinfo )
{
    UINT8  status;
    UINT32 sector;
    
#ifdef  MY_DEBUG_PRINTF            
    printf("Disk_Test......\n");        
#endif
    
    /* Uз */
    MS_CofDescrAnalyse( Diskinfo, EHCI_Data_Buf );                              /* U̵з,ȡϢ */

    /* U̽гʼ */
    status = MS_Init_EX( Diskinfo, EHCI_Data_Buf );                             /* 洢豸ʼ */
    if( status == USB_OPERATE_SUCCESS )
    {        
        sector = 0x00;
        while( 1 )  
        {
            /* һζȡ20K */
            status = MS_ReadSector_EX( Diskinfo, sector, EHCI_DATA_BUF_LEN / Diskinfo->PerSecSize, EHCI_Data_Buf );/* ȡN */                        
            if( status )
            {
                return( status );
            }
            
            /* жǷȫ,ͷٶ */
            if( sector <= ( Diskinfo->Capability - 40 ) )
            {

                sector = sector + EHCI_DATA_BUF_LEN / Diskinfo->PerSecSize;                        
            }
            else
            {
                sector = 0x00;    
            }
        }
    }
    return( status );
}    
/*******************************************************************************
* Function Name  : HUB_Port_PreEnumerate
* Description    : HUB˿öǰ
* Input          : num----HUB˿ں
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 HUB_Port_PreEnumerate( UINT8 num )
{
    UINT8  status;

#ifdef  MY_DEBUG_PRINTF            
        printf("HUB_Port_PreEnumerate\n");
#endif    
    Delay_ms( 10 );
    status = HUB_GetPortStatus( &RootHub, EHCI_Data_Buf, num );
    if( status != USB_OPERATE_SUCCESS )
    {    
        return( status );                                
    }
                            
    Delay_ms( 100 );                                                            /* ȴ豸ϵȶ */    
    status = HUB_SetPortFeature( &RootHub, EHCI_Data_Buf, num, USB_PORT_RESET );/* 豸ӵĶ˿ڸλ */
    if( status != USB_OPERATE_SUCCESS )
    {    
        return( status );                                                            
    }

#ifdef  MY_DEBUG_PRINTF            
    printf("Reset Port And Then Wait In\n" );
#endif    
    /* ѯǰλ˿,ֱλ,ɺ״̬ʾ */
    do 
    {  
        Delay_ms( 10 );
        status = HUB_GetPortStatus( &RootHub, EHCI_Data_Buf, num );
        if( status != USB_OPERATE_SUCCESS )
        {    
            return( status );                                
        }                                        
    }while( EHCI_Data_Buf[ 0 ] & 0x10 );  
    Delay_ms( 200 );

    /* ӻƳ仯־ */    
    status = HUB_ClearPortFeature( &RootHub, EHCI_Data_Buf, num, USB_C_PORT_CONNECTION );
    if( status != USB_OPERATE_SUCCESS )
    {        
        return( status );                        
    }

    /* ٴж豸Ƿ */
    status = HUB_GetPortStatus( &RootHub, EHCI_Data_Buf, num );
    if( status != USB_OPERATE_SUCCESS )
    {                                
        return( status );
    }    
    if( ( EHCI_Data_Buf[ 0 ] & 0x01 ) == 0x00 )
    {
        return( USB_INT_DISCONNECT );            
    }    
    return( USB_OPERATE_SUCCESS );    
}
    
/*******************************************************************************
* Function Name  : HUB_Test
* Description    : HUB
* Input          : *Diskinfo----ǰUؽṹ
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 HUB_Test( HUB_INFO *Hubinfo )
{
    UINT8  status;
    UINT16 len;
    UINT32 i, temp;
    UINT8  portnum;

#ifdef  MY_DEBUG_PRINTF            
    printf("HUB_Test......\n");        
#endif

    /* HUBз */
    HUB_CofDescrAnalyse( Hubinfo, EHCI_Data_Buf );                              /* HUBз,ȡϢ */
    status = HUB_GetClassDevDescr( Hubinfo, EHCI_Data_Buf, &len );              /* ȡHUB */
    if( status == USB_OPERATE_SUCCESS )
    {
        HubDevice.bHubPortNum = ( (PUSB_HUB_DESCR)EHCI_Data_Buf) -> bNumberOfPorts; /* HUBĶ˿ */
        if( HubDevice.bHubPortNum > 4 )
        {
            HubDevice.bHubPortNum = 4;
        }    
    }
    
    /* HUB˿ڶϵ */            
    for( i = 0; i < HubDevice.bHubPortNum; i++ )                                 
    {                      
        status = HUB_SetPortFeature( Hubinfo, EHCI_Data_Buf, i, USB_PORT_POWER );
    }

    while( 1 )
    {
        Delay_ms( 50 );
        
        /* ѯHUBζ˿״ */
        for( portnum = 0; portnum < HubDevice.bHubPortNum; portnum++ ) 
        {  
            status = HUB_CheckPortConnect( &RootHub, EHCI_Data_Buf, portnum );  /* ѯ˿״̬ */    
            if( status == USB_HUBDEVICE_CONNECT )                               /* ⵽豸 */                                        
            {    
                HUB_Port_PreEnumerate( portnum );                               /* ˿öǰ׼ */

                /* ޸Ĳ浱ǰ豸Ϣ */
                HUB_UDisk[ portnum ].Device.bDeviceOnHub = 0x01;                /* ǰUSB豸HUB */                            
                HUB_UDisk[ portnum ].Device.bOnHubPortNumber = portnum + 1;     /* ǰUSB豸HUBϵĶ˿ں */
                HUB_UDisk[ portnum ].Device.bSpeed = HUB_CheckPortSpeed( &RootHub, EHCI_Data_Buf, portnum );/* ǰUSB豸ٶȣ0x01---٣0x00---ȫ٣0x02--- */    
                HUB_UDisk[ portnum ].Device.bAddress = portnum + 1;             /* ǰUSB豸ַĬΪ0 */
                HUB_UDisk[ portnum ].Device.bHubAddress = RootHub.Device.bHubAddress;    /* ǰUSBصHUBַĬΪ0 */                            
                HUB_UDisk[ portnum ].Device.bConnectStatus = 0x01;              /* ǰUSB豸 */
                HUB_UDisk[ portnum ].Device.bPortEnableDisableStatus = 0x01;    /* ǰ˿ʹ */    

                /* 䵱ǰ˿豸ƴҪQH */
                temp = USBHOST_GetStructure( EHCI_MEM_TYPE_QHD );
                if( temp == USB_MEM_ALLOCATE_ERROR )
                {
                    return( USB_MEM_ALLOCATE_ERROR );
                }    
                HUB_UDisk[ portnum ].Device.qHD_Control = (qHD_Structure*)temp; /* qHD_Structureռ */
                USBHOST_Allocate_QHD( &HUB_UDisk[ portnum ].Device,                                 
                                       HUB_UDisk[ portnum ].Device.qHD_Control, 
                                       EHCI_HD_TYPE_QH, 
                                       EHCI_EP_TYPE_CONTROL, 
                                       0, 
                                       0, 
                                      DEFAULT_USB_EP0_SIZE );
                USBHOST_qHD_Link_Insert(HUB_UDisk[portnum].Device.qHD_Control); /* ǰQHDӵQHD */

                /* ޸Ĳ浱ǰ豸Ϣ */
                HUB_UDisk[ portnum ].Device.qHD_Control->bDeviceAddress = 0x00;
                HUB_UDisk[ portnum ].Device.qHD_Control->bHubAddr = RootHub.Device.bHubAddress;             
                HUB_UDisk[ portnum ].Device.qHD_Control->bPortNumber = portnum + 1;                                           
                HUB_UDisk[ portnum ].Device.qHD_Control->bHighBandwidth = 1;

#if 1    
                printf("wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n");
                printf("portnum: %x\n",portnum);
                printf("HUB_UDisk[ portnum ].bHubAddress: %x\n",HUB_UDisk[ portnum ].Device.bHubAddress);
                printf("HUB_UDisk[ portnum ].bDeviceOnHub:%x\n",(UINT16)HUB_UDisk[ portnum ].Device.bDeviceOnHub);
                printf("HUB_UDisk[ portnum ].bOnHubPortNumber:%x\n",(UINT16)HUB_UDisk[ portnum ].Device.bOnHubPortNumber);
                printf("HUB_UDisk[ portnum ].bSpeed:%x\n",(UINT16)HUB_UDisk[ portnum ].Device.bSpeed);
                printf("HUB_UDisk[ portnum ].bAddress:%x\n",(UINT16)HUB_UDisk[ portnum ].Device.bAddress);
                printf("HUB_UDisk[ portnum ].bHubAddress:%x\n",(UINT16)HUB_UDisk[ portnum ].Device.bHubAddress);
                printf("HUB_UDisk[ portnum ].qHD_Control->bDeviceAddress:%x\n",(UINT16)HUB_UDisk[ portnum ].Device.qHD_Control->bDeviceAddress);
                printf("HUB_UDisk[ portnum ].qHD_Control->bHubAddr:%x\n",(UINT16)HUB_UDisk[ portnum ].Device.qHD_Control->bHubAddr);
                printf("HUB_UDisk[ portnum ].qHD_Control->bPortNumber:%x\n",(UINT16)HUB_UDisk[ portnum ].Device.qHD_Control->bPortNumber);
                printf("HUB_UDisk[ portnum ].qHD_Control->bHighBandwidth:%x\n",(UINT16)HUB_UDisk[ portnum ].Device.qHD_Control->bHighBandwidth);
#endif

                /* USB豸ö */    
                status = USBHOST_EHCI_Enumerate( &HUB_UDisk[ portnum ].Device, 
                         EHCI_Data_Buf );                                       /* USB豸ö */
                if( status == USB_OPERATE_SUCCESS )
                {
                    if( gDeviceClassType == USB_DEV_CLASS_STORAGE )             /* ǰ豸Ϊ洢豸 */
                    {
#ifdef  MY_DEBUG_PRINTF            
                        printf("Current USB Device is Mass Storage Device\n");
#endif            
                        /* Uз */
                        MS_CofDescrAnalyse( &HUB_UDisk[ portnum ], EHCI_Data_Buf );/* U̵з,ȡϢ */

                        /* U̽гʼ */
                        status = MS_Init_EX(&HUB_UDisk[ portnum ],EHCI_Data_Buf);  /* 洢豸ʼ */
                        if( status == USB_OPERATE_SUCCESS )
                        {
                        }    
                    }
                    else
                    {
#ifdef  MY_DEBUG_PRINTF            
                        printf("Current USB Device is Not Mass Storage Device\n");
#endif                                    
                        break;
                    }    
                }
            }
            else if( status == 0x02 )                                           /* ǰ˿: 豸 */
            {                
                /* һζȡ20K */
                status = MS_ReadSector_EX( &HUB_UDisk[ portnum ], 0x00, EHCI_DATA_BUF_LEN / HUB_UDisk[ portnum ].PerSecSize, EHCI_Data_Buf );/* ȡN */                        
                if( status )
                {
                    return( status );
                }                            
            }    
            else if( status == USB_HUBDEVICE_DISCONNECT )                       /* ǰ˿: ⵽豸Ͽ */
            {
                printf("Device Out\n");    

                /* Ƴ仯־ */
                status = HUB_ClearPortFeature( &RootHub, EHCI_Data_Buf, portnum, USB_C_PORT_CONNECTION );
                if( status != USB_OPERATE_SUCCESS )
                {                                                                    
                }

                /* ոU̲ʱĸԴ */
                USBHOST_Release_QHD( HUB_UDisk[ portnum ].Device.qHD_Control ); /* յǰ豸ƴQH */    
                USBHOST_Release_QHD( HUB_UDisk[ portnum ].qHD_Bulk_Out );       /* յǰ豸QH */    
                USBHOST_Release_QHD( HUB_UDisk[ portnum ].qHD_Bulk_In );        /* յǰ豸QH */
            }            
        }    
                
        /* ѯHUB״ */
        if( USBHOST_EHCI_Detect_Connect( &Hubinfo->Device ) == USB_INT_DISCONNECT )
        {
            USBHOST_DevicePara_Init( &Hubinfo->Device );                        /* USBزʼ */
#ifdef  MY_DEBUG_PRINTF    
            printf("HUB Device Out\n");
#endif
            break;
        }                        
    }
    return( status );
}                

/*********************************** endfile **********************************/
