/********************************** (C) COPYRIGHT *******************************
* File Name          : EHCI_HCD.C
* Author             : WCH
* Version            : V1.20
* Date               : 2013/11/15
* Description        : CH563 USB Host Controller EHCI test pattern file
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "CH563BAS.H"                                                           /* CH563ͷļ */
#include "CH563SFR.H"                                                           /* CH563Ĵͷļ */    
#include "CH563USBSFR.H"                                                        /* оƬUSBĴͷļ */    
#include "CH563USB.H"                                                           /* USBöͷļ */    
#include "EHCI_HCD.H"                                                           /* Ͳͷļ */
#include "PRINTF.H"                                                             /* ڴӡͷļ */                                

/******************************************************************************/
/*  */
/* USBƴSETUPṹָ붨 */
UINT8  gDeviceClassType;                                                        /* ǰ豸 */
UINT8V gEHCILastStatus;                                                         /* EHCIһβ״̬ */

/* EHCIĴؽṹָ붨 */
EHCI_CAPABILITY *EHCI_Caps;
EHCI_REGISTERS    *EHCI_Regs;
USB_SETUP_REQ   *Ctl_Setup;                                                     /* ƴݰ */

/*  */
UINT32 gEHCIFreeRamAddr;                                                        /* EHCIڴʼַ */
UINT32 gEHCI_RAM_BaseAddr;                                                      /* EHCIݽṹַ */
UINT32 gEHCI_QHD_BaseAddr;                                                      /* EHCIݽṹQHDַ */
UINT32 gEHCI_QTD_BaseAddr;                                                      /* EHCIݽṹQTDַ */
UINT32 gEHCI_ITD_BaseAddr;                                                      /* EHCIݽṹITDַ */
UINT32 gEHCI_Preiodic_Frame_List_BaseAddr;                                      /* EHCIбݽṹַ */
UINT32 gEHCI_DataPage_BaseAddr;                                                 /* EHCIݻַ */
UINT8  EHCI_qHD_Manage[ EHCI_QHD_MAX ];                                         /* 1=>Free; 2=>used */
UINT8  EHCI_qTD_Manage[ EHCI_QTD_MAX ];                                         /* 1=>Free; 2=>used */
UINT8  EHCI_iTD_Manage[ EHCI_ITD_MAX ];                                         /* 1=>Free; 2=>used */  
UINT8  EHCI_DataPage_Manage[ EHCI_DATAPAGE_MAX ];                               /* 1=>Free; 2=>used */ 

/*******************************************************************************
* Function Name  : USBHOST_ModeSet
* Description    : USBģʽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBHOST_ModeSet( void )
{ 
    /* оƬΪģʽ */
    R8_MISC_CTRL_USB =  R8_MISC_CTRL_USB & ( ~RB_MISC_USB_ID_EN );              /* USB OTG ID pin enable */                                    
    R8_MISC_CTRL_USB = R8_MISC_CTRL_USB & ( ~RB_MISC_USB_ID_ST );               /* óUSB */    
    OTG_CONTROL_STATUS = 0x000E0190;                                            /* USBΪģʽ */    
}

/*******************************************************************************
* Function Name  : USBHOST_HC_StopRun_Setting
* Description    : USBֹͣ
* Input          : option---USBHOST_OP_DISABLE: ֹͣUSB
*                           USBHOST_OP_ENABLE:  USB
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_HC_StopRun_Setting( UINT8 option )
{
    UINT16 timeout;

    if( option == USBHOST_OP_ENABLE ) 
    {
        /* жǷ,ֱӷ */
        if( ( EHCI_Regs->hc_usbcmd & RB_RS ) && ( EHCI_Regs->hc_usbsts & RB_HCHALTED ) == 0 ) 
        {
            return( USB_OPERATE_SUCCESS );                                                                
        }

        /* USB,ȴɹ */        
        EHCI_Regs->hc_usbcmd |= RB_RS;
        Delay_ms( 1 );
        for( timeout = 1000; timeout != 0; timeout -- ) 
        {
            Delay_us( 10 );        
            if( ( EHCI_Regs->hc_usbcmd & RB_RS ) && ( EHCI_Regs->hc_usbsts & RB_HCHALTED ) == 0 ) 
            {
                break;
            }
        }
        if ( timeout == 0 ) 
        {
            return( USB_OPERATE_ERROR );                                        /* ʱ˳ */
        }
        return( USB_OPERATE_SUCCESS );        
    }
    else if( option == USBHOST_OP_DISABLE )
    {    
        /* жǷֹͣ,ֱֹͣӷ */
        if( ( EHCI_Regs->hc_usbcmd & RB_RS ) == 0 && ( EHCI_Regs->hc_usbsts & RB_HCHALTED ) ) 
        {    
            return( USB_OPERATE_SUCCESS );                                                                
        }
        
        /* ֹͣAsynchronousPeriodic */
         USBHOST_Asynchronous_Setting( USBHOST_OP_DISABLE );
         USBHOST_Periodic_Setting( USBHOST_OP_DISABLE );
    
        /* ֹͣUSB,ȴֹͣɹ */        
        EHCI_Regs->hc_usbcmd &= ~RB_RS;
        Delay_ms( 1 );
        for( timeout = 1000; timeout != 0; timeout -- ) 
        {
            Delay_us( 10 );        
            if( ( EHCI_Regs->hc_usbcmd & RB_RS ) == 0 && ( EHCI_Regs->hc_usbsts & RB_HCHALTED ) ) 
            {    
                break;
            }
        }
        if( timeout == 0 ) 
        {    
            return( USB_OPERATE_ERROR );                                        /* ʱ˳ */
        }
         return( USB_OPERATE_SUCCESS );        
    }
    return( USB_PARAMETER_ERROR );
}    
    
/*******************************************************************************
* Function Name  : USBHOST_Asynchronous_Setting
* Description    : USBáֹͣAsynchronous
* Input          : option---USBHOST_OP_DISABLE: USBֹͣAsynchronous
*                           USBHOST_OP_ENABLE:  USBAsynchronous
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_Asynchronous_Setting( UINT8 option )
{            
    UINT16 timeout;

    if( option == USBHOST_OP_ENABLE ) 
    {    
        /* жǷ,ֱӷ */
        if( EHCI_Regs->hc_usbsts & RB_ASCH_STS ) 
        {
            return( USB_OPERATE_SUCCESS );    
        }
                                
        /* Asynchronous,ȴɹ */    
        EHCI_Regs->hc_usbcmd |= RB_ASCH_EN;
        Delay_ms( 1 );    
        for( timeout = 1000; timeout != 0; timeout -- ) 
        {
            Delay_us( 10 );        
            if( EHCI_Regs->hc_usbsts & RB_ASCH_STS ) 
            {
                break;
            }
        }
        if( timeout == 0 ) 
        {
            return( USB_OPERATE_ERROR );                                        /* ʱ˳ */
        }
        return( USB_OPERATE_SUCCESS );
    }
    else if( option == USBHOST_OP_DISABLE ) 
    {
        /* жǷֹͣ,ֱֹͣӷ */
        if( ( EHCI_Regs->hc_usbcmd & RB_ASCH_EN ) == 0x00 && ( EHCI_Regs->hc_usbsts & RB_ASCH_STS ) == 0x00 ) 
        {
            return( USB_OPERATE_SUCCESS );    
        }
        
        /* ֹͣAsynchronous,ȴֹͣ */                
        EHCI_Regs->hc_usbcmd &= ~RB_ASCH_EN;
        Delay_ms( 1 );    
        for( timeout = 1000; timeout != 0; timeout -- ) 
        {
            Delay_us( 10 );        
            if( ( EHCI_Regs->hc_usbsts & RB_ASCH_STS ) == 0 ) 
            {
                break;
            }    
        }
        if( timeout == 0 ) 
        {
            return( USB_OPERATE_ERROR );                                        /* ʱ˳ */
         }
         return( USB_OPERATE_SUCCESS );
    }                
    return( USB_PARAMETER_ERROR );
}

/*******************************************************************************
* Function Name  : USBHOST_Periodic_Setting
* Description    : USBáֹͣPeriodic
* Input          : option---USBHOST_OP_DISABLE: USBֹͣPeriodic
*                           USBHOST_OP_ENABLE:  USBPeriodic
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_Periodic_Setting( UINT8 option )
{
    UINT16 timeout;

    if( option == USBHOST_OP_ENABLE ) 
    {    
        /* жǷ,ֱӷ */
        if( EHCI_Regs->hc_usbsts & RB_PSCH_STS ) 
        {
            return( USB_OPERATE_SUCCESS );    
        }
                
        /* Periodic,ȴɹ */    
        EHCI_Regs->hc_usbcmd |= RB_PSCH_EN;    
        Delay_ms( 1 );                                    
        for( timeout = 1000; timeout != 0; timeout -- ) 
        {
            Delay_us( 10 );        
            if( EHCI_Regs->hc_usbsts & RB_PSCH_STS ) 
            {
                break;
            }
        }
        if( timeout == 0 ) 
        {
            return( USB_OPERATE_ERROR );                                        /* ʱ˳ */
        }
         return( USB_OPERATE_SUCCESS );
    }
    else if( option == USBHOST_OP_DISABLE ) 
    {
        /* жǷֹͣ,ֱֹͣӷ */
        if( ( EHCI_Regs->hc_usbcmd & RB_PSCH_EN ) == 0x00 && ( EHCI_Regs->hc_usbsts & RB_PSCH_STS ) == 0x00 ) 
        {
            return( USB_OPERATE_SUCCESS );    
        }
                
        /* ֹͣPeriodic,ȴֹͣ */                
        EHCI_Regs->hc_usbcmd &= ~RB_PSCH_EN;
        Delay_ms( 1 );    
        for( timeout = 1000; timeout != 0; timeout -- ) 
        {
            Delay_us( 10 );        
            if( ( EHCI_Regs->hc_usbsts & RB_PSCH_STS ) == 0 ) 
            {
                break;
            }
        }
        if( timeout == 0 ) 
        {
            return( USB_OPERATE_ERROR );                                        /* ʱ˳ */
        }
         return( USB_OPERATE_SUCCESS );
    }                
    return( USB_PARAMETER_ERROR );
}

/*******************************************************************************
* Function Name  : USBHOST_EHCI_Init
* Description    : USBEHCIʼ
* Input          : None
* Output         : None
* Return         : USB_OPERATE_SUCCESS---EHCIʼɹ
*                  USB_HC_ERROR----------EHCIʼʧ
*******************************************************************************/
UINT8 USBHOST_EHCI_Init( void )
{
    UINT8  status;
    UINT16 count;
    
#ifdef  MY_DEBUG_PRINTF 
    printf( "USBHOST_EHCI_Init:...\n " );
#endif
    /* Set EHCI Memory Register */
    EHCI_Caps = ( EHCI_CAPABILITY *)( USB_BASE_ADDR + 0x000 );
    EHCI_Regs = ( EHCI_REGISTERS *)( USB_BASE_ADDR + 0x010 );      

    USBHOST_HC_StopRun_Setting( USBHOST_OP_DISABLE );                           /* رUSB */
    Delay_ms( 3 );

    /* Reset EHCI Host Control */
    EHCI_Regs->hc_usbcmd |= RB_HC_RESET;                                        /* ʼHCλ */
    for( count = 1000; count != 0; count -- ) 
    {
        Delay_us( 10 );
        if( ( EHCI_Regs->hc_usbcmd & RB_HC_RESET ) == 0 ) 
        {
            break;                                                              /* ȴHCλ,ӲԶ0 */
        }
    }
    if( count == 0 ) 
    {
        return( USB_HC_ERROR );                                                 /* ʱδλ,򱨸 */    
    }    
    Delay_ms( 3 );    

    /* 鲿ּĴĬֵǷȷ */
    if( RB_HC_LENGTH( EHCI_Caps->hc_caplength ) != 0x0010 )
    {
        return( USB_HC_ERROR );
    }    
    if( RB_HC_VERSION( EHCI_Caps->hc_caplength ) != 0x0100 )
    {
        return( USB_HC_ERROR );
    }    
    if( EHCI_Caps->hc_hcsparams != 0x0001 )
    {
        return( USB_HC_ERROR );
    }    
    if( EHCI_Caps->hc_hccparams != 0x0006 )
    {
        return( USB_HC_ERROR );
    }    

    /* ʼEHCIּĴ */
//    EHCI_Regs->hc_frindex = 0x00000000;                                       /* USBĴ */
    EHCI_Regs->hc_periodiclistbase = 0x00000000;                                /* ֡бַ0 */
    EHCI_Regs->hc_asynchronous = 0x00000000;                                    /* 첽бַ0 */                                     
    EHCI_Regs->hc_portsc = EHCI_PORT_INIT;                                      /* ˿״̬ƼĴ */    
    EHCI_Regs->hc_usbint_en = RB_INT_OAA_EN | RB_H_SYSERR_EN | RB_PO_CHG_INT_EN |
                              RB_USBERR_INT_EN | RB_USB_INT_EN;                 /* USBжüĴ */
    EHCI_Regs->hc_usbcmd = 0x00080100 | 0x08;                                   /* USBĴ */        
    EHCI_Regs->hc_usbsts = EHCI_Regs->hc_usbsts;                                /* USB״̬Ĵ */ 
    status = USBHOST_Structure_DeInit( );                                       /* ʼUSB HOSTΪнṹڴ */
    if( status )
    {
        return( status );
    }    
    EHCI_Regs->hc_asynchronous = gEHCI_QHD_BaseAddr;                            /* 첽бַ */ 
    EHCI_Regs->hc_periodiclistbase = gEHCI_Preiodic_Frame_List_BaseAddr;        /* ֡бַ */
    Delay_ms( 1 );                                                              /* ʱ */
    return( USB_OPERATE_SUCCESS );
}

/*******************************************************************************
* Function Name  : USBHOST_Structure_DeInit
* Description    : USBݽṹڴ估ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_Structure_DeInit( void )
{
    UINT8  i;
    UINT8  *pData;
    UINT32 address;
    char   *host_memory_ptr;

    /* ȷȫر */
    USBHOST_Periodic_Setting( USBHOST_OP_DISABLE );
    USBHOST_Asynchronous_Setting( USBHOST_OP_DISABLE );
    Delay_ms( 3 );

    /* 1EHCIڴ */
    gEHCIFreeRamAddr = (UINT32)EHCI_Allocate_Buf;                                
    host_memory_ptr = (char *)( ( gEHCIFreeRamAddr + 0x1F ) & ~0x1F );
    gEHCI_RAM_BaseAddr = (UINT32)host_memory_ptr;                               /* EHCIݽṹַ */
    gEHCIFreeRamAddr = (UINT32)host_memory_ptr;                                 /* EHCIڴʼַ */
                    
    /* 1.1QHDڴռ */
    address = (UINT32)host_memory_ptr;
    if( ( address + ( EHCI_QHD_SIZE * EHCI_QHD_MAX ) ) > ( (UINT32)EHCI_Allocate_Buf + EHCI_ALLOCATE_BUF_LEN ) )
    {
        return( USB_MEM_ALLOCATE_ERROR );                                       /* ڴʧ */    
    }                                            
    gEHCI_QHD_BaseAddr = address;                                               /* EHCIݽṹQHDַ */        
    gEHCIFreeRamAddr = address + ( EHCI_QHD_SIZE * EHCI_QHD_MAX );              /* ¿ʼַ */    

    /* 1.2QTDڴռ */
    address = gEHCIFreeRamAddr + ( EHCI_QTD_SIZE * EHCI_QTD_MAX );
    if( address > ( (UINT32)EHCI_Allocate_Buf + EHCI_ALLOCATE_BUF_LEN ) )
    {
        return( USB_MEM_ALLOCATE_ERROR );                                       /* ڴʧ */    
    }                                            
    gEHCI_QTD_BaseAddr = gEHCIFreeRamAddr;                                      /* EHCIݽṹQTDַ */
    gEHCIFreeRamAddr = address;                                                 /* ¿ʼַ */    

    /* 1.3ITDڴռ */
    address = gEHCIFreeRamAddr + ( EHCI_ITD_SIZE * EHCI_ITD_MAX );
    if( address > ( (UINT32)EHCI_Allocate_Buf + EHCI_ALLOCATE_BUF_LEN ) )
    {
        return( USB_MEM_ALLOCATE_ERROR );                                       /* ڴʧ */    
    }                                            
    gEHCI_ITD_BaseAddr = gEHCIFreeRamAddr;                                      /* EHCIݽṹITDַ */
    gEHCIFreeRamAddr = address;                                                 /* ¿ʼַ */    

    /* 1.4֡бڴռ */                                        
    gEHCI_Preiodic_Frame_List_BaseAddr = (UINT32)EHCI_PERIODIC_LIST_Buf;        /* EHCIбݽṹַ */

    /* 2ʼѷEHCIڴ */
    pData = EHCI_Allocate_Buf;
    while( (UINT32)pData < gEHCIFreeRamAddr )
    {
        *pData = 0;
        pData++;
    }
    
    /* 3QHDQTDITDDataPageڴԪ */    
    for( i = 0; i < EHCI_QHD_MAX; i++ )
    {
        EHCI_qHD_Manage[ i ] = EHCI_MEM_FREE;
    }
    for( i = 0; i < EHCI_QTD_MAX; i++ )
    {
        EHCI_qTD_Manage[ i ] = EHCI_MEM_FREE;
    }    
    for( i = 0; i < EHCI_ITD_MAX; i++ )
    {
        EHCI_iTD_Manage[ i ] = EHCI_MEM_FREE;
    }    
    for( i = 0; i < EHCI_DATAPAGE_MAX; i++ )
    {
        EHCI_DataPage_Manage[ i ] = EHCI_MEM_FREE;
    } 
    
    /* 4ָEHCIݻַ */
    gEHCI_DataPage_BaseAddr = (UINT32)EHCI_Data_Buf;                            /* EHCIݻַ */

    /* 5Setupڴ */
    Ctl_Setup = (USB_SETUP_REQ *)gEHCIFreeRamAddr;
    gEHCIFreeRamAddr = gEHCIFreeRamAddr + 8;                        
    return( USB_OPERATE_SUCCESS );           
}

/*******************************************************************************
* Function Name  : USBHOST_GetStructure
* Description    : ݽṹڴ
* Input          : Type---Ҫݽṹ
* Output         : None
* Return         : USB_MEM_ALLOCATE_ERRORʾʧ; 
*                  طUSB_MEM_ALLOCATE_ERRORʾɹʵڴַ
*******************************************************************************/
UINT32 USBHOST_GetStructure( UINT8 Type )
{
    UINT32 i;
    qHD_Structure *spTempqHD;    
    qTD_Structure *spTempqTD;
    iTD_Structure *spTempiTD;

    switch( Type ) 
    {
        case EHCI_MEM_TYPE_QHD:                                                 /* ݽṹ: QHD */
            for( i = 0; i < EHCI_QHD_MAX; i++ )
            {
                /* Ѱδڴ */
                if( EHCI_qHD_Manage[ i ] == EHCI_MEM_FREE ) 
                {
                    EHCI_qHD_Manage[ i ] = EHCI_MEM_USED;                       /* ѷ־ */
                    
                    /* qHDݽṹֽгʼ */                    
                    spTempqHD = ( qHD_Structure * )( gEHCI_QHD_BaseAddr + ( i * EHCI_QHD_SIZE ) );
                    return( (UINT32)spTempqHD );
                }
            }                 
            break;        
        
        case EHCI_MEM_TYPE_QTD:                                                 /* ݽṹ: QTD */
            for( i = 0; i < EHCI_QTD_MAX; i++ )
            {
                /* Ѱδڴ */
                if( EHCI_qTD_Manage[ i ] == EHCI_MEM_FREE ) 
                {
                    EHCI_qTD_Manage[ i ] = EHCI_MEM_USED;                       /* ѷ־ */

                    /* qTDݽṹֽгʼ */                    
                    spTempqTD = ( qTD_Structure * )( gEHCI_QTD_BaseAddr + ( i * EHCI_QTD_SIZE ) );                
                    spTempqTD->bTerminate = 0x01;       
                    spTempqTD->bStatus_Active = 0x00;            
                    spTempqTD->bInterruptOnComplete = 0x01;   
                    spTempqTD->bAlternateTerminate = 0x01;    
                    spTempqTD->bErrorCounter = 0x03;                        
                    return( (UINT32)spTempqTD );
                }
            }                 
            break;

        case EHCI_MEM_TYPE_ITD:                                                 /* ݽṹ: ITD */ 
            for( i = 0; i < EHCI_ITD_MAX; i++ )
            {
                /* Ѱδڴ */
                if( EHCI_iTD_Manage[ i ] == EHCI_MEM_FREE )                 
                {
                    EHCI_iTD_Manage[ i ] = EHCI_MEM_USED;                       /* ѷ־ */

                    /* iTDݽṹֽгʼ */                                        
                    spTempiTD = ( iTD_Structure * )( gEHCI_ITD_BaseAddr + ( i * EHCI_ITD_SIZE ) );
                    spTempiTD->bTerminate = 0x01; 
                    return( (UINT32)spTempiTD );
                }
            }
            break;

        case EHCI_MEM_TYPE_SITD:                                                /* ݽṹ: SITD */ 
            /* ֧SITD */
            break;

        case EHCI_MEM_TYPE_4K_BUFFER:                                           /* ݻ */     
            for( i = 0; i < EHCI_DATAPAGE_MAX; i++ )                        
            {
                /* Ѱδڴ */
                if( EHCI_DataPage_Manage[ i ] == EHCI_MEM_FREE ) 
                {
                    EHCI_DataPage_Manage[ i ] = EHCI_MEM_USED;
                    return( (UINT32)( gEHCI_DataPage_BaseAddr + i * EHCI_DATAPAGE_SIZE ) );    
                }               
            }
            break;
           
        default:
            break;      
    }
    return( USB_MEM_ALLOCATE_ERROR );                                           /* ڴ */
}

/*******************************************************************************
* Function Name  : USBHOST_ReleaseStructure
* Description    : ݽṹڴ
* Input          : Type--------Ҫյݽṹ
*                  pwAddress---Ҫյݽṹַ
* Output         : None
* Return         : USB_OPERATE_ERRORʾʧ; 
*                  USB_OPERATE_SUCCESSʾճɹ
*******************************************************************************/
UINT8 USBHOST_ReleaseStructure( UINT8 Type, UINT32 pwAddress )
{
    UINT32 i;
    UINT32 wReleaseNum;
    UINT32 *pData;

    pData = ( UINT32 *)pwAddress; 
    switch( Type ) 
    {
        case EHCI_MEM_TYPE_QHD:  
            if( ( pwAddress < gEHCI_QHD_BaseAddr ) || ( ( pwAddress > gEHCI_QTD_BaseAddr ) ) ) 
            {
                return( USB_OPERATE_ERROR );
            }
            wReleaseNum = ( pwAddress - gEHCI_QHD_BaseAddr ) / EHCI_QHD_SIZE;                
            if( wReleaseNum > EHCI_QHD_MAX ) 
            {
                return( USB_OPERATE_ERROR );
            }

            /* ݽṹڴ */                
            EHCI_qHD_Manage[ wReleaseNum ] = EHCI_MEM_FREE;                     /* ѷ־ */
            for( i = 0; i < EHCI_QHD_SIZE / 4; i++ )
            {
                *( pData + i ) = 0x00;
            }
            break;        
        
        case EHCI_MEM_TYPE_QTD:  
            if( ( pwAddress < gEHCI_QTD_BaseAddr ) || ( ( pwAddress > gEHCI_ITD_BaseAddr ) ) ) 
            {
                return( USB_OPERATE_ERROR );
            }
            wReleaseNum = ( pwAddress - gEHCI_QTD_BaseAddr ) / EHCI_QTD_SIZE;                
            if( wReleaseNum > EHCI_QTD_MAX ) 
            {
                return( USB_OPERATE_ERROR );
            }

            /* ݽṹڴ */                
            EHCI_qTD_Manage[ wReleaseNum ] = EHCI_MEM_FREE;                     /* ѷ־ */
            for( i = 0; i < EHCI_QTD_SIZE / 4; i++ )
            {
                *( pData + i ) = 0x00;
            }
            break;

        case EHCI_MEM_TYPE_ITD:
            if( ( pwAddress < gEHCI_ITD_BaseAddr ) || ( pwAddress > gEHCI_Preiodic_Frame_List_BaseAddr ) ) 
            {
                return( USB_OPERATE_ERROR );
            }
            wReleaseNum = ( pwAddress - gEHCI_ITD_BaseAddr ) / EHCI_ITD_SIZE;                
            if( wReleaseNum > EHCI_ITD_MAX ) 
            {
                return( USB_OPERATE_ERROR );
            }
            
            /* ݽṹڴ */     
            EHCI_iTD_Manage[ wReleaseNum ] = EHCI_MEM_FREE;                     /* ѷ־ */             
            for( i = 0; i < EHCI_ITD_SIZE / 4; i++ )
            {
                *( pData + i ) = 0x00;        
            }
            break;

        case EHCI_MEM_TYPE_4K_BUFFER:      
            if( ( pwAddress < gEHCI_DataPage_BaseAddr ) || ( pwAddress > gEHCI_DataPage_BaseAddr + EHCI_DATA_BUF_LEN ) ) 
            {
                return( USB_OPERATE_ERROR );
            }
            wReleaseNum = ( pwAddress - gEHCI_DataPage_BaseAddr ) / EHCI_DATAPAGE_SIZE;
            if( wReleaseNum > EHCI_DATAPAGE_MAX) 
            {
                return( USB_OPERATE_ERROR );
            }  
            
            /* ݻڴ */                        
            EHCI_DataPage_Manage[ wReleaseNum ] = EHCI_MEM_FREE;                /* ѷ־ */     
            break;    

        default: 
            return( USB_OPERATE_ERROR );
    }
    return( USB_OPERATE_SUCCESS );
}

/*******************************************************************************
* Function Name  : USBHOST_Allocate_QH
* Description    : ʼQH
* Input          : *Device---------ǰ豸
                   *psQHTemp-------ҪгʼQH
*                  bQHType---------ǰQH
*                  bType-----------ǰ˵ǷΪƴ˵
*                  bHead-----------ǰQHǷΪͷ
*                  bEndPt----------ǰ˵
*                  wMaxPacketSize--ǰ˵С
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_Allocate_QHD( ATTACH_DEVICE_INFO *Device, 
                            qHD_Structure *psQHTemp, 
                            UINT8 bQHType, 
                            UINT8 bType, 
                            UINT8 bHead, 
                            UINT8 bEndPt, 
                            UINT32 wMaxPacketSize )
{
    qTD_Structure *spTempqTD;

    /* ṩĲ,ʼqHD */
    /* <1>.Next_qHD_Pointer Word */
    psQHTemp->bTerminate = 0x00;                  
    psQHTemp->bType = bQHType;                         
                
    /* <2>.qHD_2 Word */
    psQHTemp->bDeviceAddress = Device->bAddress;                                /* Bit6---0 */     
    psQHTemp->bInactiveOnNextTransaction = 0x00;                                /* Bit7 */
    psQHTemp->bEdNumber = bEndPt;                                               /* Bit11---8 */               
    psQHTemp->bEdSpeed = Device->bSpeed;                                        /* Bit13---12 */ 
    if( bType )
    {    
        psQHTemp->bDataToggleControl = 0x01;                                    /* Bit14: 1 for control 0 for Bulk */   
    }
    else
    {
        psQHTemp->bDataToggleControl = 0x00;                                    /* Bit14: 1 for control 0 for Bulk */   
    }    
    psQHTemp->bHeadOfReclamationListFlag = bHead;                               /* Bit15 */
    psQHTemp->bMaxPacketSize = wMaxPacketSize;                                  /* Bit26---16 */     
    if( ( Device->bSpeed != EHCI_DEVICE_SPEED_HS ) && ( bType ) )
    {    
        psQHTemp->bControlEdFlag = 0x01;                                        /* Bit27 */ 
    }
    psQHTemp->bNakCounter = 0x00;                                               /* Bit31---28 */ 

    /* <3>.qHD_3 Word */    
    psQHTemp->bInterruptScheduleMask = 0x00;                                    /* Bit7---0 */
    psQHTemp->bSplitTransactionMask = 0x00;                                     /* Bit15---8 */
    psQHTemp->bHubAddr = Device->bHubAddress;                                   /* Bit22---16 */  
    psQHTemp->bPortNumber = Device->bOnHubPortNumber;                           /* Bit29---23 */  
    psQHTemp->bHighBandwidth = 0x01;                                            /* Bit31---30 */  

    /* <4>.Overlay_CurrentqTD */  

    /* <5>.Overlay_NextqTD */       
    psQHTemp->bOverlay_NextTerminate = 0x01;                                    /* Bit0 */

    /* <6>.Overlay_AlternateNextqTD */       
    psQHTemp->bOverlay_AlternateNextTerminate = 0x01;                           /* Bit0 */

    /* <7>.Overlay_TotalBytes */       
    psQHTemp->bOverlay_Status = 0;

    /* <8>.Overlay_BufferPointer0 */ 
   
    /* 1qTD,صQH */
    spTempqTD = ( qTD_Structure *)USBHOST_GetStructure( EHCI_MEM_TYPE_QTD ); 
    psQHTemp->bOverlay_NextqTD = ( ( (UINT32)spTempqTD ) >> 0x05 );
    psQHTemp->bOverlay_AlternateqTD = ( ( (UINT32)spTempqTD ) >> 0x05 );

    /* <4>.Overlay_CurrentqTD */  
    psQHTemp->bOverlay_CurrentqTD = (UINT32)spTempqTD;                          /* Ҫ,ڼ䵱ǰԭʼTD */
    psQHTemp->bOverlay_NextTerminate = 0x00;
    psQHTemp->bOverlay_AlternateNextTerminate = 0x00;
    
    return( USB_OPERATE_SUCCESS );    
}

/*******************************************************************************
* Function Name  : USBHOST_Resume
* Description    : 
* Input          : *Device----------ǰ豸
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_Resume( ATTACH_DEVICE_INFO *Device )
{
//    if( ( EHCI_Regs->hc_portsc & RB_PO_SUSP ) == 0 )  return( USB_PARAMETER_ERROR );

    EHCI_Regs->hc_portsc |= RB_F_PO_RESM;    
    Delay_ms( 30 );      
    
    /* Write PORTSC->ForcePortResume = 0 (Host should not issue the PortChange interrupt) */
    EHCI_Regs->hc_portsc &= ~RB_F_PO_RESM;    
    Delay_us( 100 );

    if( EHCI_Regs->hc_portsc & RB_PO_SUSP )  
    {
        return( USB_PARAMETER_ERROR );
    }
    Device->bSuspend = 0x00;                                                    /* 豸־ */
    return ( USB_OPERATE_SUCCESS );  
}

/*******************************************************************************
* Function Name  : USBHOST_Suspend
* Description    : 
* Input          : *Device----------ǰ豸
* Output         : None
* Return         : 0x00ʾɹ; 0x01ʾʧ
*******************************************************************************/
UINT8 USBHOST_Suspend( ATTACH_DEVICE_INFO *Device )
{
    if( ( EHCI_Regs->hc_portsc & RB_PO_EN ) == 0 )    
    {
        return( USB_PARAMETER_ERROR );
    }
       
    /* Write PORTSC->Suspend=1 */    
    EHCI_Regs->hc_portsc |= RB_PO_SUSP; 
    Device->bSuspend = 1;
    Delay_us( 100 );
    if ( ( EHCI_Regs->hc_portsc & RB_PO_SUSP ) == 0x00 ) EHCI_Regs->hc_portsc |= RB_PO_SUSP;

    /* Waiting for the PORTSC->Suspend=1 */
//    while( EHCI_Regs->hc_portsc & RB_PO_SUSP == 0x00 );

    return( USB_OPERATE_SUCCESS );
}

/*******************************************************************************
* Function Name  : DEBUG_Printf_Memary
* Description    : ӡָڴռ
* Input          : startaddr---ڴռʼַ
*                  size--------ӡ˫ֽ
* Output         : None
* Return         : None
*******************************************************************************/
void DEBUG_Print_Memory( UINT32 startaddr, UINT16 size )
{
    UINT32 *p;
    UINT16 i;
    
    p = (UINT32 *)startaddr;    
    printf( "Memory Start Address: %08lx\n",startaddr);
    for( i = 0; i < size; i++ )
    {
        printf( "%08lx\n",*p++ );
    }        
}

/*******************************************************************************
* Function Name  : USBHOST_DevicePara_Init
* Description    : ʼ豸ز
* Input          : *Device---ǰ豸
* Output         : None
* Return         : None
*******************************************************************************/
void USBHOST_DevicePara_Init( ATTACH_DEVICE_INFO *Device )
{                                                                
    gEHCILastStatus = 0x00;                                                     /* EHCIһβ״̬ */

    Device->bDeviceOnHub = 0x00;                                                /* ĬϵǰUSB豸δHUB */
    Device->bOnHubPortNumber = 0x00;                                            /* ĬϵǰUSB豸HUBϵĶ˿ںΪ0 */
    Device->bAddress = 0x00;                                                    /* ĬϵǰUSB豸ַΪ0 */
    Device->bHubAddress = 0x00;                                                 /* ĬϵǰUSBصHUBַΪ0 */    
    Device->bConnectStatus = 0x00;                                              /* ĬϵǰUSB豸δ */
    Device->bPortEnableDisableStatus = 0x00;                                    /* Ĭ϶˿δʹ */    
    Device->bSpeed = 0xFF;                                                      /* ĬϵǰUSB豸ٶδ֪ */    
    Device->bEp0MaxPks = DEFAULT_USB_EP0_SIZE;                                  /* ĬϵǰUSB豸˵0СΪ8 */    
    Device->bPortReset = 0x00;                                                  /* ĬϵǰUSB豸δλ */
    Device->bSuspend = 0x00;                                                    /* ĬϵǰUSB豸δ */
    Device->bRemoteWakeUpDetected = 0x00;                                    
    Device->bSendOK = 0x00;                                                     /* ĬϵǰUSB豸ͳɹ */
    Device->bSendStatusError = 0x00;                                            /* ĬϵǰUSB豸״̬Ϊ0 */        
}

/*******************************************************************************
* Function Name  : USBHOST_EHCI_BusReset
* Description    : USB߸λ
* Input          : *Device---ǰ豸
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_EHCI_BusReset( ATTACH_DEVICE_INFO *Device )  
{
    UINT16 timeout;

#ifdef  MY_DEBUG_PRINTF 
    printf( "USBHOST_BusReset:...\n " );
#endif    

    if( Device->bDeviceOnHub )                                                  /* ǰ豸HUB */    
    {
        return( USB_OPERATE_SUCCESS );
    }

    /* 豸ַ˵0С */
    Device->bEp0MaxPks = DEFAULT_USB_EP0_SIZE;                                  /* ĬϵǰUSB豸˵0СΪ64 */    
    Device->bAddress = 0x00;                                                    /* 浱ǰĵֵַ */
    
    /* USB߸λ */
    EHCI_Regs->hc_portsc = EHCI_PORT_INIT | RB_PO_RESET;                        /* PORTSCλ8USB߸λ */
    Delay_ms( 60 );        
    EHCI_Regs->hc_portsc = EHCI_PORT_INIT;                                      /* PORTSCλ8USB߸λ */
    Delay_ms( 2 );        
        
    /* ȴλ */    
    for( timeout = 2000; timeout != 0; timeout -- ) 
    {
        Delay_us( 10 );                
        if( ( EHCI_Regs->hc_portsc & RB_PO_RESET ) == 0 ) 
        {
            break;                                                              /* ȴλ */
        }
    }
    if( timeout == 0 ) 
    {
        return( USB_OPERATE_ERROR );                                            /* ʱδλ,򱨸 */    
    }
    Delay_ms( 5 );                                                              /* EHCIһܹ */
    EHCI_Regs->hc_usbsts = RB_PO_CHG_DET;
    return( USB_OPERATE_SUCCESS );
}

/*******************************************************************************
* Function Name  : USBHOST_EHCI_Detect_Connect
* Description    : USB豸
*                  ע˿ʹλ߸λʱԶ1
* Input          : *Device---ǰ豸
* Output         : None
* Return         : 0x00-----------------USB豸
*                  0x01-----------------USB豸δʹ
*                  0x02-----------------USB豸Ѿʹ
*                  USB_INT_CONNECT------⵽USB豸¼
*                  USB_INT_DISCONNECT---⵽USB豸Ͽ¼
*******************************************************************************/
UINT8 USBHOST_EHCI_Detect_Connect( ATTACH_DEVICE_INFO *Device )
{            
    if( EHCI_Regs->hc_portsc & RB_CONN_CHG )                                    /* Connect status change */
    {    
        EHCI_Regs->hc_usbsts = RB_PO_CHG_DET;                                   /* Clear Port change detect */
        EHCI_Regs->hc_portsc = RB_CONN_CHG;                                     /* 仯λ */
        Delay_ms( 3 );
                    
        /* жϵǰıӻǶϿ */
        if( EHCI_Regs->hc_portsc & RB_CONN_STS )
        {
            /* start controller operations */                
            USBHOST_HC_StopRun_Setting( USBHOST_OP_ENABLE );                    /* USB */                
            Delay_ms( 110 );
            USBHOST_EHCI_BusReset( Device );                                    /* USB߸λ */
            Delay_ms( 5 );
            EHCI_Regs->hc_usbsts = RB_PO_CHG_DET;
            Device->bConnectStatus = 0x01;                

            /* еǰUSB豸ٶж */
            Device->bSpeed = ( OTG_CONTROL_STATUS >> 22 ) & 0x03;               /* ȡOTG Control Status Register(0x080)λ23-22 */        
            return( USB_INT_CONNECT );                                          /* ⵽USB豸¼ */                 
        }    
        else
        {
            USBHOST_DevicePara_Init( Device );                                  /* ز */    
            return( USB_INT_DISCONNECT );                                       /* ⵽USB豸Ͽ¼ */
        }            
    }    
    else
    {            
        if( ( EHCI_Regs->hc_portsc & RB_CONN_STS ) == 0x00 )
        {
            return( USB_INT_DISCONNECT );                                       /* USB豸 */
        }        
        else
        {
            if( EHCI_Regs->hc_portsc & RB_PO_EN )
            {
                return( 0x02 );                                                 /* USB豸Ѿʹ */    
            }    
            else
            {
                /* start controller operations */                
                USBHOST_HC_StopRun_Setting( USBHOST_OP_ENABLE );                /* USB */                
                Delay_ms( 110 );
                USBHOST_EHCI_BusReset( Device );                                /* USB߸λ */
                Delay_ms( 5 );
                EHCI_Regs->hc_usbsts = RB_PO_CHG_DET;
                Device->bConnectStatus = 0x01;                
    
                /* еǰUSB豸ٶж */
                Device->bSpeed = ( OTG_CONTROL_STATUS >> 22 ) & 0x03;           /* ȡOTG Control Status Register(0x080)λ23-22 */        

                return( 0x01 );                                                 /* USB豸δʹ */    
            }    
        }                    
    }            
}

/*******************************************************************************
* Function Name  : USBHOST_EHCI_EP0_Init
* Description    : USBƶ˵0ʼ
* Input          : *Device---ǰ豸
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_EHCI_EP0_Init( ATTACH_DEVICE_INFO *Device )
{
    UINT32 temp;
    
#ifdef  MY_DEBUG_PRINTF 
    printf( "USBHOST_EP0_Init:...\n" );
#endif
    
    /* 䵱ǰƴҪQH */
    temp = USBHOST_GetStructure( EHCI_MEM_TYPE_QHD );
    if( temp == USB_MEM_ALLOCATE_ERROR )
    {
        return( USB_MEM_ALLOCATE_ERROR );
    }    
    Device->qHD_Control = ( qHD_Structure *)temp;                               /* qHD_Structure */

    /*  ʼQHD */
    USBHOST_Allocate_QHD( Device, 
                          Device->qHD_Control, 
                          EHCI_HD_TYPE_QH, 
                          EHCI_EP_TYPE_CONTROL, 
                          1, 
                          0, 
                          DEFAULT_USB_EP0_SIZE );

    /* QHDӵQHD */
    USBHOST_qHD_Link_Insert( Device->qHD_Control );    
    
    EHCI_Regs->hc_asynchronous = (UINT32)Device->qHD_Control;
    USBHOST_Asynchronous_Setting( USBHOST_OP_ENABLE );                          /* Enable USB asynchronous Schedule */ 
    Delay_ms( 3 );
    return( USB_OPERATE_SUCCESS );    
}

/*******************************************************************************
* Function Name  : USBHOST_Error_Int_Deal
* Description    : USBEHCIشжϴ
*                  ֻж: λ0----RB_USB_INT
*                                  λ1----RB_USBERR_INT
*                                  λ2----RB_PO_CHG_DET
*                                  λ4----RB_H_STSERR 
* Input          : None
* Output         : None
* Return         : صǰж״̬
*******************************************************************************/
UINT8 USBHOST_Error_Int_Deal( ATTACH_DEVICE_INFO *Device )
{
    UINT32 ints;
        
    ints = EHCI_Regs->hc_usbsts;                                                /* ȡEHCIUSBSTSĴ */
    if( ints & RB_USB_INT )                                                     /* USBSTSλ0: USB Interrupt */    
    {
        EHCI_Regs->hc_usbsts = RB_USB_INT;                                      /* USBж */
    }
    else if( ints & RB_USBERR_INT )                                             /* USBSTSλ1: USB Error Interrupt */
    {    
        EHCI_Regs->hc_usbsts = RB_USBERR_INT;                                   /* USBж */
    }
    else if( ints & RB_PO_CHG_DET )                                             /* USBSTSλ2: Port Change Detect */
    {        
        EHCI_Regs->hc_usbsts = RB_PO_CHG_DET;
        return( USB_INT_DISCONNECT );
    }    
    else if( ints & RB_H_STSERR )                                               /* USBSTSλ4: HOSTϵͳж */
    {    
        EHCI_Regs->hc_usbsts = RB_H_STSERR;                                     /* HOSTϵͳж */
    }            
    else
    {
        EHCI_Regs->hc_usbsts = EHCI_Regs->hc_usbsts;                            /* ж */    
    }                
    return( USB_INT_ERROR );
}

/*******************************************************************************
* Function Name  : USBHOST_Send_qTD
* Description    : USBһQTD
* Input          : *Device-------ǰ豸
                   *spHeadqTD----ǰҪִеqTD
*                  *spTempqHD----ǰصqHD
*                  *pRetLen------ǰqTDִϺ󷵻س
*                  wTimeOutSec---ʱʱ(λΪ)
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_Send_qTD( ATTACH_DEVICE_INFO *Device, qTD_Structure *spHeadqTD, qHD_Structure *spTempqHD, UINT16 *pRetLen, UINT32 wTimeOutSec )
{
    qTD_Structure *spOldDumyqTD; 
    qTD_Structure *spReleaseqTD;    
    UINT32 timeout;
    UINT8  flag;     

    spOldDumyqTD = ( qTD_Structure *)( ( (UINT32)( spTempqHD->bOverlay_NextqTD ) ) << 5 );  /* еTD,ǰTD */
    memcpy( spOldDumyqTD, spHeadqTD, EHCI_QTD_SIZE );                           /* ƵǰTDй */
        
    spOldDumyqTD->bNextQTDPointer = ( (UINT32)spHeadqTD ) >> 5;                 /* TDȥΪ,ڴӸָ뿪 */
    spOldDumyqTD->bTerminate = 0;   
    spOldDumyqTD->bStatus_Active = 1;                                           /* ԵǰTDĲ,TDᱻ,ǰTDݱƵQHгΪٴ */
    spOldDumyqTD->bAlternateQTDPointer = ( (UINT32)spHeadqTD ) >> 5;            /* ̰ȴӸָ뿪 */
    spOldDumyqTD->bAlternateTerminate = 0;

    Device->psSendLastqTD = spOldDumyqTD;
    Device->bSendStatusError = 0;
  
    flag = 0x00;     
    wTimeOutSec *= 50;
    for( timeout = wTimeOutSec; timeout != 0; timeout -- ) 
    {     
        /* ȴ */
        Delay_us( 20 );                                                         /* ÿ20uSҲѯһ */
        if( spOldDumyqTD->bStatus_Active == 0x00 ) 
        {
            break;                                                              /* ,ɺԶQHиƻ */
        }
        if( EHCI_Regs->hc_usbsts & RB_PO_CHG_DET ) 
        {  
            /* ѯ豸ǷϿ */
            flag = 0x02;
            break;
        }
    }

    if( timeout == 0 )                                                          /* ʱ˳ */
    {
        USBHOST_Asynchronous_Setting( USBHOST_OP_DISABLE );                     /* ֹͣ첽 */
        spOldDumyqTD->bStatus_Active = 0;                                       /* ֹͣQTD */        
        spOldDumyqTD->bTerminate = 1;                                           /* Ͽ */
        spOldDumyqTD->bAlternateTerminate = 1;
        spTempqHD->bOverlay_Status &= 0x7F;                                     /* ֹͣ */
        Delay_us( 100 );                                                        /* ȴ */
    }
    if( pRetLen ) 
    {
        *pRetLen = *pRetLen - spOldDumyqTD->bTotalBytes;                        /* 泤 */
    }
    gEHCILastStatus = spTempqHD->bOverlay_Status;                               /* ϴۼִ״̬,ǵǰ,ǳʱʹspOldDumyqTD״̬ */
    Device->bSendStatusError = gEHCILastStatus;                                 /* ݴ浱ǰqHDִ״̬,жǷд */
    spTempqHD->bOverlay_Status = 0;                                             /* Աٴۼƴ */
    spReleaseqTD = ( qTD_Structure *)( ( (UINT32)( spTempqHD->bOverlay_NextqTD ) ) << 5 );  /* ʱͣڵǰTD,ͣһTDõTD */
    spReleaseqTD = spReleaseqTD == spOldDumyqTD ? spHeadqTD : spOldDumyqTD;     /* ʱͷTD,ͷŵǰTD */
    USBHOST_ReleaseStructure( EHCI_MEM_TYPE_QTD, ( UINT32 )spReleaseqTD );      /* qTD */

    if( timeout == 0 ) 
    {
        USBHOST_Asynchronous_Setting( USBHOST_OP_ENABLE );
    }
    
    if( ( gEHCILastStatus & EHCI_QTD_STATUS_HALTED ) || ( gEHCILastStatus & EHCI_QTD_STATUS_BUF_ERROR ) || 
        ( gEHCILastStatus & EHCI_QTD_STATUS_BABBLE ) || ( gEHCILastStatus & EHCI_QTD_STATUS_TRANS_ERROR ) ||
        ( gEHCILastStatus & EHCI_QTD_STATUS_MISS_FRAME ) || ( timeout == 0 ) ) 
    {
        flag = 0x01;
    }
        
#ifdef  MY_DEBUG_PRINTF         
    if( gEHCILastStatus & EHCI_QTD_STATUS_HALTED ) 
    {
        printf("ERR: EHCI_QTD_STATUS_HALTED\n");
    }
    if( gEHCILastStatus & EHCI_QTD_STATUS_BUF_ERROR ) 
    {
        printf("ERR: EHCI_QTD_STATUS_BUF_ERROR\n");
    }
    if( gEHCILastStatus & EHCI_QTD_STATUS_BABBLE ) 
    {
        printf("ERR: EHCI_QTD_STATUS_BABBLE\n");
    }
    if( gEHCILastStatus & EHCI_QTD_STATUS_TRANS_ERROR ) 
    {
        printf("ERR: EHCI_QTD_STATUS_TRANS_ERROR\n");
    }
    if( gEHCILastStatus & EHCI_QTD_STATUS_MISS_FRAME ) 
    {  
        printf("ERR: EHCI_QTD_STATUS_MISS_FRAME\n");
    }
    if( timeout == 0 )
    {
//        printf("EHCI Time Out.........\n");        
    }
#endif   

    /* ִ״̬ */
    if( flag )  
    {
        if( flag == 0x02 )
        {
            return( USB_INT_DISCONNECT );    
        }
        if( timeout == 0 ) 
        {
            return( ERR_USB_TIMEOUT );
        }
        return( USBHOST_Error_Int_Deal( Device ) );        
    }  
    else
    {         
        return( USB_OPERATE_SUCCESS );
    }
}

/*******************************************************************************
* Function Name  : USBHOST_Issue_Control
* Description    : USBһƴ
* Input          : *Device-----ǰ豸
*                  *pCmdPack---ƴ
*                  *pDatBuf----շݻ
*                   *pRetLen----շʵʳ
* Output         : None   
* Return         : None
*******************************************************************************/
UINT8 USBHOST_Issue_Control( ATTACH_DEVICE_INFO *Device, USB_SETUP_REQ *pCmdPack, UINT8 *pDatBuf, UINT16 *pRetLen )
{
    UINT8  status;
    UINT32 total, temp;
    UINT16 retlen;
    UINT8  tog; 
    UINT8  retry;
    UINT8  back[ 8 ];
    UINT8  *pbuf;
    qTD_Structure *spTempqTD;
    
    memcpy( back, pCmdPack, 8 );                                                /* ݵǰ */    
    for( retry = 0; retry < 3; retry++ )                                        /* 3 */
    {
        /* 豸Ƿ */
        status = USBHOST_EHCI_Detect_Connect( Device );                         /* 豸Ƿ */
        if( ( status == USB_INT_DISCONNECT ) || ( status == 0x00 ) )
        {
             return( USB_INT_DISCONNECT );
        }        
        
        /* 1. SETUP׶ */
        Delay_us( 500 );        
        pbuf = back;

        /* 1.1 qTDʼ */
        spTempqTD = ( qTD_Structure *)USBHOST_GetStructure( EHCI_MEM_TYPE_QTD );  
        spTempqTD->bPID = EHCI_QTD_PID_SETUP;                                   /* Bit9---8 */   
        spTempqTD->bTotalBytes = retlen = 8;                                    /* Bit30---16 */   
        spTempqTD->bDataToggle = 0;                                             /* Bit31 */ 
        spTempqTD->ArrayBufferPointer_Word[ 0 ] = (UINT32)pbuf; 

        /* 1.2 qTDȴִ  */
        status = USBHOST_Send_qTD( Device, spTempqTD, Device->qHD_Control, &retlen, 1000 );
        Delay_us( 500 );        
        if( status == USB_OPERATE_SUCCESS )
        {    
            /* 2. ݽ׶ */
            /* һδԴ20K,ûнжѭ */
            tog = TRUE;                                                         /* ĬDATA1,Ĭݹ״̬׶ΪIN */    
            total = ( ( (UINT32)Ctl_Setup->wLengthH ) << 8 ) + Ctl_Setup->wLengthL;
            if( total && pDatBuf )                                              /* Ҫշ */
            {
                pbuf = pDatBuf;
                if( Ctl_Setup->bReqType & 0x80 )                                /* DATA׶: ݽ */
                {    
                    /* 2.1 INqTDʼ */
                    spTempqTD = ( qTD_Structure *)USBHOST_GetStructure( EHCI_MEM_TYPE_QTD );
                    spTempqTD->bPID = EHCI_QTD_PID_IN;                          /* Bit9---8 */   
                    spTempqTD->bTotalBytes = retlen = total;                    /* Bit30---16 */   
                    spTempqTD->bDataToggle = 1;                                 /* Bit31 */ 
                    spTempqTD->ArrayBufferPointer_Word[ 0 ] = (UINT32)pbuf;
                    temp = ( ( UINT32 )( pbuf ) >> 12  + 1 ) << 12;
                    spTempqTD->ArrayBufferPointer_Word[ 1 ] = (UINT32)temp; 
                    spTempqTD->ArrayBufferPointer_Word[ 2 ] = (UINT32)temp + 4096;                    
                    spTempqTD->ArrayBufferPointer_Word[ 3 ] = (UINT32)temp + 2 * 4096;                    
                    spTempqTD->ArrayBufferPointer_Word[ 4 ] = (UINT32)temp + 3 * 4096;                    

                    /* 2.2 䲢ȴִ  */
                    status = USBHOST_Send_qTD( Device, spTempqTD, Device->qHD_Control,  &retlen, 1000 );                    
                    if( status == USB_INT_DISCONNECT )                          /* 豸Ͽ,ֱӷ */
                    {
                        return( status );
                    }
                    if( gEHCILastStatus & EHCI_QTD_STATUS_HALTED )              /* STALL */
                    {
                        USBHOST_EHCI_ClearEndpStall( Device, 0x00 );            /* ˵ */
                    }
                    tog = FALSE;                                                /* ״̬׶ΪOUT */
                }           
                else                                                            /* DATA׶: ݷ */
                {
                    /* 2.1 OUTqTDʼ */
                    spTempqTD = ( qTD_Structure *)USBHOST_GetStructure( EHCI_MEM_TYPE_QTD );  
                    spTempqTD->bPID = EHCI_QTD_PID_OUT;                         /* Bit9---8 */   
                    spTempqTD->bTotalBytes = retlen = total;                    /* Bit30---16 */   
                    spTempqTD->bDataToggle = 1;                                 /* Bit31 */ 
                    spTempqTD->ArrayBufferPointer_Word[ 0 ] = (UINT32)pbuf;
                    temp = ( ( UINT32 )( pbuf ) >> 12  + 1 ) << 12;                    
                    spTempqTD->ArrayBufferPointer_Word[ 1 ] = (UINT32)temp; 
                    spTempqTD->ArrayBufferPointer_Word[ 2 ] = (UINT32)temp + 4096;                    
                    spTempqTD->ArrayBufferPointer_Word[ 3 ] = (UINT32)temp + 2 * 4096;                    
                    spTempqTD->ArrayBufferPointer_Word[ 4 ] = (UINT32)temp + 3 * 4096;                    

                    /* 䲢ȴִ  */
                    status = USBHOST_Send_qTD( Device, spTempqTD, Device->qHD_Control,  &retlen, 1000 );
                    if( status == USB_INT_DISCONNECT )                          /* 豸Ͽ,ֱӷ */
                    {
                        return( status );
                    }
                    if( gEHCILastStatus & EHCI_QTD_STATUS_HALTED )              /* STALL */
                    {
                        USBHOST_EHCI_ClearEndpStall( Device, 0x00 );            /* ˵ */
                    }
                    tog = TRUE;                                                 /* ״̬׶ΪIN */
                }
                
                /* ʵʴ䳤 */        
                if( pRetLen )  
                {
                    *pRetLen = retlen;                                          /* ʵʳɹշܳ */
                }                
            }            
            if( status == USB_OPERATE_SUCCESS )
            {    
                /* 3. ״̬׶ */                
                Delay_us( 500 );        
                /* 3.1 INOUTqTDʼ */
                spTempqTD = ( qTD_Structure *)USBHOST_GetStructure( EHCI_MEM_TYPE_QTD );
                if( tog == FALSE )    
                {    
                    spTempqTD->bPID = EHCI_QTD_PID_OUT;                         /* Bit9---8 */   
                }
                else
                {
                    spTempqTD->bPID = EHCI_QTD_PID_IN;                          /* Bit9---8 */                       
                }    
                spTempqTD->bDataToggle = 1;                                     /* Bit31 */ 
                spTempqTD->bTotalBytes = retlen = 0x00;                         /* Bit30---16 */   
                pbuf = back;
                spTempqTD->ArrayBufferPointer_Word[ 0 ] = (UINT32)pbuf;

                /* 3.2 䲢ȴִ  */
                status = USBHOST_Send_qTD( Device, spTempqTD, Device->qHD_Control,  &retlen, 1000 );
                if( status == USB_OPERATE_SUCCESS )    
                {    
                    Delay_us( 200 );        
                    return( USB_OPERATE_SUCCESS );            
                }
                else if( status == USB_INT_DISCONNECT )                         /* 豸Ͽ,ֱӷ */
                {
                    return( status );
                }                
                else
                {
                    /* TimeoutCRCBad PIDȴ */    
                }    
            }
            else if( status == USB_INT_DISCONNECT )                             /* 豸Ͽ,ֱӷ */
            {
                return( status );                
            }     
        }    
        Delay_us( 1000 );        
    }
    return( USB_OPERATE_ERROR );    
}

/*******************************************************************************
* Function Name  : USBHOST_Issue_Bulk
* Description    : USBִ
* Input          : *Device-----ǰ豸
*                  *pBlukqHD---˵QH
*                  *pDatBuf---ݻ
*                  *pSize-----͡ݴС
*                  Type-------(IN/OUT)
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_Issue_Bulk( ATTACH_DEVICE_INFO *Device, qHD_Structure *pBlukqHD, UINT8 *pDatBuf, UINT16 *pSize, UINT8 Type )
{
    qTD_Structure *spTempqTD;
    UINT32 temp;

    /* Ϊǰ1qTD */    
    spTempqTD = ( qTD_Structure *)USBHOST_GetStructure( EHCI_MEM_TYPE_QTD ); 
    spTempqTD->bTotalBytes = *pSize;      
    spTempqTD->bDataToggle = 0;  
    spTempqTD->ArrayBufferPointer_Word[ 0 ] = (UINT32)pDatBuf;
    temp = ( ( ( UINT32 )( pDatBuf ) >> 12 ) + 1 ) << 12;
    spTempqTD->ArrayBufferPointer_Word[ 1 ] = (UINT32)temp; 
    spTempqTD->ArrayBufferPointer_Word[ 2 ] = (UINT32)temp + 4096;                    
    spTempqTD->ArrayBufferPointer_Word[ 3 ] = (UINT32)temp + 2 * 4096;                    
    spTempqTD->ArrayBufferPointer_Word[ 4 ] = (UINT32)temp + 3 * 4096;                       
    spTempqTD->bPID = Type;             

    /* ִд䲢ȴؽ */
    return( USBHOST_Send_qTD( Device, spTempqTD, pBlukqHD, pSize, 20000 ) );    
}

/*******************************************************************************
* Function Name  : USBHOST_Issue_Interrupt
* Description    : USBִжϴ
* Input          : *Device-----ǰ豸
*                  *pIntqHD---˵QH
*                  *pDatBuf---ݻ
*                  *pSize-----͡ݴС
*                  Type-------(IN/OUT)
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_Issue_Interrupt( ATTACH_DEVICE_INFO *Device, qHD_Structure *pIntqHD, UINT8 *pDatBuf, UINT16 *pSize, UINT8 Type )
{
    qTD_Structure *spTempqTD;
    UINT32 temp;

    /* Ϊǰжϴ1qTD */    
    spTempqTD = ( qTD_Structure *)USBHOST_GetStructure( EHCI_MEM_TYPE_QTD ); 
    spTempqTD->bTotalBytes = *pSize;      
//    spTempqTD->bDataToggle = 0;  
    spTempqTD->ArrayBufferPointer_Word[ 0 ] = (UINT32)pDatBuf;
    temp = ( ( ( UINT32 )( pDatBuf ) >> 12 ) + 1 ) << 12;
    spTempqTD->ArrayBufferPointer_Word[ 1 ] = (UINT32)temp; 
    spTempqTD->ArrayBufferPointer_Word[ 2 ] = (UINT32)temp + 4096;                    
    spTempqTD->ArrayBufferPointer_Word[ 3 ] = (UINT32)temp + 2 * 4096;                    
    spTempqTD->ArrayBufferPointer_Word[ 4 ] = (UINT32)temp + 3 * 4096;                       
    spTempqTD->bPID = Type;             

    /* ִд䲢ȴؽ */
    return( USBHOST_Send_qTD( Device, spTempqTD, pIntqHD, pSize, 1 ) );    
}  

/*******************************************************************************
* Function Name  : USBHOST_Issue_qTD
* Description    : USBһQTD
*                  úqTD,ȴִ,Ҳ
* Input          : *Device-------ǰ豸
                   *spHeadqTD----ǰҪִеqTD
*                  *spTempqHD----ǰصqHD
* Output         : None
* Return         : None
*******************************************************************************/
UINT32 USBHOST_Issue_qTD( ATTACH_DEVICE_INFO *Device, qTD_Structure *spHeadqTD, qHD_Structure *spTempqHD )
{
    qTD_Structure *spOldDumyqTD;   

    spOldDumyqTD = ( qTD_Structure *)( ( (UINT32)( spTempqHD->bOverlay_NextqTD ) ) << 5 );  /* еTD,ǰTD */    
    memcpy( spOldDumyqTD, spHeadqTD, EHCI_QTD_SIZE );                           /* ƵǰTDй */   
    spOldDumyqTD->bNextQTDPointer = ( (UINT32)spHeadqTD ) >> 5;                 /* TDȥΪ,ڴӸָ뿪 */
    spOldDumyqTD->bTerminate = 0;   
    spOldDumyqTD->bStatus_Active = 1;                                           /* ԵǰTDĲ,TDᱻ,ǰTDݱƵQHгΪٴ */
    spOldDumyqTD->bAlternateQTDPointer = ( (UINT32)spHeadqTD ) >> 5;            /* ̰ȴӸָ뿪 */
    spOldDumyqTD->bAlternateTerminate = 0;
    Device->psSendLastqTD = spOldDumyqTD;
    Device->bSendStatusError = 0; 
    return( (UINT32)spOldDumyqTD );
}

/*******************************************************************************
* Function Name  : USBHOST_Check_qTD
* Description    : USBѯQTDǷִ
* Input          : *Device-------ǰ豸
*                  *spHeadqTD----ǰҪѯqTD
*                  *spTempqHD----ǰصqHD
*                  *pRetLen------ȡ,ɹʵʻȡ
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_Check_qTD( ATTACH_DEVICE_INFO *Device, qTD_Structure *spHeadqTD, qHD_Structure *spTempqHD, UINT16 *pRetLen )
{
    qTD_Structure *spOldDumyqTD; 
    qTD_Structure *spReleaseqTD; 

       spOldDumyqTD = ( qTD_Structure *)spHeadqTD;
    if( spOldDumyqTD->bStatus_Active == 0x00 ) 
    {
        if( pRetLen ) 
        {
            *pRetLen = *pRetLen - spOldDumyqTD->bTotalBytes;                    /* 泤 */
        } 

        /* ִгɹĴ */
        gEHCILastStatus = spTempqHD->bOverlay_Status;                           /* ϴۼִ״̬,ǵǰ,ǳʱʹspOldDumyqTD״̬ */
        Device->bSendStatusError = gEHCILastStatus;                             /* ݴ浱ǰqHDִ״̬,жǷд */
        spTempqHD->bOverlay_Status = 0;                                         /* Աٴۼƴ */
        spReleaseqTD = ( qTD_Structure *)( ( (UINT32)( spTempqHD->bOverlay_NextqTD ) ) << 5 );  /* ʱͣڵǰTD,ͣһTDõTD */
        spReleaseqTD = spReleaseqTD == spOldDumyqTD ? spHeadqTD : spOldDumyqTD; /* ʱͷTD,ͷŵǰTD */
        USBHOST_ReleaseStructure( EHCI_MEM_TYPE_QTD, ( UINT32 )spReleaseqTD );  /* qTD */
        return( USB_OPERATE_SUCCESS );
    }
    return( USB_OPERATE_ERROR );
}

/*******************************************************************************
* Function Name  : USBHOST_Remove_qTD
* Description    : USBǿƳǰQTD
* Input          : *Device-------ǰ豸
                   *spHeadqTD----ǰҪѯqTD
*                  *spTempqHD----ǰصqHD
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_Remove_qTD( ATTACH_DEVICE_INFO *Device, qTD_Structure *spHeadqTD, qHD_Structure *spTempqHD )
{
    qTD_Structure *spOldDumyqTD; 
    qTD_Structure *spReleaseqTD;   

    spOldDumyqTD = ( qTD_Structure *)( ( (UINT32)( spTempqHD->bOverlay_NextqTD ) ) << 5 );  /* еTD,ǰTD */
    USBHOST_Asynchronous_Setting( USBHOST_OP_DISABLE );                         /* ֹͣ첽 */
    spOldDumyqTD->bStatus_Active = 0;                                           /* ֹͣQTD */        
    spOldDumyqTD->bTerminate = 1;                                               /* Ͽ */
    spOldDumyqTD->bAlternateTerminate = 1;
    spTempqHD->bOverlay_Status &= 0x7F;                                         /* ֹͣ */
    Delay_us( 100 );                                                            /* ȴ */
    gEHCILastStatus = spTempqHD->bOverlay_Status;                               /* ϴۼִ״̬,ǵǰ,ǳʱʹspOldDumyqTD״̬ */
    Device->bSendStatusError = gEHCILastStatus;                                 /* ݴ浱ǰqHDִ״̬,жǷд */
    spTempqHD->bOverlay_Status = 0;                                             /* Աٴۼƴ */
    spReleaseqTD = ( qTD_Structure *)( ( (UINT32)( spTempqHD->bOverlay_NextqTD ) ) << 5 );  /* ʱͣڵǰTD,ͣһTDõTD */
    spReleaseqTD = spReleaseqTD == spOldDumyqTD ? spHeadqTD : spOldDumyqTD;     /* ʱͷTD,ͷŵǰTD */
    USBHOST_ReleaseStructure( EHCI_MEM_TYPE_QTD, ( UINT32 )spReleaseqTD );      /* qTD */

    USBHOST_Asynchronous_Setting( USBHOST_OP_ENABLE );
    return( USB_OPERATE_SUCCESS );
}

/*******************************************************************************
* Function Name  : USBHOST_EHCI_GetDeviceDescr
* Description    : USBȡ豸
* Input          : *Device---ǰ豸
                   *buf------ݻ
                   *len------ݳ                   
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_EHCI_GetDeviceDescr( ATTACH_DEVICE_INFO *Device, UINT8 *buf, UINT16 *len ) 
{
    UINT16 l;
    UINT8  status;
    
    /* SETUP */
    Ctl_Setup->bReqType = 0x80;
    Ctl_Setup->bRequest = 0x06;
    Ctl_Setup->wValueL  = 0x00;
    Ctl_Setup->wValueH  = 0x01;
    Ctl_Setup->wIndexL  = 0x00;
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = *len;
    Ctl_Setup->wLengthH = 0x00;
    
    /* Ȼȡ豸ǰ8ֽ */    
    l = *len;
    status = USBHOST_Issue_Control( Device, Ctl_Setup, buf, &l  );              /* ִпƴ */    
    if( status == USB_OPERATE_SUCCESS )
    {
        Device->bEp0MaxPks = ( (PUSB_DEV_DESCR)buf ) -> bMaxPacketSize0;        /* ˵0С */
           
        /* ·˵0С */
        Device->qHD_Control->bMaxPacketSize = Device->bEp0MaxPks;               /* Bit26---16 */ 
        *len = l;                                                               /* ʵʻȡ */    
    }
    return( status );
}

/*******************************************************************************
* Function Name  : USBHOST_EHCI_GetConfigDescr
* Description    : USBȡ
* Input          : *Device---ǰ豸
                   *buf------ݻ
                   *len------ݳ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_EHCI_GetConfigDescr( ATTACH_DEVICE_INFO *Device, UINT8 *buf, UINT16 *len ) 
{
    UINT16 l;
    UINT8  status;
    
    /* SETUP */
    Ctl_Setup->bReqType = 0x80;
    Ctl_Setup->bRequest = 0x06;
    Ctl_Setup->wValueL  = 0x00;
    Ctl_Setup->wValueH  = 0x02;
    Ctl_Setup->wIndexL  = 0x00;
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x04;
    Ctl_Setup->wLengthH = 0x00;

    /* Ȼȡǰ4ֽ,Աȷʵܳ */        
    l = Ctl_Setup->wLengthL;
    status = USBHOST_Issue_Control( Device, Ctl_Setup, buf, &l  );              /* ִпƴ */    
    if( status == USB_OPERATE_SUCCESS )
    {
        /* ʵܳȻȡȫ */        
        Ctl_Setup->wLengthL = ( (PUSB_CFG_DESCR)buf ) -> wTotalLengthL;
        Ctl_Setup->wLengthH = ( (PUSB_CFG_DESCR)buf ) -> wTotalLengthH;
        l = ( ( ( UINT16 )Ctl_Setup->wLengthH << 8 ) ) + Ctl_Setup->wLengthL;
        status = USBHOST_Issue_Control( Device, Ctl_Setup, buf, &l  );          /* ִпƴ */
        if( status == USB_OPERATE_SUCCESS )
        {
            *len = l;
        }        
        else
        {
            *len = 0x00;
        }    
        return( status );
    }    
    return( status );
}

/*******************************************************************************
* Function Name  : USBHOST_EHCI_SetAddress
* Description    : USBõַ
* Input          : *Device---ǰ豸
                   addr------Ҫõĵַ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_EHCI_SetAddress( ATTACH_DEVICE_INFO *Device, UINT8 addr ) 
{
    UINT8  status;
            
    /* SETUP */        
    Ctl_Setup->bReqType = 0x00;
    Ctl_Setup->bRequest = 0x05;
    Ctl_Setup->wValueL  = Device->bDeviceOnHub ? Device->bOnHubPortNumber + addr + 1 : addr;                                
    Ctl_Setup->wValueH  = 0x00;
    Ctl_Setup->wIndexL  = 0x00;
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x00;
    Ctl_Setup->wLengthH = 0x00;

    /* USB豸ַ */
    status = USBHOST_Issue_Control( Device, Ctl_Setup, NULL, NULL  );           /* ִпƴ */        
    if( status == USB_OPERATE_SUCCESS )
    {
        /* Լַ */       
        Device->bAddress = Device-> bDeviceOnHub ? Device->bOnHubPortNumber + addr + 1 : addr;    /* 浱ǰĵֵַ */
        Device->qHD_Control->bDeviceAddress = Device->bAddress;                 /* ޸Ķ˵ĵַ */
    }    
    Delay_ms( 5 );                                                              /* ȴUSB豸ɲ */    
    return( status );
}
                                   
/*******************************************************************************
* Function Name  : USBHOST_EHCI_SetConfig
* Description    : USBֵ
* Input          : *Device---ǰ豸
                   cfg------Ҫõֵ
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_EHCI_SetConfig( ATTACH_DEVICE_INFO *Device, UINT8 cfg ) 
{
    UINT8  status;

    /* SETUP */                
    Ctl_Setup->bReqType = 0x00;
    Ctl_Setup->bRequest = 0x09;
    Ctl_Setup->wValueL  = cfg;
    Ctl_Setup->wValueH  = 0x00;
    Ctl_Setup->wIndexL  = 0x00;
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x00;
    Ctl_Setup->wLengthH = 0x00;
    
    /* USB豸 */    
    status = USBHOST_Issue_Control( Device, Ctl_Setup, NULL, NULL  );           /* ִпƴ */
    return( status );
}

/*******************************************************************************
* Function Name  : USBHOST_EHCI_ClearEndpStall
* Description    : USB˵
* Input          : *Device---ǰ豸
                   endp------ҪĶ˵
* Output         : None
* Return         : صǰִ״̬
*******************************************************************************/
UINT8 USBHOST_EHCI_ClearEndpStall( ATTACH_DEVICE_INFO *Device, UINT8 endp )
{
    UINT8  status;

    /* SETUP */                
    Ctl_Setup->bReqType = 0x02;
    Ctl_Setup->bRequest = 0x01;
    Ctl_Setup->wValueL  = 0x00;
    Ctl_Setup->wValueH  = 0x00;
    Ctl_Setup->wIndexL  = endp;
    Ctl_Setup->wIndexH  = 0x00;
    Ctl_Setup->wLengthL = 0x00;
    Ctl_Setup->wLengthH = 0x00;
    
    /* USB豸 */    
    status = USBHOST_Issue_Control( Device, Ctl_Setup, NULL, NULL  );           /* ִпƴ */    
    return( status );
}

/*******************************************************************************
* Function Name  : USBHOST_CofDescrAnalyse
* Description    : USB
*                  ˴ֻǼж豸,Ҫ豸ͽϸһ
* Input          : *pbuf--- 
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_CofDescrAnalyse( UINT8 *pbuf )
{
    gDeviceClassType = ( (PUSB_CFG_DESCR_LONG)pbuf ) -> itf_descr.bInterfaceClass;
    if( ( gDeviceClassType <= 0x09 ) || ( gDeviceClassType == 0xFF ) )    
    {
        return( USB_OPERATE_SUCCESS ); 
    }
    else
    {
        gDeviceClassType = USB_DEV_CLASS_RESERVED;                              /* ǰ豸Ĭδ֪ */     
        return( ERR_USB_UNKNOWN );                                              /* ֧,  */
    }            
}

/*******************************************************************************
* Function Name  : USBHOST_EHCI_Enumerate
* Description    : USB豸ö
*                  ö:
                   (1)ȡ豸;
                   (2)λUSB豸;
                   (3)USBַ;
                   (4)ʵʳȻȡ豸;
                   (5)ȡ4ֽڵ;
                   (6)ʵʳȻȡ;
                   (7);
                   (8)ֵ
* Input          : *Device---ǰ豸
                   *pbuf-----ݻ
* Output         : None
* Return         : USB_OPERATE_SUCCESS---豸öٳɹ;
*                  USB_OPERATE_ERROR-----豸öʧ;
*******************************************************************************/
UINT8 USBHOST_EHCI_Enumerate( ATTACH_DEVICE_INFO *Device, UINT8 *pbuf )
{
    UINT8  status;
    UINT16 i, len;    

#ifdef  MY_DEBUG_PRINTF 
    printf( "USBHOST_Enumerate:..\n" );
#endif
    
    /* (1)ȡ豸 */
#ifdef  MY_DEBUG_PRINTF 
    printf( "USBHOST_GetDeviceDescr:...\n" );
#endif
    len = DEFAULT_USB_EP0_SIZE;
    status = USBHOST_EHCI_GetDeviceDescr( Device, pbuf, &len  );                /* ȡ豸 */
    if( status != USB_OPERATE_SUCCESS ) 
    {
#ifdef  MY_DEBUG_PRINTF 
        printf( "ERROR = %02X\n", (UINT16)status );
#endif
        return( USB_OPERATE_ERROR );                                            /* ֹ,ֱӷ */
    }

#ifdef  MY_DEBUG_PRINTF
    for( i = 0; i < len; i ++ ) 
    {
        printf( "%02X ", (UINT16)*( pbuf + i ) );
    }
    printf( "\n" );
#endif
    Delay_ms( 3 );

    /* (2)λUSB豸*/
    USBHOST_EHCI_BusReset( Device );

    /* ȴ豸 */
    for( i = 0; i < 10; i ++ )
    {
        Delay_ms( 50 );
        if( USBHOST_EHCI_Detect_Connect( Device ) == USB_INT_CONNECT )          /* 豸 */
        {
            break;
        }
    }
    
    /* (3)USBַ */
#ifdef  MY_DEBUG_PRINTF 
    printf( "USBHOST_SetAddress:...\n " );
#endif
    status = USBHOST_EHCI_SetAddress( Device, DEFAULT_USB_OP_ADDR );            /* USB豸ַ */
    if( status != USB_OPERATE_SUCCESS )
    {
#ifdef  MY_DEBUG_PRINTF
        printf( "ERROR = %02X\n", (UINT16)status );
#endif
        return( USB_OPERATE_ERROR );                                            /* ֹ,ֱӷ */
    }
    Delay_ms( 3 );

    /* (4)ʵʳȻȡ豸 */
#ifdef  MY_DEBUG_PRINTF 
    printf( "USBHOST_GetDeviceDescr:...\n" );
#endif
    len = 0x12;
    status = USBHOST_EHCI_GetDeviceDescr( Device, pbuf, &len  );                /* ȡ豸 */
    if( status != USB_OPERATE_SUCCESS ) 
    {
#ifdef  MY_DEBUG_PRINTF 
        printf( "ERROR = %02X\n", (UINT16)status );
#endif
        return( USB_OPERATE_ERROR );                                            /* ֹ,ֱӷ */
    }
#ifdef  MY_DEBUG_PRINTF
    for( i = 0; i < len; i ++ ) 
    {
        printf( "%02X ", (UINT16)*( pbuf + i ) );
    }
    printf( "\n" );
#endif
    Delay_ms( 3 );    
    
    /* (5)ȡ4ֽڵ */
    /* (6)ʵʳȻȡ */
#ifdef  MY_DEBUG_PRINTF
    printf( "USBHOST_GetConfigDescr:...\n " );
#endif
    status = USBHOST_EHCI_GetConfigDescr( Device, pbuf, &len );                 /* ȡ */
    if( status != USB_OPERATE_SUCCESS ) 
    {
#ifdef  MY_DEBUG_PRINTF
        printf( "ERROR = %02X\n", (UINT16)status );
#endif
        return( USB_OPERATE_ERROR );                                            /* ֹ,ֱӷ */
    }
#ifdef  MY_DEBUG_PRINTF
    for ( i = 0; i < ( (PUSB_CFG_DESCR)pbuf ) -> wTotalLengthL + ( (UINT16)( (PUSB_CFG_DESCR)pbuf ) -> wTotalLengthH << 8 ); i ++ ) 
    {   
        printf( "%02X ", (UINT16)*( pbuf + i ) );
    }
    printf( "\n" );
#endif
    Delay_ms( 3 );
    
    /* (7) */    
#ifdef  MY_DEBUG_PRINTF
    printf( "USBHOST_CofDescrAnalyse:...\n " );
#endif    
    status = USBHOST_CofDescrAnalyse( pbuf );                                   /*  */
    if( status != USB_OPERATE_SUCCESS )    
    {    
#ifdef  MY_DEBUG_PRINTF
        printf( "Current Device is Not USB Mass Storage Device\n" );
#endif
        return( USB_OPERATE_ERROR );                                            /* ֹ,ֱӷ */
    }
            
    /* (8)ֵ */    
#ifdef  MY_DEBUG_PRINTF
    printf( "USBHOST_SetConfig:...\n " );
#endif
    status = USBHOST_EHCI_SetConfig( Device, ( (PUSB_CFG_DESCR)pbuf ) -> bConfigurationValue ); /* USB豸 */
    if ( status != USB_OPERATE_SUCCESS ) 
    {
#ifdef  MY_DEBUG_PRINTF
        printf( "ERROR = %02X\n", (UINT16)status );
#endif
        return( USB_OPERATE_ERROR );                                            /* ֹ,ֱӷ */
    }
    Delay_ms( 3 );    
    return( USB_OPERATE_SUCCESS );
}

/*******************************************************************************
* Function Name  : USBHOST_QH_Link_Insert
* Description    : ǰqHDӵ
* Input          : CurrentQH---ǰҪӵȥQH
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_qHD_Link_Insert( qHD_Structure *CurrentqHD )
{
    UINT8  i, flag;
    UINT32 temp;
    qHD_Structure *FirstqHD;
    qHD_Structure *LastqHD;

    FirstqHD = (qHD_Structure*)gEHCI_QHD_BaseAddr;                              /* ָһqHD */

    /* ͨѯṹҵһqHD */    
    flag = 0x00;     
    LastqHD = (qHD_Structure*)gEHCI_QHD_BaseAddr;    
    for( i = 0; i < EHCI_QHD_MAX; i++ )                                            
    {
        temp = ( UINT32 )( LastqHD->bNextQHDPointer ) << 5;                     /* еǰqHDָһqHDʼַ */
        if( ( temp == gEHCI_QHD_BaseAddr ) || ( temp == 0 ) )                    
        {    
            flag = 0x01;
            break;
        }
        else
        {
            LastqHD = (qHD_Structure*)temp;
        }                
    }

    if( flag )
    {
        CurrentqHD->bNextQHDPointer = ( ( ( UINT32)FirstqHD ) >> 5 );           /* ǰqHDһqHD */        
        LastqHD->bNextQHDPointer = ( ( (UINT32)CurrentqHD ) >> 5 );             /* һqHDǰqHD */
    }
    else
    {
        return( USB_OPERATE_ERROR );            
    }
    return( USB_OPERATE_SUCCESS );    
}

/*******************************************************************************
* Function Name  : USBHOST_QH_Link_BackOut
* Description    : ǰQHժ
* Input          : CurrentQH---ǰҪӵȥQH
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_QH_Link_BackOut( qHD_Structure *CurrentQH )
{
    UINT8  i;
    UINT32 temp;
    UINT32 address;
    qHD_Structure *LastqHD;

    USBHOST_Asynchronous_Setting( USBHOST_OP_DISABLE );                         /* 첽 */
    Delay_ms( 3 );

    /* ͨѯṹҵָqHDһqHD */        
    LastqHD = (qHD_Structure*)gEHCI_QHD_BaseAddr;    
    address = ( UINT32 )CurrentQH;
    for( i = 0; i < EHCI_QHD_MAX; i++ )                                            
    {
        temp = ( UINT32 )( LastqHD->bNextQHDPointer ) << 5;                     /* еǰqHDָһqHDʼַ */
        if( temp == address )                    
        {        
            LastqHD->bNextQHDPointer = ( UINT32 )( CurrentQH->bNextQHDPointer );
            break;
        }
        else
        {
            LastqHD = (qHD_Structure*)temp;
        }                
    }
    USBHOST_Asynchronous_Setting( USBHOST_OP_ENABLE );                          /* ʹ첽 */
    Delay_ms( 3 );
    return( USB_OPERATE_SUCCESS );
}
      
/*******************************************************************************
* Function Name  : USBHOST_Release_QHD
* Description    : ͷŵǰQHD(ժQH¹صTDԼQH)
* Input          : 
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 USBHOST_Release_QHD( qHD_Structure *CurrentQH )
{
    UINT8  status;

    /* ǰQHQHժ */
    status = USBHOST_QH_Link_BackOut( CurrentQH );
    if( status )
    {
        return( status );
    }

    /* յǰQH¹صTDڴ */
    status = USBHOST_ReleaseStructure( EHCI_MEM_TYPE_QTD, ( UINT32 )( CurrentQH->bOverlay_NextqTD << 5 ) );
    if( status )
    {
        return( status );
    }

    /* յǰQHڴ */
    status = USBHOST_ReleaseStructure( EHCI_MEM_TYPE_QHD, ( UINT32 )CurrentQH );
    return( status );
}
