/********************************** (C) COPYRIGHT *******************************
* File Name          : UDISK.H
* Author             : WCH
* Version            : V1.20
* Date               : 2013/11/15
* Description        : SCSIЭUͷļ
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "CH563BAS.H"

#ifndef __UDISK_H__
#define __UDISK_H__

#ifdef __cplusplus
extern "C" {
#endif


/******************************************************************************/
#ifdef BIG_ENDIAN
#define USB_BO_CBW_SIG              0x55534243                                  /* CBWʶ־'USBC' */
#define USB_BO_CSW_SIG              0x55534253                                  /* ״̬CSWʶ־'USBS' */
#else
#define USB_BO_CBW_SIG              0x43425355                                  /* CBWʶ־'USBC' */
#define USB_BO_CSW_SIG              0x53425355                                  /* ״̬CSWʶ־'USBS' */
#endif

#define USB_BO_CBW_SIZE             0x1F                                        /* CBWܳ */
#define USB_BO_CSW_SIZE             0x0D                                        /* ״̬CSWܳ */
#define USB_BO_DATA_IN              0x80
#define USB_BO_DATA_OUT             0x00

/* USBʽĲ״̬ */
#define USB_INT_SUCCESS             0x14                                        /* USBߴɹ */
#define USB_INT_CONNECT             0x15                                        /* ⵽USB豸¼ */
#define USB_INT_DISCONNECT          0x16                                        /* ⵽USB豸Ͽ¼ */
#define USB_INT_BUF_OVER           0x17                                         /* USBƴ̫,  */
#define USB_INT_DISK_ERR           0x1F                                         /* USB洢ʧ */

typedef union _BULK_ONLY_CMD 
{
    struct 
    {
        UINT32 mCBW_Sig;
        UINT32 mCBW_Tag;
        UINT32 mCBW_DataLen;                                                    /* : ݴ䳤 */
        UINT8  mCBW_Flag;                                                       /* : ䷽ȱ־ */
        UINT8  mCBW_LUN;
        UINT8  mCBW_CB_Len;                                                     /* : ĳ,Чֵ116 */
        UINT8  mCBW_CB_Buf[16];                                                 /* : ,ûΪ16ֽ */
    } mCBW;                                                                     /* BulkOnlyЭ, CBWṹ */
    struct 
    {
        UINT32 mCSW_Sig;
        UINT32 mCSW_Tag;
        UINT32 mCSW_Residue;                                                    /* : ʣݳ */
        UINT8  mCSW_Status;                                                     /* : ִн״̬ */
    } mCSW;                                                                     /* BulkOnlyЭ״̬, CSWṹ */
} BULK_ONLY_CMD;

typedef struct _DiskInfo 
{ 
    ATTACH_DEVICE_INFO  Device;                                                    
    qHD_Structure *qHD_Bulk_In;                                                 /* ϴ˵EHCIؽṹָ붨 */
    qHD_Structure *qHD_Bulk_Out;                                                /* ´˵EHCIؽṹָ붨 */
    UINT8  MaxLun;                                                              /* ߼Ԫ */
    UINT8  CurLun;                                                              /* ̵ǰ߼Ԫ */
    UINT32 Capability;                                                          /*  */
    UINT32 PerSecSize;                                                          /* С */         
    UINT8  BulkInEp;                                                            /* USB洢豸IN˵ַ */
    UINT8  BulkOutEp;                                                           /* USB洢豸OUT˵ַ */
    UINT16 BulkInEpSize;                                                        /* USB洢豸IN˵С */    
    UINT16 BulkOutEpSize;                                                       /* USB洢豸OUT˵С */    
    UINT8  InterfNumber;                                                        /* USB洢豸Ľӿں */   
}DISK_INFO;                                                                     /* Ϣṹ,洢ǰU̱Ҫ */

/******************************************************************************/
/*  */
extern BULK_ONLY_CMD    mBOC;                                                    /* BulkOnlyṹ */                                                        

/******************************************************************************/
/*  */
extern UINT8 MS_CofDescrAnalyse( DISK_INFO *Diskinfo, UINT8 *pbuf );            /*  */                         
extern UINT8 MS_Bluk_QH_Allocate( DISK_INFO *Diskinfo );                        /* USBQHTD */
extern UINT8 MS_GetMaxLun_EX( DISK_INFO *Diskinfo );                            /* USBȡ߼Ԫ */
extern UINT8 MS_ResetErrorBOC_EX( DISK_INFO *Diskinfo );                        /* USBλU */    
extern UINT8 MS_ScsiCmd_Process_EX( DISK_INFO *Diskinfo, UINT8 *DataBuf );      /* ִлBulkOnlyЭ */
extern UINT8 MS_RequestSense_EX( DISK_INFO *Diskinfo, UINT8 *pbuf );            /* USB̴״̬ */
extern UINT8 MS_DiskInquiry_EX( DISK_INFO *Diskinfo, UINT8 *pbuf );             /* USBȡ */ 
extern UINT8 MS_DiskCapacity_EX( DISK_INFO *Diskinfo, UINT8 *pbuf );            /* USBȡ */
extern UINT8 MS_DiskTestReady_EX( DISK_INFO *Diskinfo, UINT8 *pbuf );           /* USBԴǷ */
extern UINT8 MS_Init_EX( DISK_INFO *Diskinfo, UINT8 *pbuf );                    /* USB洢豸ʼ */    
extern UINT8 MS_ReadSector_EX( DISK_INFO *Diskinfo, UINT32 StartLba, UINT32 SectCount, PUINT8 DataBuf );/* ΪλӴ̶ȡ */
extern UINT8 MS_WriteSector_EX( DISK_INFO *Diskinfo, UINT32 StartLba, UINT8 SectCount, PUINT8 DataBuf );/* Ϊλд */

#ifdef __cplusplus
}
#endif

#endif
